/*! For license information please see main.js.LICENSE.txt */
(()=>{var e={6010:(e,t,n)=>{const{InstanceBase:s,InstanceStatus:i,runEntrypoint:r,TCPHelper:o,combineRgb:a}=n(8049);r(class extends s{PSTATE_READY=0;PSTATE_MULTILINE=1;PSTATE_SINGLELINE=2;DTYPE_UNKNOWN=0;DTYPE_GENERAL="GENERAL";DTYPE_MX2="MX2";actions={};variables={};presets={};state={destinationConnectionList:[],selectedSource:"",selectedDestination:""};deviceType=this.DTYPE_UNKNOWN;inputs={};outputs={};CHOICES_INPUTS=[];CHOICES_OUTPUTS=[];CHOICES_PRESETS=[];constructor(e){super(e),this.instanceOptions.disableVariableValidation=!0}getConfigFields(){return[{type:"text",id:"info",width:12,label:"Information",value:"This module is for controlling Lightware equipment that supports LW3 protocol. So far only HDMI20_OPTC and MX2-8x8-HDMI20 have been tested. Please contact us if your LW3 compatible equipment is not supported"},{type:"textinput",id:"host",label:"Device IP",width:12,regex:this.REGEX_IP}]}async destroy(){void 0!==this.socket&&this.socket.destroy(),this.debug("destroy",this.id)}async init(e){this.config=e,this.updateStatus(i.Connecting),this.initTCP(),this.initVariables(),this.initFeedbacks(),this.initPresets()}initActions(){this.actions.xpt={name:"XP:Switch - Select video input for output",options:[{label:"Input",type:"dropdown",id:"input",choices:this.CHOICES_INPUTS,default:this.CHOICES_INPUTS[0]?.id||""},{label:"Output",type:"dropdown",id:"output",choices:this.CHOICES_OUTPUTS,default:this.CHOICES_OUTPUTS[0]?.id||""}],callback:e=>{let t=e.options;this[this.deviceType+"_XPT"](t)}},this.actions.preset={name:"Recall Preset",options:[{label:"Preset",type:"dropdown",id:"preset",choices:this.CHOICES_PRESETS,default:this.CHOICES_PRESETS[0]?.id||""}],callback:e=>{let t=e.options;this.deviceType===this.DTYPE_GENERAL?this.sendCommand("CALL /PRESETS/AVC:load("+t.preset.toString()+")",(e=>{this.log("info","Preset Load Result: "+e)})):this.deviceType===this.DTYPE_MX2&&this.sendCommand("CALL /MEDIA/PRESET/"+t.preset.toString()+":load()",(e=>{this.log("info","Preset Load Result: "+e)}))}},this.actions.selectSource={name:"Select source for take",options:[{label:"Source",type:"dropdown",id:"port",choices:this.CHOICES_INPUTS,default:this.CHOICES_INPUTS[0]?.id||""}],callback:e=>{this.state.selectedSource=e.options.port,this.checkFeedbacks("sourceSelected","route")}},this.actions.selectDestination={name:"Select destination for take",options:[{label:"Destination",type:"dropdown",id:"port",choices:this.CHOICES_OUTPUTS,default:this.CHOICES_OUTPUTS[0]?.id||""}],callback:e=>{this.state.selectedDestination=e.options.port,this.checkFeedbacks("destinationSelected","route")}},this.actions.takeSalvo={name:"Route selected ports",options:[],callback:()=>{this.state.selectedSource.match(/^I\d+$/)&&this.state.selectedDestination.match(/^O\d+$/)&&this[this.deviceType+"_XPT"]({input:this.state.selectedSource,output:this.state.selectedDestination})}},this.setActionDefinitions(this.actions)}initFeedbacks(){let e=this;const t={};t.route={type:"boolean",name:"Route",description:"Shows if an input is routed to an output",defaultStyle:{color:a(0,0,0),bgcolor:a(255,0,0)},options:[{type:"number",label:"Input",id:"input",tooltip:"0 = selected",default:1,min:0,max:512},{type:"number",label:"Output",id:"output",tooltip:"0 = selected",default:1,min:0,max:512}],callback:t=>{try{let n=t.options.output>0?t.options.output:e.state.selectedDestination.replace(/\D/g,""),s=t.options.input>0?"I"+t.options.input:e.state.selectedSource;return e.state.destinationConnectionList[n-1]===s}catch(e){return this.log("error","trying to read feedback status for a invalid input or output"),!1}}},t.sourceSelected={type:"boolean",name:"source selected",description:"Shows if an input is selected for routing",defaultStyle:{color:a(0,0,0),bgcolor:a(0,255,0)},options:[{type:"number",label:"Input",id:"port",default:1,min:1,max:512}],callback:t=>{try{return e.state.selectedSource==="I"+t.options.port}catch(e){return this.log("error","trying to read feedback status for a invalid input or output"),!1}}},t.destinationSelected={type:"boolean",name:"destination selected",description:"Shows if an output is selected for routing",defaultStyle:{color:a(0,0,0),bgcolor:a(0,255,0)},options:[{type:"number",label:"Output",id:"port",default:1,min:1,max:512}],callback:t=>{try{return e.state.selectedDestination==="O"+t.options.port}catch(e){return this.log("error","trying to read feedback status for a invalid input or output"),!1}}},this.setFeedbackDefinitions(t)}initVariables(){this.setVariableDefinitions(Object.keys(this.variables).map((e=>({variableId:e,name:this.variables[e]}))))}createSelectPreset(e){let t={port:e,num:parseInt(e.replace(/\D/g,"")),shorttype:e.charAt(0)};t.type={I:"Input",O:"Output"}[t.shorttype]||"",t.action={I:"selectSource",O:"selectDestination"}[t.shorttype]||"",t.option={I:"source",O:"destination"}[t.shorttype]||"",this.presets["selection"+e]={name:"Select "+t.type+" "+t.num,type:"button",category:"Select "+t.type,style:{text:`${t.type}\\n$(${this.label}:name_${t.port})`,size:"auto",color:a(255,255,255),bgcolor:a(30,30,30)},steps:[{down:[{actionId:t.action,options:{port:t.port}}],up:[]}],feedbacks:[{feedbackId:t.option+"Selected",options:{port:t.num},style:{color:a(0,255,0),bgcolor:a(0,70,0)}},{feedbackId:"route",options:{input:"I"===t.shorttype?t.num:0,output:"O"===t.shorttype?t.num:0},style:{bgcolor:a(150,0,0)}}]},"I"===t.shorttype&&(this.presets["selectAndTake"+e]={name:"Select Input "+t.num+" and Take",type:"button",category:"Select Input and Take",style:{text:`Input\\n$(${this.label}:name_${t.port})`,size:"auto",color:a(255,255,255),bgcolor:a(60,0,0)},steps:[{down:[{actionId:t.action,options:{port:t.port}},{actionId:"takeSalvo"}],up:[]}],feedbacks:[{feedbackId:t.option+"Selected",options:{port:t.num},style:{color:a(0,255,0),bgcolor:a(0,70,0)}},{feedbackId:"route",options:{input:"I"===t.shorttype?t.num:0,output:"O"===t.shorttype?t.num:0},style:{bgcolor:a(150,0,0)}}]})}initPresets(){this.presets.take={type:"button",name:"Take Selected",type:"button",category:"Misc",style:{text:"Take selected",size:"auto",color:a(0,0,0),bgcolor:a(180,30,30)},steps:[{down:[{actionId:"takeSalvo"}],up:[]}],feedbacks:[]},this.setPresetDefinitions(this.presets)}initDevice(){this.sendCommand("GET /.ProductName",(e=>{e=e.replace(/^.+ProductName=/,""),this.log("info","Connected to an "+e),e.match(/OPTC-[TR]X|MMX\d+x\d+|UMX-TPS-[TR]X100/)||e.match(/(^MEX-)|HDMI-TPS-[TR]X200|HDMI-3D-OPT|SW4-OPT|MODEX/)?(this.deviceType=this.DTYPE_GENERAL,this.initGENERAL()):e.match(/^MX2/)?(this.deviceType=this.DTYPE_MX2,this.initMX2()):(this.log("warning","Unknown LW3 device, use with caution"),this.deviceType=this.DTYPE_GENERAL,this.initMX2())})),this.sendCommand("GET /MEDIA/VIDEO/XP.*",(e=>{let t=e.split(/\r\n/);if(t.find((e=>e.match(/XP:lockDestination/)))){let e=parseInt(t.find((e=>e.match(/XP\.DestinationPortCount=\d+/))).match(/XP\.DestinationPortCount=(\d+)$/)[1]);this.actions.outputLock={name:"Output Lock",options:[{id:"output",type:"number",label:"Output",min:1,max:e,default:1},{id:"cmd",type:"dropdown",label:"Lock",choices:[{id:"lockDestination",label:"Lock Output"},{id:"unlockDestination",label:"Unlock Output"}],default:"unlockDestination"}],callback:e=>{this.sendCommand(`CALL /MEDIA/VIDEO/XP:${e.options.cmd}(O${e.options.output})`,(e=>{this.log("info","Output Lock Result: "+e)}))}}}})),this.sendCommand("GET /MEDIA/USB/USBSWITCH.*",(e=>{let t=e.split(/\r\n/);if(t.find((e=>e.match(/Enable\d+=/)))){let e=t.filter((e=>e.match(/Enable\d+=/))).map((e=>e.match(/Enable(\d+)=/)[1]));this.actions.switchUSB={name:"Switch USB Host",options:[{id:"host",type:"dropdown",label:"Host",choices:[{id:"0",label:"Off"},...e.map((e=>({id:e,label:"PC "+e})))],default:"0"}],callback:e=>{this.sendCommand("SET /MEDIA/USB/USBSWITCH.HostSelect="+e.options.host.toString(),(e=>{this.log("info","Switch USB Result: "+e)}))}}}})),this.sendCommand("GET /CTRL/MACROS.*",(e=>{const t="No macros available";let n=e.split(/\r\n/);if(n.find((e=>e.match(/MACROS.\d+=/)))){let e=[t];n.find((e=>e.match(/MACROS.\d+=\d+;.+;\w+$/)))&&(e=n.filter((e=>e.match(/MACROS.\d+=\d+;.+;\w+$/))).map((e=>e.match(/MACROS.\d+=\d+;.+;(\w+)$/)[1]))),this.actions.runMacro={name:"Run Macro",options:[{id:"macro",type:"dropdown",label:"Macro",choices:e.map((e=>({id:e,label:e}))),default:e[0]}],callback:e=>{e.options.macro!==t&&this.sendCommand("CALL /CTRL/MACROS:run("+e.options.macro+")",(e=>{this.log("info","Run Macro Result: "+e)}))}}}}))}initGENERAL(){this.sendCommand("OPEN /MEDIA/VIDEO/*.Text",(e=>{})),this.sendCommand("GET /MEDIA/VIDEO/*.Text",(e=>{let t=e.split(/\r\n/);this.CHOICES_INPUTS.length=0,this.CHOICES_OUTPUTS.length=0;for(let e in t){let n=t[e].match(/\/MEDIA\/VIDEO\/(.+?)\.Text=(.+)$/);if(n){let e=n[1],t=n[2];e.match(/I\d+/)&&(this.inputs[e]=t,this.CHOICES_INPUTS.push({label:t,id:e}),this.variables["name_"+e]="Name of input "+e.slice(1),this.setVariableValues({["name_"+e]:t})),e.match(/O\d+/)&&(this.outputs[e]=t,this.CHOICES_OUTPUTS.push({label:t,id:e}),this.variables["name_"+e]="Name of output "+e.slice(1),this.setVariableValues({["name_"+e]:t}),this.variables["source_"+e]="Source at output "+e.slice(1),this.variables["sourcename_"+e]="Name of source at output "+e.slice(1)),this.createSelectPreset(e)}}this.initActions(),this.initVariables(),this.setPresetDefinitions(this.presets)})),this.sendCommand("GET /PRESETS/AVC/*.Name",(e=>{let t=e.split(/\r\n/);this.log("debug",t),this.CHOICES_PRESETS=[...t.filter((e=>void 0!==e.match(/\/PRESETS\/AVC\/(.+?)\.Name=(.+)$/))).map((e=>{let[t,n,s]=e.match(/\/PRESETS\/AVC\/(.+?)\.Name=(.+)$/);return{id:n,label:s}}))],this.initActions()})),this.sendCommand("OPEN /MEDIA/VIDEO/XP",(e=>{})),this.sendCommand("GET /MEDIA/VIDEO/XP.DestinationConnectionList",(e=>{e.split(/\r\n/).forEach((e=>this.parseResponse(e))),this.checkFeedbacks("route")}))}initMX2(){this.sendCommand("GET /MEDIA/NAMES/VIDEO.*",(e=>{let t=e.split(/\r\n/);this.log("debug",t),this.CHOICES_INPUTS.length=0,this.CHOICES_OUTPUTS.length=0;for(let e in t){let n=t[e].match(/\/MEDIA\/NAMES\/VIDEO\.(.+?)=\d+;(.+)$/);if(n){let e=n[1],t=n[2];e.match(/I\d+/)&&(this.inputs[e]=t,this.CHOICES_INPUTS.push({label:t,id:e}),this.variables["name_"+e]="Name of input "+e.slice(1),this.setVariableValues({["name_"+e]:t})),e.match(/O\d+/)&&(this.outputs[e]=t,this.CHOICES_OUTPUTS.push({label:t,id:e}),this.variables["name_"+e]="Name of output "+e.slice(1),this.setVariableValues({["name_"+e]:t}),this.variables["source_"+e]="Source at output "+e.slice(1),this.variables["sourcename_"+e]="Name of source at output "+e.slice(1)),this.createSelectPreset(e)}}this.initActions(),this.initVariables(),this.setPresetDefinitions(this.presets)})),this.CHOICES_PRESETS=[],this.sendCommand("GET /PRESETS/AVC/*.Name",(e=>{if("string"==typeof e){if(!e.startsWith("nE")){let t=e.split(/\r\n/).filter((e=>Array.isArray(e.match(/\/PRESETS\/AVC\/(.+?)\.Name=(.+)$/)))).map((e=>{let[t,n,s]=e.match(/\/PRESETS\/AVC\/(.+?)\.Name=(.+)$/);return{id:n,label:s}}));if(t.length)return this.CHOICES_PRESETS.push(...t),void this.initActions();this.log("debug",`Response to 'GET /PRESETS/AVC/*.Name' didn't have any presets. Response was:${e}\nNow trying with /MEDIA/PRESET`)}this.sendCommand("GET /MEDIA/PRESET",(e=>{if("string"!=typeof e||e.startsWith("nE"))return void this.log("error",`Got invalid response to 'GET /MEDIA/PRESET'. Response was:${e}`);let t=e.split(/\r\n/).filter((e=>Array.isArray(e.match(/\/MEDIA\/PRESET\/([A-Za-z0-9\-_]{1,16})/)))).map((e=>{let[t,n]=e.match(/MEDIA\/PRESET\/([A-Za-z0-9\-_]{1,16})/);return{id:n,label:n}}));t.length?(this.CHOICES_PRESETS.push(...t),this.log("info",`'GET /MEDIA/PRESET' found ${t.length} presets with the names: ${t.map((e=>e.label)).join(", ")}`),this.initActions()):this.log("info",`Response to 'GET /MEDIA/PRESET' didn't have any presets. Response was:${e}`)}))}else this.log("error",`Got invalid response to 'GET /PRESETS/AVC/*.Name'. Response was:${e}`)})),this.sendCommand("OPEN /MEDIA/XP/VIDEO",(e=>{})),this.sendCommand("GET /MEDIA/XP/VIDEO.DestinationConnectionList",(e=>{e.split(/\r\n/).forEach((e=>this.parseResponse(e))),this.checkFeedbacks("route")}))}initTCP(){let e=this,t="";this.pstate=this.PSTATE_READY,this.pid="",this.multiline="",this.multilineError="",this.responseHandlers={},this.sendId=0,void 0!==this.socket&&(this.socket.destroy(),delete this.socket),this.log("info",this.config.host),this.config.host&&(this.socket=new o(this.config.host,6107),this.socket.on("status_change",((t,n)=>{e.updateStatus(t,n)})),this.socket.on("connect",(()=>{e.initDevice()})),this.socket.on("error",(t=>{e.log("error","Network error: "+t.message)})),this.socket.on("data",(e=>{let n=0,s="",i=0;for(t+=e;-1!==(n=t.indexOf("\r\n",i));)s=t.substring(i,n),i=n+2,this.socket.emit("receiveline",s.toString());t=t.slice(i)})),this.socket.on("receiveline",(t=>{e.pstate===e.PSTATE_READY&&t.startsWith("{")?(e.pstate=e.PSTATE_MULTILINE,e.multiline="",e.multilineError="",e.pid=t.slice(1)):e.pstate===e.PSTATE_MULTILINE?"}"===t?(void 0!==e.responseHandlers[this.pid]&&(""!=e.multilineError.trim()&&e.log("error","Error from device: "+e.multilineError),e.responseHandlers[e.pid](e.multiline.trim()),delete e.responseHandlers[e.pid]),e.pstate=e.PSTATE_READY):"E"==t.slice(1,1)?e.multilineError+=t+"\r\n":e.multiline+=t+"\r\n":this.parseResponse(t)})))}GENERAL_XPT(e){this.sendCommand("CALL /MEDIA/VIDEO/XP:switch("+e.input+":"+e.output+")",(e=>{this.log("info","XPT Result: "+e)}))}MX2_XPT(e){this.sendCommand("CALL /MEDIA/XP/VIDEO:switch("+e.input+":"+e.output+")",(e=>{this.log("info","XPT Result: "+e)}))}sendCommand(e,t){this.sendId>9998?this.sendId=0:this.sendId++;let n=this.sendId.toString().padStart(4,"0");void 0!==this.socket?(this.socket.send(n+"#"+e+"\r\n"),this.responseHandlers[n]=t):this.log("debug","Socket not connected :(")}parseResponse(e){console.log("parsing",e);let t=!1;[{pat:"^(pr|CHG).+\\.DestinationConnection(List|Status)=",fun:e=>{console.log("received",e);let t=e.replace(/^.+DestinationConnection(List|Status)=/,"").split(";");Array.isArray(t)?t[0].match(/^I\d+$/)?(""===t[t.length-1]&&t.pop(),this.state.destinationConnectionList=t,this.setVariableValues(Object.fromEntries(t.map(((e,t)=>["source_O"+(t+1),e])))),this.setVariableValues(Object.fromEntries(t.map(((e,t)=>["sourcename_O"+(t+1),this.inputs[e]]))))):this.log("error",`received malformed connection status: ${e}`):this.log("error",`received very malformed connection status: ${e}`)},fbk:"route"},{pat:"^(pr|CHG).+\\/MEDIA\\/VIDEO\\/(I|O)\\d+\\.Text=",fun:e=>{let[t,n]=e.replace(/^.+\/MEDIA\/VIDEO\//,"").split(".Text=");return t.match(/^I\d+$/)&&(this.inputs[t]=n,this.setVariableValues({["name_"+t]:n}),this.state.destinationConnectionList.map(((e,t)=>({in:e,out:"O"+(t+1)}))).filter((e=>e.in===t)).forEach((e=>{this.setVariableValues({["sourcename_"+e.out]:n})}))),t.match(/^O\d+$/)&&(this.outputs[t]=n,this.setVariableValues({["name_"+t]:n})),!0}}].filter((t=>{const n=new RegExp(t.pat);return!!e.match(n)})).forEach((n=>{n.fun&&"function"==typeof n.fun&&!0===n.fun(e)&&(t=!0),n.fbk&&"string"==typeof n.fbk&&this.checkFeedbacks(n.fbk)})),t&&(this.initActions(),this.initFeedbacks())}updateConfig(e){let t=!1;this.config.host!=e.host&&(t=!0),this.config=e,!0!==t&&void 0!==this.socket||this.initTCP()}},[])},7056:(e,t,n)=>{"use strict";const s=n(4063);s.code='require("ajv/dist/runtime/equal").default',t.Z=s},1460:(e,t,n)=>{"use strict";n.r(t),n.d(t,{__assign:()=>r,__asyncDelegator:()=>w,__asyncGenerator:()=>k,__asyncValues:()=>I,__await:()=>T,__awaiter:()=>f,__classPrivateFieldGet:()=>D,__classPrivateFieldIn:()=>A,__classPrivateFieldSet:()=>N,__createBinding:()=>g,__decorate:()=>a,__esDecorate:()=>u,__exportStar:()=>m,__extends:()=>i,__generator:()=>_,__importDefault:()=>R,__importStar:()=>O,__makeTemplateObject:()=>x,__metadata:()=>h,__param:()=>c,__propKey:()=>d,__read:()=>b,__rest:()=>o,__runInitializers:()=>l,__setFunctionName:()=>p,__spread:()=>v,__spreadArray:()=>S,__spreadArrays:()=>E,__values:()=>y});var s=function(e,t){return s=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(e,t){e.__proto__=t}||function(e,t){for(var n in t)Object.prototype.hasOwnProperty.call(t,n)&&(e[n]=t[n])},s(e,t)};function i(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Class extends value "+String(t)+" is not a constructor or null");function n(){this.constructor=e}s(e,t),e.prototype=null===t?Object.create(t):(n.prototype=t.prototype,new n)}var r=function(){return r=Object.assign||function(e){for(var t,n=1,s=arguments.length;n<s;n++)for(var i in t=arguments[n])Object.prototype.hasOwnProperty.call(t,i)&&(e[i]=t[i]);return e},r.apply(this,arguments)};function o(e,t){var n={};for(var s in e)Object.prototype.hasOwnProperty.call(e,s)&&t.indexOf(s)<0&&(n[s]=e[s]);if(null!=e&&"function"==typeof Object.getOwnPropertySymbols){var i=0;for(s=Object.getOwnPropertySymbols(e);i<s.length;i++)t.indexOf(s[i])<0&&Object.prototype.propertyIsEnumerable.call(e,s[i])&&(n[s[i]]=e[s[i]])}return n}function a(e,t,n,s){var i,r=arguments.length,o=r<3?t:null===s?s=Object.getOwnPropertyDescriptor(t,n):s;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)o=Reflect.decorate(e,t,n,s);else for(var a=e.length-1;a>=0;a--)(i=e[a])&&(o=(r<3?i(o):r>3?i(t,n,o):i(t,n))||o);return r>3&&o&&Object.defineProperty(t,n,o),o}function c(e,t){return function(n,s){t(n,s,e)}}function u(e,t,n,s,i,r){function o(e){if(void 0!==e&&"function"!=typeof e)throw new TypeError("Function expected");return e}for(var a,c=s.kind,u="getter"===c?"get":"setter"===c?"set":"value",l=!t&&e?s.static?e:e.prototype:null,d=t||(l?Object.getOwnPropertyDescriptor(l,s.name):{}),p=!1,h=n.length-1;h>=0;h--){var f={};for(var _ in s)f[_]="access"===_?{}:s[_];for(var _ in s.access)f.access[_]=s.access[_];f.addInitializer=function(e){if(p)throw new TypeError("Cannot add initializers after decoration has completed");r.push(o(e||null))};var g=(0,n[h])("accessor"===c?{get:d.get,set:d.set}:d[u],f);if("accessor"===c){if(void 0===g)continue;if(null===g||"object"!=typeof g)throw new TypeError("Object expected");(a=o(g.get))&&(d.get=a),(a=o(g.set))&&(d.set=a),(a=o(g.init))&&i.push(a)}else(a=o(g))&&("field"===c?i.push(a):d[u]=a)}l&&Object.defineProperty(l,s.name,d),p=!0}function l(e,t,n){for(var s=arguments.length>2,i=0;i<t.length;i++)n=s?t[i].call(e,n):t[i].call(e);return s?n:void 0}function d(e){return"symbol"==typeof e?e:"".concat(e)}function p(e,t,n){return"symbol"==typeof t&&(t=t.description?"[".concat(t.description,"]"):""),Object.defineProperty(e,"name",{configurable:!0,value:n?"".concat(n," ",t):t})}function h(e,t){if("object"==typeof Reflect&&"function"==typeof Reflect.metadata)return Reflect.metadata(e,t)}function f(e,t,n,s){return new(n||(n=Promise))((function(i,r){function o(e){try{c(s.next(e))}catch(e){r(e)}}function a(e){try{c(s.throw(e))}catch(e){r(e)}}function c(e){var t;e.done?i(e.value):(t=e.value,t instanceof n?t:new n((function(e){e(t)}))).then(o,a)}c((s=s.apply(e,t||[])).next())}))}function _(e,t){var n,s,i,r,o={label:0,sent:function(){if(1&i[0])throw i[1];return i[1]},trys:[],ops:[]};return r={next:a(0),throw:a(1),return:a(2)},"function"==typeof Symbol&&(r[Symbol.iterator]=function(){return this}),r;function a(a){return function(c){return function(a){if(n)throw new TypeError("Generator is already executing.");for(;r&&(r=0,a[0]&&(o=0)),o;)try{if(n=1,s&&(i=2&a[0]?s.return:a[0]?s.throw||((i=s.return)&&i.call(s),0):s.next)&&!(i=i.call(s,a[1])).done)return i;switch(s=0,i&&(a=[2&a[0],i.value]),a[0]){case 0:case 1:i=a;break;case 4:return o.label++,{value:a[1],done:!1};case 5:o.label++,s=a[1],a=[0];continue;case 7:a=o.ops.pop(),o.trys.pop();continue;default:if(!((i=(i=o.trys).length>0&&i[i.length-1])||6!==a[0]&&2!==a[0])){o=0;continue}if(3===a[0]&&(!i||a[1]>i[0]&&a[1]<i[3])){o.label=a[1];break}if(6===a[0]&&o.label<i[1]){o.label=i[1],i=a;break}if(i&&o.label<i[2]){o.label=i[2],o.ops.push(a);break}i[2]&&o.ops.pop(),o.trys.pop();continue}a=t.call(e,o)}catch(e){a=[6,e],s=0}finally{n=i=0}if(5&a[0])throw a[1];return{value:a[0]?a[1]:void 0,done:!0}}([a,c])}}}var g=Object.create?function(e,t,n,s){void 0===s&&(s=n);var i=Object.getOwnPropertyDescriptor(t,n);i&&!("get"in i?!t.__esModule:i.writable||i.configurable)||(i={enumerable:!0,get:function(){return t[n]}}),Object.defineProperty(e,s,i)}:function(e,t,n,s){void 0===s&&(s=n),e[s]=t[n]};function m(e,t){for(var n in e)"default"===n||Object.prototype.hasOwnProperty.call(t,n)||g(t,e,n)}function y(e){var t="function"==typeof Symbol&&Symbol.iterator,n=t&&e[t],s=0;if(n)return n.call(e);if(e&&"number"==typeof e.length)return{next:function(){return e&&s>=e.length&&(e=void 0),{value:e&&e[s++],done:!e}}};throw new TypeError(t?"Object is not iterable.":"Symbol.iterator is not defined.")}function b(e,t){var n="function"==typeof Symbol&&e[Symbol.iterator];if(!n)return e;var s,i,r=n.call(e),o=[];try{for(;(void 0===t||t-- >0)&&!(s=r.next()).done;)o.push(s.value)}catch(e){i={error:e}}finally{try{s&&!s.done&&(n=r.return)&&n.call(r)}finally{if(i)throw i.error}}return o}function v(){for(var e=[],t=0;t<arguments.length;t++)e=e.concat(b(arguments[t]));return e}function E(){for(var e=0,t=0,n=arguments.length;t<n;t++)e+=arguments[t].length;var s=Array(e),i=0;for(t=0;t<n;t++)for(var r=arguments[t],o=0,a=r.length;o<a;o++,i++)s[i]=r[o];return s}function S(e,t,n){if(n||2===arguments.length)for(var s,i=0,r=t.length;i<r;i++)!s&&i in t||(s||(s=Array.prototype.slice.call(t,0,i)),s[i]=t[i]);return e.concat(s||Array.prototype.slice.call(t))}function T(e){return this instanceof T?(this.v=e,this):new T(e)}function k(e,t,n){if(!Symbol.asyncIterator)throw new TypeError("Symbol.asyncIterator is not defined.");var s,i=n.apply(e,t||[]),r=[];return s={},o("next"),o("throw"),o("return"),s[Symbol.asyncIterator]=function(){return this},s;function o(e){i[e]&&(s[e]=function(t){return new Promise((function(n,s){r.push([e,t,n,s])>1||a(e,t)}))})}function a(e,t){try{(n=i[e](t)).value instanceof T?Promise.resolve(n.value.v).then(c,u):l(r[0][2],n)}catch(e){l(r[0][3],e)}var n}function c(e){a("next",e)}function u(e){a("throw",e)}function l(e,t){e(t),r.shift(),r.length&&a(r[0][0],r[0][1])}}function w(e){var t,n;return t={},s("next"),s("throw",(function(e){throw e})),s("return"),t[Symbol.iterator]=function(){return this},t;function s(s,i){t[s]=e[s]?function(t){return(n=!n)?{value:T(e[s](t)),done:!1}:i?i(t):t}:i}}function I(e){if(!Symbol.asyncIterator)throw new TypeError("Symbol.asyncIterator is not defined.");var t,n=e[Symbol.asyncIterator];return n?n.call(e):(e=y(e),t={},s("next"),s("throw"),s("return"),t[Symbol.asyncIterator]=function(){return this},t);function s(n){t[n]=e[n]&&function(t){return new Promise((function(s,i){!function(e,t,n,s){Promise.resolve(s).then((function(t){e({value:t,done:n})}),t)}(s,i,(t=e[n](t)).done,t.value)}))}}}function x(e,t){return Object.defineProperty?Object.defineProperty(e,"raw",{value:t}):e.raw=t,e}var C=Object.create?function(e,t){Object.defineProperty(e,"default",{enumerable:!0,value:t})}:function(e,t){e.default=t};function O(e){if(e&&e.__esModule)return e;var t={};if(null!=e)for(var n in e)"default"!==n&&Object.prototype.hasOwnProperty.call(e,n)&&g(t,e,n);return C(t,e),t}function R(e){return e&&e.__esModule?e:{default:e}}function D(e,t,n,s){if("a"===n&&!s)throw new TypeError("Private accessor was defined without a getter");if("function"==typeof t?e!==t||!s:!t.has(e))throw new TypeError("Cannot read private member from an object whose class did not declare it");return"m"===n?s:"a"===n?s.call(e):s?s.value:t.get(e)}function N(e,t,n,s,i){if("m"===s)throw new TypeError("Private method is not writable");if("a"===s&&!i)throw new TypeError("Private accessor was defined without a setter");if("function"==typeof t?e!==t||!i:!t.has(e))throw new TypeError("Cannot write private member to an object whose class did not declare it");return"a"===s?i.call(e,n):i?i.value=n:t.set(e,n),n}function A(e,t){if(null===t||"object"!=typeof t&&"function"!=typeof t)throw new TypeError("Cannot use 'in' operator on non-object");return"function"==typeof e?t===e:e.has(t)}},758:(e,t,n)=>{"use strict";n.d(t,{r:()=>o});var s=n(5659),i=n(6890),r=n(2176);function o(){(0,i.T)(),(0,r.KV)()&&function(){const t=(0,s.cu)();if(!t.__SENTRY__)return;const n={mongodb:()=>new((0,r.l$)(e,"./node/integrations/mongo").Mongo),mongoose:()=>new((0,r.l$)(e,"./node/integrations/mongo").Mongo),mysql:()=>new((0,r.l$)(e,"./node/integrations/mysql").Mysql),pg:()=>new((0,r.l$)(e,"./node/integrations/postgres").Postgres)},i=Object.keys(n).filter((e=>!!(0,r.$y)(e))).map((e=>{try{return n[e]()}catch(e){return}})).filter((e=>e));i.length>0&&(t.__SENTRY__.integrations=[...t.__SENTRY__.integrations||[],...i])}()}e=n.hmd(e)},2716:(e,t,n)=>{"use strict";n.d(t,{_:()=>l});var s=n(4307),i=n(2176),r=n(2343),o=n(535),a=n(2844),c=n(7597),u=n(7990);class l{static __initStatic(){this.id="Apollo"}__init(){this.name=l.id}constructor(e={useNestjs:!1}){l.prototype.__init.call(this),this._useNest=!!e.useNestjs}loadDependency(){return this._useNest?this._module=this._module||(0,i.$y)("@nestjs/graphql"):this._module=this._module||(0,i.$y)("apollo-server-core"),this._module}setupOnce(e,t){if((0,u.K)(t))("undefined"==typeof __SENTRY_DEBUG__||__SENTRY_DEBUG__)&&r.kg.log("Apollo Integration is skipped because of instrumenter configuration.");else if(this._useNest){const e=this.loadDependency();if(!e)return void(("undefined"==typeof __SENTRY_DEBUG__||__SENTRY_DEBUG__)&&r.kg.error("Apollo-NestJS Integration was unable to require @nestjs/graphql package."));(0,o.hl)(e.GraphQLFactory.prototype,"mergeWithSchema",(function(e){return function(...n){return(0,o.hl)(this.resolversExplorerService,"explore",(function(e){return function(){return d((0,a.lE)(e.call(this)),t)}})),e.call(this,...n)}}))}else{const e=this.loadDependency();if(!e)return void(("undefined"==typeof __SENTRY_DEBUG__||__SENTRY_DEBUG__)&&r.kg.error("Apollo Integration was unable to require apollo-server-core package."));(0,o.hl)(e.ApolloServerBase.prototype,"constructSchema",(function(e){return function(){if(!this.config.resolvers)return("undefined"==typeof __SENTRY_DEBUG__||__SENTRY_DEBUG__)&&(this.config.schema?(r.kg.warn("Apollo integration is not able to trace `ApolloServer` instances constructed via `schema` property.If you are using NestJS with Apollo, please use `Sentry.Integrations.Apollo({ useNestjs: true })` instead."),r.kg.warn()):this.config.modules&&r.kg.warn("Apollo integration is not able to trace `ApolloServer` instances constructed via `modules` property."),r.kg.error("Skipping tracing as no resolvers found on the `ApolloServer` instance.")),e.call(this);const n=(0,a.lE)(this.config.resolvers);return this.config.resolvers=d(n,t),e.call(this)}}))}}}function d(e,t){return e.map((e=>(Object.keys(e).forEach((n=>{Object.keys(e[n]).forEach((i=>{"function"==typeof e[n][i]&&function(e,t,n,i){(0,o.hl)(e[t],n,(function(e){return function(...r){const o=i().getScope(),a=(0,s.x)([o,"optionalAccess",e=>e.getSpan,"call",e=>e()]),u=(0,s.x)([a,"optionalAccess",e=>e.startChild,"call",e=>e({description:`${t}.${n}`,op:"graphql.resolve"})]),l=e.call(this,...r);return(0,c.J8)(l)?l.then((e=>((0,s.x)([u,"optionalAccess",e=>e.finish,"call",e=>e()]),e))):((0,s.x)([u,"optionalAccess",e=>e.finish,"call",e=>e()]),l)}}))}(e,n,i,t)}))})),e)))}l.__initStatic()},8737:(e,t,n)=>{"use strict";n.d(t,{N:()=>u});var s=n(4307),i=n(2343),r=n(6956),o=n(442),a=n(7597),c=n(7990);class u{static __initStatic(){this.id="Express"}__init(){this.name=u.id}constructor(e={}){u.prototype.__init.call(this),this._router=e.router||e.app,this._methods=(Array.isArray(e.methods)?e.methods:[]).concat("use")}setupOnce(e,t){this._router?(0,c.K)(t)?("undefined"==typeof __SENTRY_DEBUG__||__SENTRY_DEBUG__)&&i.kg.log("Express Integration is skipped because of instrumenter configuration."):(function(e,t=[]){t.forEach((t=>function(e,t){const n=e[t];return e[t]=function(...e){return n.call(this,...function(e,t){return e.map((e=>"function"==typeof e?l(e,t):Array.isArray(e)?e.map((e=>"function"==typeof e?l(e,t):e)):e))}(e,t))},e}(e,t)))}(this._router,this._methods),function(e){const t="settings"in e;t&&void 0===e._router&&e.lazyrouter&&e.lazyrouter();const n=t?e._router:e;if(!n)return("undefined"==typeof __SENTRY_DEBUG__||__SENTRY_DEBUG__)&&i.kg.debug("Cannot instrument router for URL Parameterization (did not find a valid router)."),void(("undefined"==typeof __SENTRY_DEBUG__||__SENTRY_DEBUG__)&&i.kg.debug("Routing instrumentation is currently only supported in Express 4."));const c=Object.getPrototypeOf(n),u=c.process_params;c.process_params=function(e,t,n,i,c){n._reconstructedRoute||(n._reconstructedRoute="");const{layerRoutePath:l,isRegex:d,isArray:p,numExtraSegments:h}=function(e){const t=(0,s.x)([e,"access",e=>e.route,"optionalAccess",e=>e.path]),n=(0,a.Kj)(t),i=Array.isArray(t);if(!t)return{isRegex:n,isArray:i,numExtraSegments:0};const o=i?Math.max(t.reduce(((e,t)=>e+(0,r.$A)(t.toString())),0)-(0,r.$A)(e.path||""),0):0,c=function(e,t){return e?t.map((e=>e.toString())).join(","):t&&t.toString()}(i,t);return{layerRoutePath:c,isRegex:n,isArray:i,numExtraSegments:o}}(e);(l||d||p)&&(n._hasParameters=!0);const f=(l||e.path||"").split("/").filter((e=>e.length>0&&(d||p||!e.includes("*")))).join("/");if(f&&f.length>0&&(n._reconstructedRoute+=`/${f}${d?"/":""}`),(0,r.$A)(n.originalUrl||"")+h===(0,r.$A)(n._reconstructedRoute)){n._hasParameters||n._reconstructedRoute!==n.originalUrl&&(n._reconstructedRoute=n.originalUrl);const e=i.__sentry_transaction;if(e&&"custom"!==e.metadata.source){const t=n._reconstructedRoute||"/";e.setName(...(0,o.oA)(n,{path:!0,method:!0,customRoute:t}))}}return u.call(this,e,t,n,i,c)}}(this._router)):("undefined"==typeof __SENTRY_DEBUG__||__SENTRY_DEBUG__)&&i.kg.error("ExpressIntegration is missing an Express instance")}}function l(e,t){const n=e.length;switch(n){case 2:return function(n,s){const i=s.__sentry_transaction;if(i){const n=i.startChild({description:e.name,op:`middleware.express.${t}`});s.once("finish",(()=>{n.finish()}))}return e.call(this,n,s)};case 3:return function(n,i,r){const o=i.__sentry_transaction,a=(0,s.x)([o,"optionalAccess",e=>e.startChild,"call",n=>n({description:e.name,op:`middleware.express.${t}`})]);e.call(this,n,i,(function(...e){(0,s.x)([a,"optionalAccess",e=>e.finish,"call",e=>e()]),r.call(this,...e)}))};case 4:return function(n,i,r,o){const a=r.__sentry_transaction,c=(0,s.x)([a,"optionalAccess",e=>e.startChild,"call",n=>n({description:e.name,op:`middleware.express.${t}`})]);e.call(this,n,i,r,(function(...e){(0,s.x)([c,"optionalAccess",e=>e.finish,"call",e=>e()]),o.call(this,...e)}))};default:throw new Error(`Express middleware takes 2-4 arguments. Got: ${n}`)}}u.__initStatic()},1791:(e,t,n)=>{"use strict";n.d(t,{k:()=>u});var s=n(4307),i=n(2176),r=n(2343),o=n(535),a=n(7597),c=n(7990);class u{constructor(){u.prototype.__init.call(this)}static __initStatic(){this.id="GraphQL"}__init(){this.name=u.id}loadDependency(){return this._module=this._module||(0,i.$y)("graphql/execution/execute.js")}setupOnce(e,t){if((0,c.K)(t))return void(("undefined"==typeof __SENTRY_DEBUG__||__SENTRY_DEBUG__)&&r.kg.log("GraphQL Integration is skipped because of instrumenter configuration."));const n=this.loadDependency();n?(0,o.hl)(n,"execute",(function(e){return function(...n){const i=t().getScope(),r=(0,s.x)([i,"optionalAccess",e=>e.getSpan,"call",e=>e()]),o=(0,s.x)([r,"optionalAccess",e=>e.startChild,"call",e=>e({description:"execute",op:"graphql.execute"})]);(0,s.x)([i,"optionalAccess",e=>e.setSpan,"call",e=>e(o)]);const c=e.call(this,...n);return(0,a.J8)(c)?c.then((e=>((0,s.x)([o,"optionalAccess",e=>e.finish,"call",e=>e()]),(0,s.x)([i,"optionalAccess",e=>e.setSpan,"call",e=>e(r)]),e))):((0,s.x)([o,"optionalAccess",e=>e.finish,"call",e=>e()]),(0,s.x)([i,"optionalAccess",e=>e.setSpan,"call",e=>e(r)]),c)}})):("undefined"==typeof __SENTRY_DEBUG__||__SENTRY_DEBUG__)&&r.kg.error("GraphQL Integration was unable to require graphql/execution package.")}}u.__initStatic()},6046:(e,t,n)=>{"use strict";n.d(t,{G:()=>i});var s=n(2176);e=n.hmd(e);const i=[()=>new((0,s.l$)(e,"./apollo").Apollo),()=>new((0,s.l$)(e,"./apollo").Apollo)({useNestjs:!0}),()=>new((0,s.l$)(e,"./graphql").GraphQL),()=>new((0,s.l$)(e,"./mongo").Mongo),()=>new((0,s.l$)(e,"./mongo").Mongo)({mongoose:!0}),()=>new((0,s.l$)(e,"./mysql").Mysql),()=>new((0,s.l$)(e,"./postgres").Postgres)]},6169:(e,t,n)=>{"use strict";n.d(t,{_:()=>d});var s=n(4307),i=n(2176),r=n(2343),o=n(535),a=n(7597),c=n(7990);const u=["aggregate","bulkWrite","countDocuments","createIndex","createIndexes","deleteMany","deleteOne","distinct","drop","dropIndex","dropIndexes","estimatedDocumentCount","find","findOne","findOneAndDelete","findOneAndReplace","findOneAndUpdate","indexes","indexExists","indexInformation","initializeOrderedBulkOp","insertMany","insertOne","isCapped","mapReduce","options","parallelCollectionScan","rename","replaceOne","stats","updateMany","updateOne"],l={bulkWrite:["operations"],countDocuments:["query"],createIndex:["fieldOrSpec"],createIndexes:["indexSpecs"],deleteMany:["filter"],deleteOne:["filter"],distinct:["key","query"],dropIndex:["indexName"],find:["query"],findOne:["query"],findOneAndDelete:["filter"],findOneAndReplace:["filter","replacement"],findOneAndUpdate:["filter","update"],indexExists:["indexes"],insertMany:["docs"],insertOne:["doc"],mapReduce:["map","reduce"],rename:["newName"],replaceOne:["filter","doc"],updateMany:["filter","update"],updateOne:["filter","update"]};class d{static __initStatic(){this.id="Mongo"}__init(){this.name=d.id}constructor(e={}){d.prototype.__init.call(this),this._operations=Array.isArray(e.operations)?e.operations:u,this._describeOperations=!("describeOperations"in e)||e.describeOperations,this._useMongoose=!!e.useMongoose}loadDependency(){const e=this._useMongoose?"mongoose":"mongodb";return this._module=this._module||(0,i.$y)(e)}setupOnce(e,t){if((0,c.K)(t))return void(("undefined"==typeof __SENTRY_DEBUG__||__SENTRY_DEBUG__)&&r.kg.log("Mongo Integration is skipped because of instrumenter configuration."));const n=this.loadDependency();if(n)this._instrumentOperations(n.Collection,this._operations,t);else{const e=this._useMongoose?"mongoose":"mongodb";("undefined"==typeof __SENTRY_DEBUG__||__SENTRY_DEBUG__)&&r.kg.error(`Mongo Integration was unable to require \`${e}\` package.`)}}_instrumentOperations(e,t,n){t.forEach((t=>this._patchOperation(e,t,n)))}_patchOperation(e,t,n){if(!(t in e.prototype))return;const i=this._getSpanContextFromOperationArguments.bind(this);(0,o.hl)(e.prototype,t,(function(e){return function(...r){const o=r[r.length-1],c=n().getScope(),u=(0,s.x)([c,"optionalAccess",e=>e.getSpan,"call",e=>e()]);if("function"!=typeof o||"mapReduce"===t&&2===r.length){const n=(0,s.x)([u,"optionalAccess",e=>e.startChild,"call",e=>e(i(this,t,r))]),o=e.call(this,...r);if((0,a.J8)(o))return o.then((e=>((0,s.x)([n,"optionalAccess",e=>e.finish,"call",e=>e()]),e)));if((l=o)&&"object"==typeof l&&l.once&&"function"==typeof l.once){const e=o;try{e.once("close",(()=>{(0,s.x)([n,"optionalAccess",e=>e.finish,"call",e=>e()])}))}catch(e){(0,s.x)([n,"optionalAccess",e=>e.finish,"call",e=>e()])}return e}return(0,s.x)([n,"optionalAccess",e=>e.finish,"call",e=>e()]),o}var l;const d=(0,s.x)([u,"optionalAccess",e=>e.startChild,"call",e=>e(i(this,t,r.slice(0,-1)))]);return e.call(this,...r.slice(0,-1),(function(e,t){(0,s.x)([d,"optionalAccess",e=>e.finish,"call",e=>e()]),o(e,t)}))}}))}_getSpanContextFromOperationArguments(e,t,n){const s={collectionName:e.collectionName,dbName:e.dbName,namespace:e.namespace,"db.system":"mongodb"},i={op:"db",description:t,data:s},r=l[t],o=Array.isArray(this._describeOperations)?this._describeOperations.includes(t):this._describeOperations;if(!r||!o)return i;try{if("mapReduce"===t){const[e,t]=n;s[r[0]]="string"==typeof e?e:e.name||"<anonymous>",s[r[1]]="string"==typeof t?t:t.name||"<anonymous>"}else for(let e=0;e<r.length;e++)s[r[e]]=JSON.stringify(n[e])}catch(e){}return i}}d.__initStatic()},24:(e,t,n)=>{"use strict";n.d(t,{m:()=>c});var s=n(4307),i=n(2176),r=n(2343),o=n(535),a=n(7990);class c{constructor(){c.prototype.__init.call(this)}static __initStatic(){this.id="Mysql"}__init(){this.name=c.id}loadDependency(){return this._module=this._module||(0,i.$y)("mysql/lib/Connection.js")}setupOnce(e,t){if((0,a.K)(t))return void(("undefined"==typeof __SENTRY_DEBUG__||__SENTRY_DEBUG__)&&r.kg.log("Mysql Integration is skipped because of instrumenter configuration."));const n=this.loadDependency();n?(0,o.hl)(n,"createQuery",(function(e){return function(n,i,r){const o=t().getScope(),a=(0,s.x)([o,"optionalAccess",e=>e.getSpan,"call",e=>e()]),c=(0,s.x)([a,"optionalAccess",e=>e.startChild,"call",e=>e({description:"string"==typeof n?n:n.sql,op:"db",data:{"db.system":"mysql"}})]);return"function"==typeof r?e.call(this,n,i,(function(e,t,n){(0,s.x)([c,"optionalAccess",e=>e.finish,"call",e=>e()]),r(e,t,n)})):"function"==typeof i?e.call(this,n,(function(e,t,n){(0,s.x)([c,"optionalAccess",e=>e.finish,"call",e=>e()]),i(e,t,n)})):e.call(this,n,i,r)}})):("undefined"==typeof __SENTRY_DEBUG__||__SENTRY_DEBUG__)&&r.kg.error("Mysql Integration was unable to require `mysql` package.")}}c.__initStatic()},1370:(e,t,n)=>{"use strict";n.d(t,{E:()=>u});var s=n(4307),i=n(2176),r=n(2343),o=n(535),a=n(7597),c=n(7990);class u{static __initStatic(){this.id="Postgres"}__init(){this.name=u.id}constructor(e={}){u.prototype.__init.call(this),this._usePgNative=!!e.usePgNative}loadDependency(){return this._module=this._module||(0,i.$y)("pg")}setupOnce(e,t){if((0,c.K)(t))return void(("undefined"==typeof __SENTRY_DEBUG__||__SENTRY_DEBUG__)&&r.kg.log("Postgres Integration is skipped because of instrumenter configuration."));const n=this.loadDependency();if(!n)return void(("undefined"==typeof __SENTRY_DEBUG__||__SENTRY_DEBUG__)&&r.kg.error("Postgres Integration was unable to require `pg` package."));if(this._usePgNative&&!(0,s.x)([n,"access",e=>e.native,"optionalAccess",e=>e.Client]))return void(("undefined"==typeof __SENTRY_DEBUG__||__SENTRY_DEBUG__)&&r.kg.error("Postgres Integration was unable to access 'pg-native' bindings."));const{Client:i}=this._usePgNative?n.native:n;(0,o.hl)(i.prototype,"query",(function(e){return function(n,i,r){const o=t().getScope(),c=(0,s.x)([o,"optionalAccess",e=>e.getSpan,"call",e=>e()]),u=(0,s.x)([c,"optionalAccess",e=>e.startChild,"call",e=>e({description:"string"==typeof n?n:n.text,op:"db",data:{"db.system":"postgresql"}})]);if("function"==typeof r)return e.call(this,n,i,(function(e,t){(0,s.x)([u,"optionalAccess",e=>e.finish,"call",e=>e()]),r(e,t)}));if("function"==typeof i)return e.call(this,n,(function(e,t){(0,s.x)([u,"optionalAccess",e=>e.finish,"call",e=>e()]),i(e,t)}));const l=void 0!==i?e.call(this,n,i):e.call(this,n);return(0,a.J8)(l)?l.then((e=>((0,s.x)([u,"optionalAccess",e=>e.finish,"call",e=>e()]),e))):((0,s.x)([u,"optionalAccess",e=>e.finish,"call",e=>e()]),l)}}))}}u.__initStatic()},9889:(e,t,n)=>{"use strict";n.d(t,{g:()=>o});var s=n(1250),i=n(2343),r=n(7990);class o{static __initStatic(){this.id="Prisma"}__init(){this.name=o.id}constructor(e={}){var t;o.prototype.__init.call(this),(t=e.client)&&t.$use?this._client=e.client:("undefined"==typeof __SENTRY_DEBUG__||__SENTRY_DEBUG__)&&i.kg.warn(`Unsupported Prisma client provided to PrismaIntegration. Provided client: ${JSON.stringify(e.client)}`)}setupOnce(e,t){this._client?(0,r.K)(t)?("undefined"==typeof __SENTRY_DEBUG__||__SENTRY_DEBUG__)&&i.kg.log("Prisma Integration is skipped because of instrumenter configuration."):this._client.$use(((e,t)=>{const n=e.action,i=e.model;return(0,s.g)({name:i?`${i} ${n}`:n,op:"db.sql.prisma",data:{"db.system":"prisma"}},(()=>t(e)))})):("undefined"==typeof __SENTRY_DEBUG__||__SENTRY_DEBUG__)&&i.kg.error("PrismaIntegration is missing a Prisma Client Instance")}}o.__initStatic()},7990:(e,t,n)=>{"use strict";n.d(t,{K:()=>i});var s=n(4307);function i(e){const t=(0,s.x)([e,"call",e=>e(),"access",e=>e.getClient,"call",e=>e(),"optionalAccess",e=>e.getOptions,"call",e=>e()]);return"sentry"!==((0,s.x)([t,"optionalAccess",e=>e.instrumenter])||"sentry")}},1131:(e,t,n)=>{"use strict";n.d(t,{J:()=>s});const s="production"},5659:(e,t,n)=>{"use strict";n.d(t,{$b:()=>y,Gd:()=>_,Ok:()=>b,Xb:()=>p,cu:()=>h,j0:()=>S,pj:()=>f,uZ:()=>m,vi:()=>E});var s=n(2844),i=n(1170),r=n(2343),o=n(1235),a=n(1131),c=n(350),u=n(9015);const l=4,d=100;class p{constructor(e,t=new c.s,n=l){this._version=n,this._stack=[{scope:t}],e&&this.bindClient(e)}isOlderThan(e){return this._version<e}bindClient(e){this.getStackTop().client=e,e&&e.setupIntegrations&&e.setupIntegrations()}pushScope(){const e=c.s.clone(this.getScope());return this.getStack().push({client:this.getClient(),scope:e}),e}popScope(){return!(this.getStack().length<=1||!this.getStack().pop())}withScope(e){const t=this.pushScope();try{e(t)}finally{this.popScope()}}getClient(){return this.getStackTop().client}getScope(){return this.getStackTop().scope}getStack(){return this._stack}getStackTop(){return this._stack[this._stack.length-1]}captureException(e,t){const n=this._lastEventId=t&&t.event_id?t.event_id:(0,s.DM)(),i=new Error("Sentry syntheticException");return this._withClient(((s,r)=>{s.captureException(e,{originalException:e,syntheticException:i,...t,event_id:n},r)})),n}captureMessage(e,t,n){const i=this._lastEventId=n&&n.event_id?n.event_id:(0,s.DM)(),r=new Error(e);return this._withClient(((s,o)=>{s.captureMessage(e,t,{originalException:e,syntheticException:r,...n,event_id:i},o)})),i}captureEvent(e,t){const n=t&&t.event_id?t.event_id:(0,s.DM)();return e.type||(this._lastEventId=n),this._withClient(((s,i)=>{s.captureEvent(e,{...t,event_id:n},i)})),n}lastEventId(){return this._lastEventId}addBreadcrumb(e,t){const{scope:n,client:s}=this.getStackTop();if(!s)return;const{beforeBreadcrumb:o=null,maxBreadcrumbs:a=d}=s.getOptions&&s.getOptions()||{};if(a<=0)return;const c={timestamp:(0,i.yW)(),...e},u=o?(0,r.Cf)((()=>o(c,t))):c;null!==u&&(s.emit&&s.emit("beforeAddBreadcrumb",u,t),n.addBreadcrumb(u,a))}setUser(e){this.getScope().setUser(e)}setTags(e){this.getScope().setTags(e)}setExtras(e){this.getScope().setExtras(e)}setTag(e,t){this.getScope().setTag(e,t)}setExtra(e,t){this.getScope().setExtra(e,t)}setContext(e,t){this.getScope().setContext(e,t)}configureScope(e){const{scope:t,client:n}=this.getStackTop();n&&e(t)}run(e){const t=f(this);try{e(this)}finally{f(t)}}getIntegration(e){const t=this.getClient();if(!t)return null;try{return t.getIntegration(e)}catch(t){return("undefined"==typeof __SENTRY_DEBUG__||__SENTRY_DEBUG__)&&r.kg.warn(`Cannot retrieve integration ${e.id} from the current Hub`),null}}startTransaction(e,t){const n=this._callExtensionMethod("startTransaction",e,t);return"undefined"!=typeof __SENTRY_DEBUG__&&!__SENTRY_DEBUG__||n||console.warn("Tracing extension 'startTransaction' has not been added. Call 'addTracingExtensions' before calling 'init':\nSentry.addTracingExtensions();\nSentry.init({...});\n"),n}traceHeaders(){return this._callExtensionMethod("traceHeaders")}captureSession(e=!1){if(e)return this.endSession();this._sendSessionUpdate()}endSession(){const e=this.getStackTop().scope,t=e.getSession();t&&(0,u.RJ)(t),this._sendSessionUpdate(),e.setSession()}startSession(e){const{scope:t,client:n}=this.getStackTop(),{release:s,environment:i=a.J}=n&&n.getOptions()||{},{userAgent:r}=o.n2.navigator||{},c=(0,u.Hv)({release:s,environment:i,user:t.getUser(),...r&&{userAgent:r},...e}),l=t.getSession&&t.getSession();return l&&"ok"===l.status&&(0,u.CT)(l,{status:"exited"}),this.endSession(),t.setSession(c),c}shouldSendDefaultPii(){const e=this.getClient(),t=e&&e.getOptions();return Boolean(t&&t.sendDefaultPii)}_sendSessionUpdate(){const{scope:e,client:t}=this.getStackTop(),n=e.getSession();n&&t&&t.captureSession&&t.captureSession(n)}_withClient(e){const{scope:t,client:n}=this.getStackTop();n&&e(n,t)}_callExtensionMethod(e,...t){const n=h().__SENTRY__;if(n&&n.extensions&&"function"==typeof n.extensions[e])return n.extensions[e].apply(this,t);("undefined"==typeof __SENTRY_DEBUG__||__SENTRY_DEBUG__)&&r.kg.warn(`Extension method ${e} couldn't be found, doing nothing.`)}}function h(){return o.n2.__SENTRY__=o.n2.__SENTRY__||{extensions:{},hub:void 0},o.n2}function f(e){const t=h(),n=E(t);return S(t,e),n}function _(){const e=h();if(e.__SENTRY__&&e.__SENTRY__.acs){const t=e.__SENTRY__.acs.getCurrentHub();if(t)return t}return g(e)}function g(e=h()){return v(e)&&!E(e).isOlderThan(l)||S(e,new p),E(e)}function m(e,t=g()){if(!v(e)||E(e).isOlderThan(l)){const n=t.getStackTop();S(e,new p(n.client,c.s.clone(n.scope)))}}function y(e){const t=h();t.__SENTRY__=t.__SENTRY__||{},t.__SENTRY__.acs=e}function b(e,t={}){const n=h();return n.__SENTRY__&&n.__SENTRY__.acs?n.__SENTRY__.acs.runWithAsyncContext(e,t):e()}function v(e){return!!(e&&e.__SENTRY__&&e.__SENTRY__.hub)}function E(e){return(0,o.YO)("hub",(()=>new p),e)}function S(e,t){return!!e&&((e.__SENTRY__=e.__SENTRY__||{}).hub=t,!0)}},350:(e,t,n)=>{"use strict";n.d(t,{c:()=>p,s:()=>l});var s=n(7597),i=n(1170),r=n(6893),o=n(2343),a=n(2844),c=n(1235),u=n(9015);class l{constructor(){this._notifyingListeners=!1,this._scopeListeners=[],this._eventProcessors=[],this._breadcrumbs=[],this._attachments=[],this._user={},this._tags={},this._extra={},this._contexts={},this._sdkProcessingMetadata={}}static clone(e){const t=new l;return e&&(t._breadcrumbs=[...e._breadcrumbs],t._tags={...e._tags},t._extra={...e._extra},t._contexts={...e._contexts},t._user=e._user,t._level=e._level,t._span=e._span,t._session=e._session,t._transactionName=e._transactionName,t._fingerprint=e._fingerprint,t._eventProcessors=[...e._eventProcessors],t._requestSession=e._requestSession,t._attachments=[...e._attachments],t._sdkProcessingMetadata={...e._sdkProcessingMetadata}),t}addScopeListener(e){this._scopeListeners.push(e)}addEventProcessor(e){return this._eventProcessors.push(e),this}setUser(e){return this._user=e||{},this._session&&(0,u.CT)(this._session,{user:e}),this._notifyScopeListeners(),this}getUser(){return this._user}getRequestSession(){return this._requestSession}setRequestSession(e){return this._requestSession=e,this}setTags(e){return this._tags={...this._tags,...e},this._notifyScopeListeners(),this}setTag(e,t){return this._tags={...this._tags,[e]:t},this._notifyScopeListeners(),this}setExtras(e){return this._extra={...this._extra,...e},this._notifyScopeListeners(),this}setExtra(e,t){return this._extra={...this._extra,[e]:t},this._notifyScopeListeners(),this}setFingerprint(e){return this._fingerprint=e,this._notifyScopeListeners(),this}setLevel(e){return this._level=e,this._notifyScopeListeners(),this}setTransactionName(e){return this._transactionName=e,this._notifyScopeListeners(),this}setContext(e,t){return null===t?delete this._contexts[e]:this._contexts[e]=t,this._notifyScopeListeners(),this}setSpan(e){return this._span=e,this._notifyScopeListeners(),this}getSpan(){return this._span}getTransaction(){const e=this.getSpan();return e&&e.transaction}setSession(e){return e?this._session=e:delete this._session,this._notifyScopeListeners(),this}getSession(){return this._session}update(e){if(!e)return this;if("function"==typeof e){const t=e(this);return t instanceof l?t:this}return e instanceof l?(this._tags={...this._tags,...e._tags},this._extra={...this._extra,...e._extra},this._contexts={...this._contexts,...e._contexts},e._user&&Object.keys(e._user).length&&(this._user=e._user),e._level&&(this._level=e._level),e._fingerprint&&(this._fingerprint=e._fingerprint),e._requestSession&&(this._requestSession=e._requestSession)):(0,s.PO)(e)&&(this._tags={...this._tags,...e.tags},this._extra={...this._extra,...e.extra},this._contexts={...this._contexts,...e.contexts},e.user&&(this._user=e.user),e.level&&(this._level=e.level),e.fingerprint&&(this._fingerprint=e.fingerprint),e.requestSession&&(this._requestSession=e.requestSession)),this}clear(){return this._breadcrumbs=[],this._tags={},this._extra={},this._user={},this._contexts={},this._level=void 0,this._transactionName=void 0,this._fingerprint=void 0,this._requestSession=void 0,this._span=void 0,this._session=void 0,this._notifyScopeListeners(),this._attachments=[],this}addBreadcrumb(e,t){const n="number"==typeof t?t:100;if(n<=0)return this;const s={timestamp:(0,i.yW)(),...e};return this._breadcrumbs=[...this._breadcrumbs,s].slice(-n),this._notifyScopeListeners(),this}getLastBreadcrumb(){return this._breadcrumbs[this._breadcrumbs.length-1]}clearBreadcrumbs(){return this._breadcrumbs=[],this._notifyScopeListeners(),this}addAttachment(e){return this._attachments.push(e),this}getAttachments(){return this._attachments}clearAttachments(){return this._attachments=[],this}applyToEvent(e,t={}){if(this._extra&&Object.keys(this._extra).length&&(e.extra={...this._extra,...e.extra}),this._tags&&Object.keys(this._tags).length&&(e.tags={...this._tags,...e.tags}),this._user&&Object.keys(this._user).length&&(e.user={...this._user,...e.user}),this._contexts&&Object.keys(this._contexts).length&&(e.contexts={...this._contexts,...e.contexts}),this._level&&(e.level=this._level),this._transactionName&&(e.transaction=this._transactionName),this._span){e.contexts={trace:this._span.getTraceContext(),...e.contexts};const t=this._span.transaction;if(t){e.sdkProcessingMetadata={dynamicSamplingContext:t.getDynamicSamplingContext(),...e.sdkProcessingMetadata};const n=t.name;n&&(e.tags={transaction:n,...e.tags})}}return this._applyFingerprint(e),e.breadcrumbs=[...e.breadcrumbs||[],...this._breadcrumbs],e.breadcrumbs=e.breadcrumbs.length>0?e.breadcrumbs:void 0,e.sdkProcessingMetadata={...e.sdkProcessingMetadata,...this._sdkProcessingMetadata},this._notifyEventProcessors([...d(),...this._eventProcessors],e,t)}setSDKProcessingMetadata(e){return this._sdkProcessingMetadata={...this._sdkProcessingMetadata,...e},this}_notifyEventProcessors(e,t,n,i=0){return new r.cW(((r,a)=>{const c=e[i];if(null===t||"function"!=typeof c)r(t);else{const u=c({...t},n);("undefined"==typeof __SENTRY_DEBUG__||__SENTRY_DEBUG__)&&c.id&&null===u&&o.kg.log(`Event processor "${c.id}" dropped event`),(0,s.J8)(u)?u.then((t=>this._notifyEventProcessors(e,t,n,i+1).then(r))).then(null,a):this._notifyEventProcessors(e,u,n,i+1).then(r).then(null,a)}}))}_notifyScopeListeners(){this._notifyingListeners||(this._notifyingListeners=!0,this._scopeListeners.forEach((e=>{e(this)})),this._notifyingListeners=!1)}_applyFingerprint(e){e.fingerprint=e.fingerprint?(0,a.lE)(e.fingerprint):[],this._fingerprint&&(e.fingerprint=e.fingerprint.concat(this._fingerprint)),e.fingerprint&&!e.fingerprint.length&&delete e.fingerprint}}function d(){return(0,c.YO)("globalEventProcessors",(()=>[]))}function p(e){d().push(e)}},9015:(e,t,n)=>{"use strict";n.d(t,{CT:()=>a,Hv:()=>o,RJ:()=>c});var s=n(1170),i=n(2844),r=n(535);function o(e){const t=(0,s.ph)(),n={sid:(0,i.DM)(),init:!0,timestamp:t,started:t,duration:0,status:"ok",errors:0,ignoreDuration:!1,toJSON:()=>function(e){return(0,r.Jr)({sid:`${e.sid}`,init:e.init,started:new Date(1e3*e.started).toISOString(),timestamp:new Date(1e3*e.timestamp).toISOString(),status:e.status,errors:e.errors,did:"number"==typeof e.did||"string"==typeof e.did?`${e.did}`:void 0,duration:e.duration,attrs:{release:e.release,environment:e.environment,ip_address:e.ipAddress,user_agent:e.userAgent}})}(n)};return e&&a(n,e),n}function a(e,t={}){if(t.user&&(!e.ipAddress&&t.user.ip_address&&(e.ipAddress=t.user.ip_address),e.did||t.did||(e.did=t.user.id||t.user.email||t.user.username)),e.timestamp=t.timestamp||(0,s.ph)(),t.ignoreDuration&&(e.ignoreDuration=t.ignoreDuration),t.sid&&(e.sid=32===t.sid.length?t.sid:(0,i.DM)()),void 0!==t.init&&(e.init=t.init),!e.did&&t.did&&(e.did=`${t.did}`),"number"==typeof t.started&&(e.started=t.started),e.ignoreDuration)e.duration=void 0;else if("number"==typeof t.duration)e.duration=t.duration;else{const t=e.timestamp-e.started;e.duration=t>=0?t:0}t.release&&(e.release=t.release),t.environment&&(e.environment=t.environment),!e.ipAddress&&t.ipAddress&&(e.ipAddress=t.ipAddress),!e.userAgent&&t.userAgent&&(e.userAgent=t.userAgent),"number"==typeof t.errors&&(e.errors=t.errors),t.status&&(e.status=t.status)}function c(e,t){let n={};t?n={status:t}:"ok"===e.status&&(n={status:"exited"}),a(e,n)}},6890:(e,t,n)=>{"use strict";n.d(t,{T:()=>m,l:()=>g});var s=n(2343),i=n(7597),r=n(5659),o=n(7522),a=n(1688),c=n(9791);let u=!1;function l(){const e=(0,c.x1)();if(e){const t="internal_error";("undefined"==typeof __SENTRY_DEBUG__||__SENTRY_DEBUG__)&&s.kg.log(`[Tracing] Transaction: ${t} -> Global error occured`),e.setStatus(t)}}l.tag="sentry_tracingErrorCallback";var d=n(5544),p=n(8069);function h(){const e=this.getScope().getSpan();return e?{"sentry-trace":e.toTraceparent()}:{}}function f(e,t,n){if(!(0,o.z)(t))return e.sampled=!1,e;if(void 0!==e.sampled)return e.setMetadata({sampleRate:Number(e.sampled)}),e;let r;return"function"==typeof t.tracesSampler?(r=t.tracesSampler(n),e.setMetadata({sampleRate:Number(r)})):void 0!==n.parentSampled?r=n.parentSampled:void 0!==t.tracesSampleRate?(r=t.tracesSampleRate,e.setMetadata({sampleRate:Number(r)})):(r=1,e.setMetadata({sampleRate:r})),a=r,((0,i.i2)(a)||"number"!=typeof a&&"boolean"!=typeof a?(("undefined"==typeof __SENTRY_DEBUG__||__SENTRY_DEBUG__)&&s.kg.warn(`[Tracing] Given sample rate is invalid. Sample rate must be a boolean or a number between 0 and 1. Got ${JSON.stringify(a)} of type ${JSON.stringify(typeof a)}.`),0):!(a<0||a>1)||(("undefined"==typeof __SENTRY_DEBUG__||__SENTRY_DEBUG__)&&s.kg.warn(`[Tracing] Given sample rate is invalid. Sample rate must be between 0 and 1. Got ${a}.`),0))?r?(e.sampled=Math.random()<r,e.sampled?(("undefined"==typeof __SENTRY_DEBUG__||__SENTRY_DEBUG__)&&s.kg.log(`[Tracing] starting ${e.op} transaction - ${e.name}`),e):(("undefined"==typeof __SENTRY_DEBUG__||__SENTRY_DEBUG__)&&s.kg.log(`[Tracing] Discarding transaction because it's not included in the random sample (sampling rate = ${Number(r)})`),e)):(("undefined"==typeof __SENTRY_DEBUG__||__SENTRY_DEBUG__)&&s.kg.log("[Tracing] Discarding transaction because "+("function"==typeof t.tracesSampler?"tracesSampler returned 0 or false":"a negative sampling decision was inherited or tracesSampleRate is set to 0")),e.sampled=!1,e):(("undefined"==typeof __SENTRY_DEBUG__||__SENTRY_DEBUG__)&&s.kg.warn("[Tracing] Discarding transaction because of invalid sample rate."),e.sampled=!1,e);var a}function _(e,t){const n=this.getClient(),i=n&&n.getOptions()||{},r=i.instrumenter||"sentry",o=e.instrumenter||"sentry";r!==o&&(("undefined"==typeof __SENTRY_DEBUG__||__SENTRY_DEBUG__)&&s.kg.error(`A transaction was started with instrumenter=\`${o}\`, but the SDK is configured with the \`${r}\` instrumenter.\nThe transaction will not be sampled. Please use the ${r} instrumentation to start transactions.`),e.sampled=!1);let a=new p.Y(e,this);return a=f(a,i,{parentSampled:e.parentSampled,transactionContext:e,...t}),a.sampled&&a.initSpanRecorder(i._experiments&&i._experiments.maxSpans),n&&n.emit&&n.emit("startTransaction",a),a}function g(e,t,n,s,i,r,o){const a=e.getClient(),c=a&&a.getOptions()||{};let u=new d.io(t,e,n,s,o,i);return u=f(u,c,{parentSampled:t.parentSampled,transactionContext:t,...r}),u.sampled&&u.initSpanRecorder(c._experiments&&c._experiments.maxSpans),a&&a.emit&&a.emit("startTransaction",u),u}function m(){const e=(0,r.cu)();e.__SENTRY__&&(e.__SENTRY__.extensions=e.__SENTRY__.extensions||{},e.__SENTRY__.extensions.startTransaction||(e.__SENTRY__.extensions.startTransaction=_),e.__SENTRY__.extensions.traceHeaders||(e.__SENTRY__.extensions.traceHeaders=h),u||(u=!0,(0,a.oq)("error",l),(0,a.oq)("unhandledrejection",l)))}},5544:(e,t,n)=>{"use strict";n.d(t,{AT:()=>a,io:()=>l});var s=n(1170),i=n(2343),r=n(8903),o=n(8069);const a={idleTimeout:1e3,finalTimeout:3e4,heartbeatInterval:5e3},c=["heartbeatFailed","idleTimeout","documentHidden","finalTimeout","externalFinish","cancelled"];class u extends r.gB{constructor(e,t,n,s){super(s),this._pushActivity=e,this._popActivity=t,this.transactionSpanId=n}add(e){e.spanId!==this.transactionSpanId&&(e.finish=t=>{e.endTimestamp="number"==typeof t?t:(0,s.ph)(),this._popActivity(e.spanId)},void 0===e.endTimestamp&&this._pushActivity(e.spanId)),super.add(e)}}class l extends o.Y{__init(){this.activities={}}__init2(){this._heartbeatCounter=0}__init3(){this._finished=!1}__init4(){this._idleTimeoutCanceledPermanently=!1}__init5(){this._beforeFinishCallbacks=[]}__init6(){this._finishReason=c[4]}constructor(e,t,n=a.idleTimeout,s=a.finalTimeout,r=a.heartbeatInterval,o=!1){super(e,t),this._idleHub=t,this._idleTimeout=n,this._finalTimeout=s,this._heartbeatInterval=r,this._onScope=o,l.prototype.__init.call(this),l.prototype.__init2.call(this),l.prototype.__init3.call(this),l.prototype.__init4.call(this),l.prototype.__init5.call(this),l.prototype.__init6.call(this),o&&(("undefined"==typeof __SENTRY_DEBUG__||__SENTRY_DEBUG__)&&i.kg.log(`Setting idle transaction on scope. Span ID: ${this.spanId}`),t.configureScope((e=>e.setSpan(this)))),this._restartIdleTimeout(),setTimeout((()=>{this._finished||(this.setStatus("deadline_exceeded"),this._finishReason=c[3],this.finish())}),this._finalTimeout)}finish(e=(0,s.ph)()){if(this._finished=!0,this.activities={},"ui.action.click"===this.op&&this.setTag("finishReason",this._finishReason),this.spanRecorder){("undefined"==typeof __SENTRY_DEBUG__||__SENTRY_DEBUG__)&&i.kg.log("[Tracing] finishing IdleTransaction",new Date(1e3*e).toISOString(),this.op);for(const t of this._beforeFinishCallbacks)t(this,e);this.spanRecorder.spans=this.spanRecorder.spans.filter((t=>{if(t.spanId===this.spanId)return!0;t.endTimestamp||(t.endTimestamp=e,t.setStatus("cancelled"),("undefined"==typeof __SENTRY_DEBUG__||__SENTRY_DEBUG__)&&i.kg.log("[Tracing] cancelling span since transaction ended early",JSON.stringify(t,void 0,2)));const n=t.startTimestamp<e;return n||("undefined"==typeof __SENTRY_DEBUG__||__SENTRY_DEBUG__)&&i.kg.log("[Tracing] discarding Span since it happened after Transaction was finished",JSON.stringify(t,void 0,2)),n})),("undefined"==typeof __SENTRY_DEBUG__||__SENTRY_DEBUG__)&&i.kg.log("[Tracing] flushing IdleTransaction")}else("undefined"==typeof __SENTRY_DEBUG__||__SENTRY_DEBUG__)&&i.kg.log("[Tracing] No active IdleTransaction");if(this._onScope){const e=this._idleHub.getScope();e.getTransaction()===this&&e.setSpan(void 0)}return super.finish(e)}registerBeforeFinishCallback(e){this._beforeFinishCallbacks.push(e)}initSpanRecorder(e){if(!this.spanRecorder){const t=e=>{this._finished||this._pushActivity(e)},n=e=>{this._finished||this._popActivity(e)};this.spanRecorder=new u(t,n,this.spanId,e),("undefined"==typeof __SENTRY_DEBUG__||__SENTRY_DEBUG__)&&i.kg.log("Starting heartbeat"),this._pingHeartbeat()}this.spanRecorder.add(this)}cancelIdleTimeout(e,{restartOnChildSpanChange:t}={restartOnChildSpanChange:!0}){this._idleTimeoutCanceledPermanently=!1===t,this._idleTimeoutID&&(clearTimeout(this._idleTimeoutID),this._idleTimeoutID=void 0,0===Object.keys(this.activities).length&&this._idleTimeoutCanceledPermanently&&(this._finishReason=c[5],this.finish(e)))}setFinishReason(e){this._finishReason=e}_restartIdleTimeout(e){this.cancelIdleTimeout(),this._idleTimeoutID=setTimeout((()=>{this._finished||0!==Object.keys(this.activities).length||(this._finishReason=c[1],this.finish(e))}),this._idleTimeout)}_pushActivity(e){this.cancelIdleTimeout(void 0,{restartOnChildSpanChange:!this._idleTimeoutCanceledPermanently}),("undefined"==typeof __SENTRY_DEBUG__||__SENTRY_DEBUG__)&&i.kg.log(`[Tracing] pushActivity: ${e}`),this.activities[e]=!0,("undefined"==typeof __SENTRY_DEBUG__||__SENTRY_DEBUG__)&&i.kg.log("[Tracing] new activities count",Object.keys(this.activities).length)}_popActivity(e){if(this.activities[e]&&(("undefined"==typeof __SENTRY_DEBUG__||__SENTRY_DEBUG__)&&i.kg.log(`[Tracing] popActivity ${e}`),delete this.activities[e],("undefined"==typeof __SENTRY_DEBUG__||__SENTRY_DEBUG__)&&i.kg.log("[Tracing] new activities count",Object.keys(this.activities).length)),0===Object.keys(this.activities).length){const e=(0,s.ph)();this._idleTimeoutCanceledPermanently?(this._finishReason=c[5],this.finish(e)):this._restartIdleTimeout(e+this._idleTimeout/1e3)}}_beat(){if(this._finished)return;const e=Object.keys(this.activities).join("");e===this._prevHeartbeatString?this._heartbeatCounter++:this._heartbeatCounter=1,this._prevHeartbeatString=e,this._heartbeatCounter>=3?(("undefined"==typeof __SENTRY_DEBUG__||__SENTRY_DEBUG__)&&i.kg.log("[Tracing] Transaction finished because of no change for 3 heart beats"),this.setStatus("deadline_exceeded"),this._finishReason=c[0],this.finish()):this._pingHeartbeat()}_pingHeartbeat(){("undefined"==typeof __SENTRY_DEBUG__||__SENTRY_DEBUG__)&&i.kg.log(`pinging Heartbeat -> current counter: ${this._heartbeatCounter}`),setTimeout((()=>{this._beat()}),this._heartbeatInterval)}}},8903:(e,t,n)=>{"use strict";n.d(t,{Dr:()=>c,Zd:()=>u,gB:()=>a});var s=n(2844),i=n(1170),r=n(2343),o=n(535);class a{__init(){this.spans=[]}constructor(e=1e3){a.prototype.__init.call(this),this._maxlen=e}add(e){this.spans.length>this._maxlen?e.spanRecorder=void 0:this.spans.push(e)}}class c{__init2(){this.traceId=(0,s.DM)()}__init3(){this.spanId=(0,s.DM)().substring(16)}__init4(){this.startTimestamp=(0,i.ph)()}__init5(){this.tags={}}__init6(){this.data={}}__init7(){this.instrumenter="sentry"}constructor(e){if(c.prototype.__init2.call(this),c.prototype.__init3.call(this),c.prototype.__init4.call(this),c.prototype.__init5.call(this),c.prototype.__init6.call(this),c.prototype.__init7.call(this),!e)return this;e.traceId&&(this.traceId=e.traceId),e.spanId&&(this.spanId=e.spanId),e.parentSpanId&&(this.parentSpanId=e.parentSpanId),"sampled"in e&&(this.sampled=e.sampled),e.op&&(this.op=e.op),e.description&&(this.description=e.description),e.data&&(this.data=e.data),e.tags&&(this.tags=e.tags),e.status&&(this.status=e.status),e.startTimestamp&&(this.startTimestamp=e.startTimestamp),e.endTimestamp&&(this.endTimestamp=e.endTimestamp),e.instrumenter&&(this.instrumenter=e.instrumenter)}startChild(e){const t=new c({...e,parentSpanId:this.spanId,sampled:this.sampled,traceId:this.traceId});if(t.spanRecorder=this.spanRecorder,t.spanRecorder&&t.spanRecorder.add(t),t.transaction=this.transaction,("undefined"==typeof __SENTRY_DEBUG__||__SENTRY_DEBUG__)&&t.transaction){const n=`[Tracing] Starting '${e&&e.op||"< unknown op >"}' span on transaction '${t.transaction.name||"< unknown name >"}' (${t.transaction.spanId}).`;t.transaction.metadata.spanMetadata[t.spanId]={logMessage:n},r.kg.log(n)}return t}setTag(e,t){return this.tags={...this.tags,[e]:t},this}setData(e,t){return this.data={...this.data,[e]:t},this}setStatus(e){return this.status=e,this}setHttpStatus(e){this.setTag("http.status_code",String(e));const t=u(e);return"unknown_error"!==t&&this.setStatus(t),this}isSuccess(){return"ok"===this.status}finish(e){if(("undefined"==typeof __SENTRY_DEBUG__||__SENTRY_DEBUG__)&&this.transaction&&this.transaction.spanId!==this.spanId){const{logMessage:e}=this.transaction.metadata.spanMetadata[this.spanId];e&&r.kg.log(e.replace("Starting","Finishing"))}this.endTimestamp="number"==typeof e?e:(0,i.ph)()}toTraceparent(){let e="";return void 0!==this.sampled&&(e=this.sampled?"-1":"-0"),`${this.traceId}-${this.spanId}${e}`}toContext(){return(0,o.Jr)({data:this.data,description:this.description,endTimestamp:this.endTimestamp,op:this.op,parentSpanId:this.parentSpanId,sampled:this.sampled,spanId:this.spanId,startTimestamp:this.startTimestamp,status:this.status,tags:this.tags,traceId:this.traceId})}updateWithContext(e){return this.data=e.data||{},this.description=e.description,this.endTimestamp=e.endTimestamp,this.op=e.op,this.parentSpanId=e.parentSpanId,this.sampled=e.sampled,this.spanId=e.spanId||this.spanId,this.startTimestamp=e.startTimestamp||this.startTimestamp,this.status=e.status,this.tags=e.tags||{},this.traceId=e.traceId||this.traceId,this}getTraceContext(){return(0,o.Jr)({data:Object.keys(this.data).length>0?this.data:void 0,description:this.description,op:this.op,parent_span_id:this.parentSpanId,span_id:this.spanId,status:this.status,tags:Object.keys(this.tags).length>0?this.tags:void 0,trace_id:this.traceId})}toJSON(){return(0,o.Jr)({data:Object.keys(this.data).length>0?this.data:void 0,description:this.description,op:this.op,parent_span_id:this.parentSpanId,span_id:this.spanId,start_timestamp:this.startTimestamp,status:this.status,tags:Object.keys(this.tags).length>0?this.tags:void 0,timestamp:this.endTimestamp,trace_id:this.traceId})}}function u(e){if(e<400&&e>=100)return"ok";if(e>=400&&e<500)switch(e){case 401:return"unauthenticated";case 403:return"permission_denied";case 404:return"not_found";case 409:return"already_exists";case 413:return"failed_precondition";case 429:return"resource_exhausted";default:return"invalid_argument"}if(e>=500&&e<600)switch(e){case 501:return"unimplemented";case 503:return"unavailable";case 504:return"deadline_exceeded";default:return"internal_error"}return"unknown_error"}},1250:(e,t,n)=>{"use strict";n.d(t,{g:()=>r});var s=n(7597),i=n(5659);function r(e,t,n=(()=>{})){const r={...e};void 0!==r.name&&void 0===r.description&&(r.description=r.name);const o=(0,i.Gd)(),a=o.getScope(),c=a.getSpan(),u=c?c.startChild(r):o.startTransaction(r);function l(){u&&u.finish(),o.getScope().setSpan(c)}let d;a.setSpan(u);try{d=t(u)}catch(e){throw u&&u.setStatus("internal_error"),n(e),l(),e}return(0,s.J8)(d)?Promise.resolve(d).then((()=>{l()}),(e=>{u&&u.setStatus("internal_error"),n(e),l()})):l(),d}},8069:(e,t,n)=>{"use strict";n.d(t,{Y:()=>c});var s=n(2343),i=n(535),r=n(1131),o=n(5659),a=n(8903);class c extends a.Dr{__init(){this._measurements={}}__init2(){this._contexts={}}__init3(){this._frozenDynamicSamplingContext=void 0}constructor(e,t){super(e),c.prototype.__init.call(this),c.prototype.__init2.call(this),c.prototype.__init3.call(this),this._hub=t||(0,o.Gd)(),this._name=e.name||"",this.metadata={source:"custom",...e.metadata,spanMetadata:{}},this._trimEnd=e.trimEnd,this.transaction=this;const n=this.metadata.dynamicSamplingContext;n&&(this._frozenDynamicSamplingContext={...n})}get name(){return this._name}set name(e){this.setName(e)}setName(e,t="custom"){this._name=e,this.metadata.source=t}initSpanRecorder(e=1e3){this.spanRecorder||(this.spanRecorder=new a.gB(e)),this.spanRecorder.add(this)}setContext(e,t){null===t?delete this._contexts[e]:this._contexts[e]=t}setMeasurement(e,t,n=""){this._measurements[e]={value:t,unit:n}}setMetadata(e){this.metadata={...this.metadata,...e}}finish(e){if(void 0!==this.endTimestamp)return;this.name||(("undefined"==typeof __SENTRY_DEBUG__||__SENTRY_DEBUG__)&&s.kg.warn("Transaction has no name, falling back to `<unlabeled transaction>`."),this.name="<unlabeled transaction>"),super.finish(e);const t=this._hub.getClient();if(t&&t.emit&&t.emit("finishTransaction",this),!0!==this.sampled)return("undefined"==typeof __SENTRY_DEBUG__||__SENTRY_DEBUG__)&&s.kg.log("[Tracing] Discarding transaction because its trace was not chosen to be sampled."),void(t&&t.recordDroppedEvent("sample_rate","transaction"));const n=this.spanRecorder?this.spanRecorder.spans.filter((e=>e!==this&&e.endTimestamp)):[];this._trimEnd&&n.length>0&&(this.endTimestamp=n.reduce(((e,t)=>e.endTimestamp&&t.endTimestamp?e.endTimestamp>t.endTimestamp?e:t:e)).endTimestamp);const i=this.metadata,r={contexts:{...this._contexts,trace:this.getTraceContext()},spans:n,start_timestamp:this.startTimestamp,tags:this.tags,timestamp:this.endTimestamp,transaction:this.name,type:"transaction",sdkProcessingMetadata:{...i,dynamicSamplingContext:this.getDynamicSamplingContext()},...i.source&&{transaction_info:{source:i.source}}};return Object.keys(this._measurements).length>0&&(("undefined"==typeof __SENTRY_DEBUG__||__SENTRY_DEBUG__)&&s.kg.log("[Measurements] Adding measurements to transaction",JSON.stringify(this._measurements,void 0,2)),r.measurements=this._measurements),("undefined"==typeof __SENTRY_DEBUG__||__SENTRY_DEBUG__)&&s.kg.log(`[Tracing] Finishing ${this.op} transaction: ${this.name}.`),this._hub.captureEvent(r)}toContext(){const e=super.toContext();return(0,i.Jr)({...e,name:this.name,trimEnd:this._trimEnd})}updateWithContext(e){return super.updateWithContext(e),this.name=e.name||"",this._trimEnd=e.trimEnd,this}getDynamicSamplingContext(){if(this._frozenDynamicSamplingContext)return this._frozenDynamicSamplingContext;const e=this._hub||(0,o.Gd)(),t=e&&e.getClient();if(!t)return{};const{environment:n,release:s}=t.getOptions()||{},{publicKey:a}=t.getDsn()||{},c=this.metadata.sampleRate,u=void 0!==c?c.toString():void 0,{segment:l}=e.getScope().getUser()||{},d=this.metadata.source,p=d&&"url"!==d?this.name:void 0,h=(0,i.Jr)({environment:n||r.J,release:s,transaction:p,user_segment:l,public_key:a,trace_id:this.traceId,sample_rate:u});return t.emit&&t.emit("createDsc",h),h}setHub(e){this._hub=e}}},9791:(e,t,n)=>{"use strict";n.d(t,{x1:()=>i});var s=n(5659);function i(e){return(e||(0,s.Gd)()).getScope().getTransaction()}},7522:(e,t,n)=>{"use strict";n.d(t,{z:()=>i});var s=n(5659);function i(e){if("boolean"==typeof __SENTRY_TRACING__&&!__SENTRY_TRACING__)return!1;const t=(0,s.Gd)().getClient(),n=e||t&&t.getOptions();return!!n&&(n.enableTracing||"tracesSampleRate"in n||"tracesSampler"in n)}},2640:(e,t,n)=>{"use strict";n.r(t),n.d(t,{DEFAULT_USER_INCLUDES:()=>Tt,Handlers:()=>i,Hub:()=>m.Xb,Integrations:()=>cn,NodeClient:()=>Ie,SDK_VERSION:()=>g,Scope:()=>ee.s,addBreadcrumb:()=>S,addGlobalEventProcessor:()=>ee.c,addRequestDataToEvent:()=>It,autoDiscoverNodePerformanceMonitoringIntegrations:()=>oe,captureCheckIn:()=>qt,captureEvent:()=>v,captureException:()=>y,captureMessage:()=>b,close:()=>Bt,configureScope:()=>E,createTransport:()=>K,deepReadDirSync:()=>Vt,defaultIntegrations:()=>$t,defaultStackParser:()=>Lt,extractRequestData:()=>wt,extractTraceparentData:()=>te.q,flush:()=>Gt,getActiveTransaction:()=>ne.x1,getCurrentHub:()=>m.Gd,getHubFromCarrier:()=>m.vi,getSentryRelease:()=>Ft,init:()=>Mt,lastEventId:()=>jt,makeMain:()=>m.pj,makeNodeTransport:()=>Ue,runWithAsyncContext:()=>m.Ok,setContext:()=>T,setExtra:()=>w,setExtras:()=>k,setTag:()=>x,setTags:()=>I,setUser:()=>C,spanStatusfromHttpCode:()=>se.Zd,startTransaction:()=>R,trace:()=>ie.g,withScope:()=>O});var s={};n.r(s),n.d(s,{FunctionToString:()=>u,InboundFilters:()=>f});var i={};n.r(i),n.d(i,{errorHandler:()=>Kt,extractRequestData:()=>zt,parseRequest:()=>Jt,requestHandler:()=>Xt,tracingHandler:()=>Wt,trpcMiddleware:()=>Qt});var r={};n.r(r),n.d(r,{Console:()=>Le,Context:()=>pt,ContextLines:()=>st,Http:()=>We,LinkedErrors:()=>rt,LocalVariables:()=>At,Modules:()=>ct,OnUncaughtException:()=>Qe,OnUnhandledRejection:()=>et,RequestData:()=>Ct,Undici:()=>Pt.Y});var o={};n.r(o),n.d(o,{Apollo:()=>en._,Express:()=>tn.N,GraphQL:()=>nn.k,Mongo:()=>sn._,Mysql:()=>rn.m,Postgres:()=>on.E,Prisma:()=>an.g});var a=n(535);let c;class u{constructor(){u.prototype.__init.call(this)}static __initStatic(){this.id="FunctionToString"}__init(){this.name=u.id}setupOnce(){c=Function.prototype.toString;try{Function.prototype.toString=function(...e){const t=(0,a.HK)(this)||this;return c.apply(t,e)}}catch(e){}}}u.__initStatic();var l=n(2343),d=n(2844),p=n(7321);const h=[/^Script error\.?$/,/^Javascript error: Script error\.? on line 0$/];class f{static __initStatic(){this.id="InboundFilters"}__init(){this.name=f.id}constructor(e={}){this._options=e,f.prototype.__init.call(this)}setupOnce(e,t){const n=e=>{const n=t();if(n){const t=n.getIntegration(f);if(t){const s=n.getClient(),i=s?s.getOptions():{},r=function(e={},t={}){return{allowUrls:[...e.allowUrls||[],...t.allowUrls||[]],denyUrls:[...e.denyUrls||[],...t.denyUrls||[]],ignoreErrors:[...e.ignoreErrors||[],...t.ignoreErrors||[],...h],ignoreTransactions:[...e.ignoreTransactions||[],...t.ignoreTransactions||[]],ignoreInternal:void 0===e.ignoreInternal||e.ignoreInternal}}(t._options,i);return function(e,t){return t.ignoreInternal&&function(e){try{return"SentryError"===e.exception.values[0].type}catch(e){}return!1}(e)?(("undefined"==typeof __SENTRY_DEBUG__||__SENTRY_DEBUG__)&&l.kg.warn(`Event dropped due to being internal Sentry Error.\nEvent: ${(0,d.jH)(e)}`),!0):function(e,t){return!(e.type||!t||!t.length)&&function(e){if(e.message)return[e.message];if(e.exception)try{const{type:t="",value:n=""}=e.exception.values&&e.exception.values[0]||{};return[`${n}`,`${t}: ${n}`]}catch(t){return("undefined"==typeof __SENTRY_DEBUG__||__SENTRY_DEBUG__)&&l.kg.error(`Cannot extract message for event ${(0,d.jH)(e)}`),[]}return[]}(e).some((e=>(0,p.U0)(e,t)))}(e,t.ignoreErrors)?(("undefined"==typeof __SENTRY_DEBUG__||__SENTRY_DEBUG__)&&l.kg.warn(`Event dropped due to being matched by \`ignoreErrors\` option.\nEvent: ${(0,d.jH)(e)}`),!0):function(e,t){if("transaction"!==e.type||!t||!t.length)return!1;const n=e.transaction;return!!n&&(0,p.U0)(n,t)}(e,t.ignoreTransactions)?(("undefined"==typeof __SENTRY_DEBUG__||__SENTRY_DEBUG__)&&l.kg.warn(`Event dropped due to being matched by \`ignoreTransactions\` option.\nEvent: ${(0,d.jH)(e)}`),!0):function(e,t){if(!t||!t.length)return!1;const n=_(e);return!!n&&(0,p.U0)(n,t)}(e,t.denyUrls)?(("undefined"==typeof __SENTRY_DEBUG__||__SENTRY_DEBUG__)&&l.kg.warn(`Event dropped due to being matched by \`denyUrls\` option.\nEvent: ${(0,d.jH)(e)}.\nUrl: ${_(e)}`),!0):!function(e,t){if(!t||!t.length)return!0;const n=_(e);return!n||(0,p.U0)(n,t)}(e,t.allowUrls)&&(("undefined"==typeof __SENTRY_DEBUG__||__SENTRY_DEBUG__)&&l.kg.warn(`Event dropped due to not being matched by \`allowUrls\` option.\nEvent: ${(0,d.jH)(e)}.\nUrl: ${_(e)}`),!0)}(e,r)?null:e}}return e};n.id=this.name,e(n)}}function _(e){try{let t;try{t=e.exception.values[0].stacktrace.frames}catch(e){}return t?function(e=[]){for(let t=e.length-1;t>=0;t--){const n=e[t];if(n&&"<anonymous>"!==n.filename&&"[native code]"!==n.filename)return n.filename||null}return null}(t):null}catch(t){return("undefined"==typeof __SENTRY_DEBUG__||__SENTRY_DEBUG__)&&l.kg.error(`Cannot extract url for event ${(0,d.jH)(e)}`),null}}f.__initStatic();const g="7.51.2";var m=n(5659);function y(e,t){return(0,m.Gd)().captureException(e,{captureContext:t})}function b(e,t){const n="string"==typeof t?t:void 0,s="string"!=typeof t?{captureContext:t}:void 0;return(0,m.Gd)().captureMessage(e,n,s)}function v(e,t){return(0,m.Gd)().captureEvent(e,t)}function E(e){(0,m.Gd)().configureScope(e)}function S(e){(0,m.Gd)().addBreadcrumb(e)}function T(e,t){(0,m.Gd)().setContext(e,t)}function k(e){(0,m.Gd)().setExtras(e)}function w(e,t){(0,m.Gd)().setExtra(e,t)}function I(e){(0,m.Gd)().setTags(e)}function x(e,t){(0,m.Gd)().setTag(e,t)}function C(e){(0,m.Gd)().setUser(e)}function O(e){(0,m.Gd)().withScope(e)}function R(e,t){return(0,m.Gd)().startTransaction({...e},t)}class D extends Error{constructor(e,t="warn"){super(e),this.message=e,this.name=new.target.prototype.constructor.name,Object.setPrototypeOf(this,new.target.prototype),this.logLevel=t}}var N=n(6893);const A=/^(?:(\w+):)\/\/(?:(\w+)(?::(\w+)?)?@)([\w.-]+)(?::(\d+))?\/(.+)/;function P(e,t=!1){const{host:n,path:s,pass:i,port:r,projectId:o,protocol:a,publicKey:c}=e;return`${a}://${c}${t&&i?`:${i}`:""}@${n}${r?`:${r}`:""}/${s?`${s}/`:s}${o}`}function U(e){return{protocol:e.protocol,publicKey:e.publicKey||"",pass:e.pass||"",host:e.host,port:e.port||"",path:e.path||"",projectId:e.projectId}}var $=n(7597),M=n(6147);function j(e,t=100,n=1/0){try{return B("",e,t,n)}catch(e){return{ERROR:`**non-serializable** (${e})`}}}function G(e,t=3,n=102400){const s=j(e,t);return i=s,function(e){return~-encodeURI(e).split(/%..|./).length}(JSON.stringify(i))>n?G(e,t-1,n):s;var i}function B(e,t,n=1/0,s=1/0,i=function(){const e="function"==typeof WeakSet,t=e?new WeakSet:[];return[function(n){if(e)return!!t.has(n)||(t.add(n),!1);for(let e=0;e<t.length;e++)if(t[e]===n)return!0;return t.push(n),!1},function(n){if(e)t.delete(n);else for(let e=0;e<t.length;e++)if(t[e]===n){t.splice(e,1);break}}]}()){const[r,o]=i;if(null==t||["number","boolean","string"].includes(typeof t)&&!(0,$.i2)(t))return t;const c=function(e,t){try{if("domain"===e&&t&&"object"==typeof t&&t._events)return"[Domain]";if("domainEmitter"===e)return"[DomainEmitter]";if("undefined"!=typeof global&&t===global)return"[Global]";if("undefined"!=typeof window&&t===window)return"[Window]";if("undefined"!=typeof document&&t===document)return"[Document]";if((0,$.Cy)(t))return"[SyntheticEvent]";if("number"==typeof t&&t!=t)return"[NaN]";if("function"==typeof t)return`[Function: ${(0,M.$P)(t)}]`;if("symbol"==typeof t)return`[${String(t)}]`;if("bigint"==typeof t)return`[BigInt: ${String(t)}]`;const n=function(e){const t=Object.getPrototypeOf(e);return t?t.constructor.name:"null prototype"}(t);return/^HTML(\w*)Element$/.test(n)?`[HTMLElement: ${n}]`:`[object ${n}]`}catch(e){return`**non-serializable** (${e})`}}(e,t);if(!c.startsWith("[object "))return c;if(t.__sentry_skip_normalization__)return t;const u="number"==typeof t.__sentry_override_normalization_depth__?t.__sentry_override_normalization_depth__:n;if(0===u)return c.replace("object ","");if(r(t))return"[Circular ~]";const l=t;if(l&&"function"==typeof l.toJSON)try{return B("",l.toJSON(),u-1,s,i)}catch(e){}const d=Array.isArray(t)?[]:{};let p=0;const h=(0,a.Sh)(t);for(const e in h){if(!Object.prototype.hasOwnProperty.call(h,e))continue;if(p>=s){d[e]="[MaxProperties ~]";break}const t=h[e];d[e]=B(e,t,u-1,s,i),p++}return o(t),d}function Y(e,t=[]){return[e,t]}function F(e,t){const[n,s]=e;return[n,[...s,t]]}function q(e,t){const n=e[1];for(const e of n)if(t(e,e[0].type))return!0;return!1}function L(e,t){return(t||new TextEncoder).encode(e)}function V(e,t){const[n,s]=e;let i=JSON.stringify(n);function r(e){"string"==typeof i?i="string"==typeof e?i+e:[L(i,t),e]:i.push("string"==typeof e?L(e,t):e)}for(const e of s){const[t,n]=e;if(r(`\n${JSON.stringify(t)}\n`),"string"==typeof n||n instanceof Uint8Array)r(n);else{let e;try{e=JSON.stringify(n)}catch(t){e=JSON.stringify(j(n))}r(e)}}return"string"==typeof i?i:function(e){const t=e.reduce(((e,t)=>e+t.length),0),n=new Uint8Array(t);let s=0;for(const t of e)n.set(t,s),s+=t.length;return n}(i)}function H(e,t){const n="string"==typeof e.data?L(e.data,t):e.data;return[(0,a.Jr)({type:"attachment",length:n.length,filename:e.filename,content_type:e.contentType,attachment_type:e.attachmentType}),n]}const z={session:"session",sessions:"session",attachment:"attachment",transaction:"transaction",event:"error",client_report:"internal",user_report:"default",profile:"profile",replay_event:"replay",replay_recording:"replay",check_in:"monitor"};function J(e){return z[e]}function W(e){if(!e||!e.sdk)return;const{name:t,version:n}=e.sdk;return{name:t,version:n}}const X=6e4;const Z=30;function K(e,t,n=function(e){const t=[];function n(e){return t.splice(t.indexOf(e),1)[0]}return{$:t,add:function(s){if(!(void 0===e||t.length<e))return(0,N.$2)(new D("Not adding Promise because buffer limit was reached."));const i=s();return-1===t.indexOf(i)&&t.push(i),i.then((()=>n(i))).then(null,(()=>n(i).then(null,(()=>{})))),i},drain:function(e){return new N.cW(((n,s)=>{let i=t.length;if(!i)return n(!0);const r=setTimeout((()=>{e&&e>0&&n(!1)}),e);t.forEach((e=>{(0,N.WD)(e).then((()=>{--i||(clearTimeout(r),n(!0))}),s)}))}))}}}(e.bufferSize||Z)){let s={};function i(i){const r=[];if(q(i,((t,n)=>{const i=J(n);if(function(e,t,n=Date.now()){return function(e,t){return e[t]||e.all||0}(e,t)>n}(s,i)){const s=Q(t,n);e.recordDroppedEvent("ratelimit_backoff",i,s)}else r.push(t)})),0===r.length)return(0,N.WD)();const o=Y(i[0],r),a=t=>{q(o,((n,s)=>{const i=Q(n,s);e.recordDroppedEvent(t,J(s),i)}))};return n.add((()=>t({body:V(o,e.textEncoder)}).then((e=>(void 0!==e.statusCode&&(e.statusCode<200||e.statusCode>=300)&&("undefined"==typeof __SENTRY_DEBUG__||__SENTRY_DEBUG__)&&l.kg.warn(`Sentry responded with status code ${e.statusCode} to sent event.`),s=function(e,{statusCode:t,headers:n},s=Date.now()){const i={...e},r=n&&n["x-sentry-rate-limits"],o=n&&n["retry-after"];if(r)for(const e of r.trim().split(",")){const[t,n]=e.split(":",2),r=parseInt(t,10),o=1e3*(isNaN(r)?60:r);if(n)for(const e of n.split(";"))i[e]=s+o;else i.all=s+o}else o?i.all=s+function(e,t=Date.now()){const n=parseInt(`${e}`,10);if(!isNaN(n))return 1e3*n;const s=Date.parse(`${e}`);return isNaN(s)?X:s-t}(o,s):429===t&&(i.all=s+6e4);return i}(s,e),e)),(e=>{throw a("network_error"),e})))).then((e=>e),(e=>{if(e instanceof D)return("undefined"==typeof __SENTRY_DEBUG__||__SENTRY_DEBUG__)&&l.kg.error("Skipped sending event because buffer is full."),a("queue_overflow"),(0,N.WD)();throw e}))}return i.__sentry__baseTransport__=!0,{send:i,flush:e=>n.drain(e)}}function Q(e,t){if("event"===t||"transaction"===t)return Array.isArray(e)?e[1]:void 0}var ee=n(350),te=n(7638),ne=n(9791),se=n(8903),ie=n(1250),re=n(6046);function oe(){const e=re.G.map((e=>{try{return e()}catch(e){return}})).filter((e=>!!e));return 0===e.length&&l.kg.warn("Performance monitoring integrations could not be automatically loaded."),e.filter((e=>!!e.loadDependency()))}var ae=n(4307);const ce=[];function ue(e){const t=e.defaultIntegrations||[],n=e.integrations;let s;t.forEach((e=>{e.isDefaultInstance=!0})),s=Array.isArray(n)?[...t,...n]:"function"==typeof n?(0,d.lE)(n(t)):t;const i=function(e){const t={};return e.forEach((e=>{const{name:n}=e,s=t[n];s&&!s.isDefaultInstance&&e.isDefaultInstance||(t[n]=e)})),Object.keys(t).map((e=>t[e]))}(s),r=function(e,t){for(let t=0;t<e.length;t++)if(!0==("Debug"===e[t].name))return t;return-1}(i);if(-1!==r){const[e]=i.splice(r,1);i.push(e)}return i}function le(e,t){t[e.name]=e,-1===ce.indexOf(e.name)&&(e.setupOnce(ee.c,m.Gd),ce.push(e.name),("undefined"==typeof __SENTRY_DEBUG__||__SENTRY_DEBUG__)&&l.kg.log(`Integration installed: ${e.name}`))}var de=n(9015),pe=n(1170),he=n(1235),fe=n(1131);const _e=new WeakMap,ge="Not capturing exception because it's already been captured.";class me{__init(){this._integrations={}}__init2(){this._integrationsInitialized=!1}__init3(){this._numProcessing=0}__init4(){this._outcomes={}}__init5(){this._hooks={}}constructor(e){if(me.prototype.__init.call(this),me.prototype.__init2.call(this),me.prototype.__init3.call(this),me.prototype.__init4.call(this),me.prototype.__init5.call(this),this._options=e,e.dsn){this._dsn=function(e){const t="string"==typeof e?function(e){const t=A.exec(e);if(!t)throw new D(`Invalid Sentry Dsn: ${e}`);const[n,s,i="",r,o="",a]=t.slice(1);let c="",u=a;const l=u.split("/");if(l.length>1&&(c=l.slice(0,-1).join("/"),u=l.pop()),u){const e=u.match(/^\d+/);e&&(u=e[0])}return U({host:r,pass:i,path:c,projectId:u,port:o,protocol:n,publicKey:s})}(e):U(e);return function(e){if("undefined"!=typeof __SENTRY_DEBUG__&&!__SENTRY_DEBUG__)return;const{port:t,projectId:n,protocol:s}=e;if(["protocol","publicKey","host","projectId"].forEach((t=>{if(!e[t])throw new D(`Invalid Sentry Dsn: ${t} missing`)})),!n.match(/^\d+$/))throw new D(`Invalid Sentry Dsn: Invalid projectId ${n}`);if(!function(e){return"http"===e||"https"===e}(s))throw new D(`Invalid Sentry Dsn: Invalid protocol ${s}`);if(t&&isNaN(parseInt(t,10)))throw new D(`Invalid Sentry Dsn: Invalid port ${t}`)}(t),t}(e.dsn);const t=function(e,t={}){const n="string"==typeof t?t:t.tunnel,s="string"!=typeof t&&t._metadata?t._metadata.sdk:void 0;return n||`${function(e){return`${function(e){const t=e.protocol?`${e.protocol}:`:"",n=e.port?`:${e.port}`:"";return`${t}//${e.host}${n}${e.path?`/${e.path}`:""}/api/`}(e)}${e.projectId}/envelope/`}(e)}?${function(e,t){return(0,a._j)({sentry_key:e.publicKey,sentry_version:"7",...t&&{sentry_client:`${t.name}/${t.version}`}})}(e,s)}`}(this._dsn,e);this._transport=e.transport({recordDroppedEvent:this.recordDroppedEvent.bind(this),...e.transportOptions,url:t})}else("undefined"==typeof __SENTRY_DEBUG__||__SENTRY_DEBUG__)&&l.kg.warn("No DSN provided, client will not do anything.")}captureException(e,t,n){if((0,d.YO)(e))return void(("undefined"==typeof __SENTRY_DEBUG__||__SENTRY_DEBUG__)&&l.kg.log(ge));let s=t&&t.event_id;return this._process(this.eventFromException(e,t).then((e=>this._captureEvent(e,t,n))).then((e=>{s=e}))),s}captureMessage(e,t,n,s){let i=n&&n.event_id;const r=(0,$.pt)(e)?this.eventFromMessage(String(e),t,n):this.eventFromException(e,n);return this._process(r.then((e=>this._captureEvent(e,n,s))).then((e=>{i=e}))),i}captureEvent(e,t,n){if(t&&t.originalException&&(0,d.YO)(t.originalException))return void(("undefined"==typeof __SENTRY_DEBUG__||__SENTRY_DEBUG__)&&l.kg.log(ge));let s=t&&t.event_id;return this._process(this._captureEvent(e,t,n).then((e=>{s=e}))),s}captureSession(e){this._isEnabled()?"string"!=typeof e.release?("undefined"==typeof __SENTRY_DEBUG__||__SENTRY_DEBUG__)&&l.kg.warn("Discarded session because of missing or non-string release"):(this.sendSession(e),(0,de.CT)(e,{init:!1})):("undefined"==typeof __SENTRY_DEBUG__||__SENTRY_DEBUG__)&&l.kg.warn("SDK not enabled, will not capture session.")}getDsn(){return this._dsn}getOptions(){return this._options}getSdkMetadata(){return this._options._metadata}getTransport(){return this._transport}flush(e){const t=this._transport;return t?this._isClientDoneProcessing(e).then((n=>t.flush(e).then((e=>n&&e)))):(0,N.WD)(!0)}close(e){return this.flush(e).then((e=>(this.getOptions().enabled=!1,e)))}setupIntegrations(){this._isEnabled()&&!this._integrationsInitialized&&(this._integrations=function(e){const t={};return e.forEach((e=>{e&&le(e,t)})),t}(this._options.integrations),this._integrationsInitialized=!0)}getIntegrationById(e){return this._integrations[e]}getIntegration(e){try{return this._integrations[e.id]||null}catch(t){return("undefined"==typeof __SENTRY_DEBUG__||__SENTRY_DEBUG__)&&l.kg.warn(`Cannot retrieve integration ${e.id} from the current Client`),null}}addIntegration(e){le(e,this._integrations)}sendEvent(e,t={}){if(this._dsn){let n=function(e,t,n,s){const i=W(n),r=e.type&&"replay_event"!==e.type?e.type:"event";!function(e,t){t&&(e.sdk=e.sdk||{},e.sdk.name=e.sdk.name||t.name,e.sdk.version=e.sdk.version||t.version,e.sdk.integrations=[...e.sdk.integrations||[],...t.integrations||[]],e.sdk.packages=[...e.sdk.packages||[],...t.packages||[]])}(e,n&&n.sdk);const o=function(e,t,n,s){const i=e.sdkProcessingMetadata&&e.sdkProcessingMetadata.dynamicSamplingContext;return{event_id:e.event_id,sent_at:(new Date).toISOString(),...t&&{sdk:t},...!!n&&{dsn:P(s)},...i&&{trace:(0,a.Jr)({...i})}}}(e,i,s,t);return delete e.sdkProcessingMetadata,Y(o,[[{type:r},e]])}(e,this._dsn,this._options._metadata,this._options.tunnel);for(const e of t.attachments||[])n=F(n,H(e,this._options.transportOptions&&this._options.transportOptions.textEncoder));const s=this._sendEnvelope(n);s&&s.then((t=>this.emit("afterSendEvent",e,t)),null)}}sendSession(e){if(this._dsn){const t=function(e,t,n,s){const i=W(n);return Y({sent_at:(new Date).toISOString(),...i&&{sdk:i},...!!s&&{dsn:P(t)}},["aggregates"in e?[{type:"sessions"},e]:[{type:"session"},e]])}(e,this._dsn,this._options._metadata,this._options.tunnel);this._sendEnvelope(t)}}recordDroppedEvent(e,t,n){if(this._options.sendClientReports){const n=`${e}:${t}`;("undefined"==typeof __SENTRY_DEBUG__||__SENTRY_DEBUG__)&&l.kg.log(`Adding outcome: "${n}"`),this._outcomes[n]=this._outcomes[n]+1||1}}on(e,t){this._hooks[e]||(this._hooks[e]=[]),this._hooks[e].push(t)}emit(e,...t){this._hooks[e]&&this._hooks[e].forEach((e=>e(...t)))}_updateSessionFromEvent(e,t){let n=!1,s=!1;const i=t.exception&&t.exception.values;if(i){s=!0;for(const e of i){const t=e.mechanism;if(t&&!1===t.handled){n=!0;break}}}const r="ok"===e.status;(r&&0===e.errors||r&&n)&&((0,de.CT)(e,{...n&&{status:"crashed"},errors:e.errors||Number(s||n)}),this.captureSession(e))}_isClientDoneProcessing(e){return new N.cW((t=>{let n=0;const s=setInterval((()=>{0==this._numProcessing?(clearInterval(s),t(!0)):(n+=1,e&&n>=e&&(clearInterval(s),t(!1)))}),1)}))}_isEnabled(){return!1!==this.getOptions().enabled&&void 0!==this._dsn}_prepareEvent(e,t,n){const s=this.getOptions(),i=Object.keys(this._integrations);return!t.integrations&&i.length>0&&(t.integrations=i),function(e,t,n,s){const{normalizeDepth:i=3,normalizeMaxBreadth:r=1e3}=e,o={...t,event_id:t.event_id||n.event_id||(0,d.DM)(),timestamp:t.timestamp||(0,pe.yW)()},a=n.integrations||e.integrations.map((e=>e.name));!function(e,t){const{environment:n,release:s,dist:i,maxValueLength:r=250}=t;"environment"in e||(e.environment="environment"in t?n:fe.J),void 0===e.release&&void 0!==s&&(e.release=s),void 0===e.dist&&void 0!==i&&(e.dist=i),e.message&&(e.message=(0,p.$G)(e.message,r));const o=e.exception&&e.exception.values&&e.exception.values[0];o&&o.value&&(o.value=(0,p.$G)(o.value,r));const a=e.request;a&&a.url&&(a.url=(0,p.$G)(a.url,r))}(o,e),function(e,t){t.length>0&&(e.sdk=e.sdk||{},e.sdk.integrations=[...e.sdk.integrations||[],...t])}(o,a),void 0===t.type&&function(e,t){const n=he.n2._sentryDebugIds;if(!n)return;let s;const i=_e.get(t);i?s=i:(s=new Map,_e.set(t,s));const r=Object.keys(n).reduce(((e,i)=>{let r;const o=s.get(i);o?r=o:(r=t(i),s.set(i,r));for(let t=r.length-1;t>=0;t--){const s=r[t];if(s.filename){e[s.filename]=n[i];break}}return e}),{}),o=new Set;try{e.exception.values.forEach((e=>{e.stacktrace.frames.forEach((e=>{e.filename&&o.add(e.filename)}))}))}catch(e){}e.debug_meta=e.debug_meta||{},e.debug_meta.images=e.debug_meta.images||[];const a=e.debug_meta.images;o.forEach((e=>{r[e]&&a.push({type:"sourcemap",code_file:e,debug_id:r[e]})}))}(o,e.stackParser);let c=s;n.captureContext&&(c=ee.s.clone(c).update(n.captureContext));let u=(0,N.WD)(o);if(c){if(c.getAttachments){const e=[...n.attachments||[],...c.getAttachments()];e.length&&(n.attachments=e)}u=c.applyToEvent(o,n)}return u.then((e=>"number"==typeof i&&i>0?function(e,t,n){if(!e)return null;const s={...e,...e.breadcrumbs&&{breadcrumbs:e.breadcrumbs.map((e=>({...e,...e.data&&{data:j(e.data,t,n)}})))},...e.user&&{user:j(e.user,t,n)},...e.contexts&&{contexts:j(e.contexts,t,n)},...e.extra&&{extra:j(e.extra,t,n)}};return e.contexts&&e.contexts.trace&&s.contexts&&(s.contexts.trace=e.contexts.trace,e.contexts.trace.data&&(s.contexts.trace.data=j(e.contexts.trace.data,t,n))),e.spans&&(s.spans=e.spans.map((e=>(e.data&&(e.data=j(e.data,t,n)),e)))),s}(e,i,r):e))}(s,e,t,n)}_captureEvent(e,t={},n){return this._processEvent(e,t,n).then((e=>e.event_id),(e=>{if("undefined"==typeof __SENTRY_DEBUG__||__SENTRY_DEBUG__){const t=e;"log"===t.logLevel?l.kg.log(t.message):l.kg.warn(t)}}))}_processEvent(e,t,n){const s=this.getOptions(),{sampleRate:i}=s;if(!this._isEnabled())return(0,N.$2)(new D("SDK not enabled, will not capture event.","log"));const r=be(e),o=ye(e),a=e.type||"error",c=`before send for type \`${a}\``;if(o&&"number"==typeof i&&Math.random()>i)return this.recordDroppedEvent("sample_rate","error",e),(0,N.$2)(new D(`Discarding event because it's not included in the random sample (sampling rate = ${i})`,"log"));const u="replay_event"===a?"replay":a;return this._prepareEvent(e,t,n).then((n=>{if(null===n)throw this.recordDroppedEvent("event_processor",u,e),new D("An event processor returned `null`, will not send event.","log");if(t.data&&!0===t.data.__sentry__)return n;const i=function(e,t,n){const{beforeSend:s,beforeSendTransaction:i}=e;return ye(t)&&s?s(t,n):be(t)&&i?i(t,n):t}(s,n,t);return function(e,t){const n=`${t} must return \`null\` or a valid event.`;if((0,$.J8)(e))return e.then((e=>{if(!(0,$.PO)(e)&&null!==e)throw new D(n);return e}),(e=>{throw new D(`${t} rejected with ${e}`)}));if(!(0,$.PO)(e)&&null!==e)throw new D(n);return e}(i,c)})).then((s=>{if(null===s)throw this.recordDroppedEvent("before_send",u,e),new D(`${c} returned \`null\`, will not send event.`,"log");const i=n&&n.getSession();!r&&i&&this._updateSessionFromEvent(i,s);const o=s.transaction_info;if(r&&o&&s.transaction!==e.transaction){const e="custom";s.transaction_info={...o,source:e}}return this.sendEvent(s,t),s})).then(null,(e=>{if(e instanceof D)throw e;throw this.captureException(e,{data:{__sentry__:!0},originalException:e}),new D(`Event processing pipeline threw an error, original event will not be sent. Details have been sent as a new event.\nReason: ${e}`)}))}_process(e){this._numProcessing++,e.then((e=>(this._numProcessing--,e)),(e=>(this._numProcessing--,e)))}_sendEnvelope(e){if(this._transport&&this._dsn)return this.emit("beforeEnvelope",e),this._transport.send(e).then(null,(e=>{("undefined"==typeof __SENTRY_DEBUG__||__SENTRY_DEBUG__)&&l.kg.error("Error while sending event:",e)}));("undefined"==typeof __SENTRY_DEBUG__||__SENTRY_DEBUG__)&&l.kg.error("Transport disabled")}_clearOutcomes(){const e=this._outcomes;return this._outcomes={},Object.keys(e).map((t=>{const[n,s]=t.split(":");return{reason:n,category:s,quantity:e[t]}}))}}function ye(e){return void 0===e.type}function be(e){return"transaction"===e.type}var ve=n(6890);class Ee{__init(){this.flushTimeout=60}__init2(){this._pendingAggregates={}}__init3(){this._isEnabled=!0}constructor(e,t){Ee.prototype.__init.call(this),Ee.prototype.__init2.call(this),Ee.prototype.__init3.call(this),this._client=e,this._intervalId=setInterval((()=>this.flush()),1e3*this.flushTimeout),this._sessionAttrs=t}flush(){const e=this.getSessionAggregates();0!==e.aggregates.length&&(this._pendingAggregates={},this._client.sendSession(e))}getSessionAggregates(){const e=Object.keys(this._pendingAggregates).map((e=>this._pendingAggregates[parseInt(e)])),t={attrs:this._sessionAttrs,aggregates:e};return(0,a.Jr)(t)}close(){clearInterval(this._intervalId),this._isEnabled=!1,this.flush()}incrementSessionStatusCount(){if(!this._isEnabled)return;const e=(0,m.Gd)().getScope(),t=e.getRequestSession();t&&t.status&&(this._incrementSessionStatusCount(t.status,new Date),e.setRequestSession(void 0))}_incrementSessionStatusCount(e,t){const n=new Date(t).setSeconds(0,0);this._pendingAggregates[n]=this._pendingAggregates[n]||{};const s=this._pendingAggregates[n];switch(s.started||(s.started=new Date(n).toISOString()),e){case"errored":return s.errored=(s.errored||0)+1,s.errored;case"ok":return s.exited=(s.exited||0)+1,s.exited;default:return s.crashed=(s.crashed||0)+1,s.crashed}}}var Se=n(2037),Te=n(3837);function ke(e,t){return e(t.stack||"",1)}function we(e,t){const n={type:t.name||t.constructor.name,value:t.message},s=ke(e,t);return s.length&&(n.stacktrace={frames:s}),n}class Ie extends me{constructor(e){e._metadata=e._metadata||{},e._metadata.sdk=e._metadata.sdk||{name:"sentry.javascript.node",packages:[{name:"npm:@sentry/node",version:g}],version:g},e.transportOptions={textEncoder:new Te.TextEncoder,...e.transportOptions},(0,ve.T)(),super(e)}captureException(e,t,n){if(this._options.autoSessionTracking&&this._sessionFlusher&&n){const e=n.getRequestSession();e&&"ok"===e.status&&(e.status="errored")}return super.captureException(e,t,n)}captureEvent(e,t,n){if(this._options.autoSessionTracking&&this._sessionFlusher&&n&&"exception"===(e.type||"exception")&&e.exception&&e.exception.values&&e.exception.values.length>0){const e=n.getRequestSession();e&&"ok"===e.status&&(e.status="errored")}return super.captureEvent(e,t,n)}close(e){return(0,ae.x)([this,"access",e=>e._sessionFlusher,"optionalAccess",e=>e.close,"call",e=>e()]),super.close(e)}initSessionFlusher(){const{release:e,environment:t}=this._options;e?this._sessionFlusher=new Ee(this,{release:e,environment:t}):("undefined"==typeof __SENTRY_DEBUG__||__SENTRY_DEBUG__)&&l.kg.warn("Cannot initialise an instance of SessionFlusher if no release is provided!")}eventFromException(e,t){return(0,N.WD)(function(e,t,n){let s=t;const i=n&&n.data&&n.data.mechanism||{handled:!0,type:"generic"};if(!(0,$.VZ)(t)){if((0,$.PO)(t)){const e=`Non-Error exception captured with keys: ${(0,a.zf)(t)}`,i=(0,m.Gd)(),r=i.getClient(),o=r&&r.getOptions().normalizeDepth;i.configureScope((e=>{e.setExtra("__serialized__",G(t,o))})),s=n&&n.syntheticException||new Error(e),s.message=e}else s=n&&n.syntheticException||new Error(t),s.message=t;i.synthetic=!0}const r={exception:{values:[we(e,s)]}};return(0,d.Db)(r,void 0,void 0),(0,d.EG)(r,i),{...r,event_id:n&&n.event_id}}(this._options.stackParser,e,t))}eventFromMessage(e,t="info",n){return(0,N.WD)(function(e,t,n="info",s,i){const r={event_id:s&&s.event_id,level:n,message:t};if(i&&s&&s.syntheticException){const n=ke(e,s.syntheticException);n.length&&(r.exception={values:[{value:t,stacktrace:{frames:n}}]})}return r}(this._options.stackParser,e,t,n,this._options.attachStacktrace))}captureCheckIn(e,t){const n="in_progress"!==e.status&&e.checkInId?e.checkInId:(0,d.DM)();if(!this._isEnabled())return("undefined"==typeof __SENTRY_DEBUG__||__SENTRY_DEBUG__)&&l.kg.warn("SDK not enabled, will not capture checkin."),n;const s=this.getOptions(),{release:i,environment:r,tunnel:o}=s,a={check_in_id:n,monitor_slug:e.monitorSlug,status:e.status,release:i,environment:r};"in_progress"!==e.status&&(a.duration=e.duration),t&&(a.monitor_config={schedule:t.schedule,checkin_margin:t.checkinMargin,max_runtime:t.maxRuntime,timezone:t.timezone});const c=function(e,t,n,s){const i={sent_at:(new Date).toISOString(),...t&&t.sdk&&{sdk:{name:t.sdk.name,version:t.sdk.version}},...!!n&&!!s&&{dsn:P(s)}},r=function(e){return[{type:"check_in"},e]}(e);return Y(i,[r])}(a,this.getSdkMetadata(),o,this.getDsn());return this._sendEnvelope(c),n}_prepareEvent(e,t,n){return e.platform=e.platform||"node",e.contexts={...e.contexts,runtime:(0,ae.x)([e,"access",e=>e.contexts,"optionalAccess",e=>e.runtime])||{name:"node",version:global.process.version}},e.server_name=e.server_name||this.getOptions().serverName||global.process.env.SENTRY_NAME||Se.hostname(),super._prepareEvent(e,t,n)}_captureRequestSession(){this._sessionFlusher?this._sessionFlusher.incrementSessionStatusCount():("undefined"==typeof __SENTRY_DEBUG__||__SENTRY_DEBUG__)&&l.kg.warn("Discarded request mode session because autoSessionTracking option was disabled")}}function xe(e,t){return null!=e?e:t()}var Ce=n(3685),Oe=n(5687),Re=n(6018),De=n(2781),Ne=n(7310);const Ae=require("zlib"),Pe=32768;function Ue(e){let t;try{t=new Ne.URL(e.url)}catch(t){return console.warn("[@sentry/node]: Invalid dsn or tunnel option, will not send any events. The tunnel option must be a full URL when used."),K(e,(()=>Promise.resolve({})))}const n="https:"===t.protocol,s=function(e,t){const{no_proxy:n}=process.env;return n&&n.split(",").some((t=>e.host.endsWith(t)||e.hostname.endsWith(t)))?void 0:t}(t,e.proxy||(n?process.env.https_proxy:void 0)||process.env.http_proxy),i=n?Oe:Ce,r=void 0!==e.keepAlive&&e.keepAlive,o=s?new Re.HttpsProxyAgent(s):new i.Agent({keepAlive:r,maxSockets:30,timeout:2e3}),a=function(e,t,n){const{hostname:s,pathname:i,port:r,protocol:o,search:a}=new Ne.URL(e.url);return function(c){return new Promise(((u,l)=>{let d=function(e){return new De.Readable({read(){this.push(e),this.push(null)}})}(c.body);const p={...e.headers};c.body.length>Pe&&(p["content-encoding"]="gzip",d=d.pipe((0,Ae.createGzip)()));const h=t.request({method:"POST",agent:n,headers:p,hostname:s,path:`${i}${a}`,port:r,protocol:o,ca:e.caCerts},(e=>{e.on("data",(()=>{})),e.on("end",(()=>{})),e.setEncoding("utf8");const t=xe(e.headers["retry-after"],(()=>null)),n=xe(e.headers["x-sentry-rate-limits"],(()=>null));u({statusCode:e.statusCode,headers:{"retry-after":t,"x-sentry-rate-limits":Array.isArray(n)?n[0]:n}})}));h.on("error",l),d.pipe(h)}))}}(e,xe(e.httpModule,(()=>i)),o);return K(e,a)}var $e=n(9656);const Me=require("domain");function je(){return Me.active}function Ge(){const e=je();if(e)return(0,m.uZ)(e),(0,m.vi)(e)}function Be(e,t){const n=je();if(n&&(0,ae.x)([t,"optionalAccess",e=>e.reuseExisting]))return e();const s=Me.create(),i=function(e){const t={};return(0,m.uZ)(t,e),(0,m.vi)(t)}(n?(0,m.vi)(n):void 0);return(0,m.j0)(s,i),s.bind((()=>e()))()}const Ye=require("async_hooks");function Fe(){$e.V.major&&$e.V.major>=14?function(){const e=new Ye.AsyncLocalStorage;function t(){return e.getStore()}(0,m.$b)({getCurrentHub:t,runWithAsyncContext:function(n,s){const i=t();if(i&&(0,ae.x)([s,"optionalAccess",e=>e.reuseExisting]))return n();const r=function(e){const t={};return(0,m.uZ)(t,e),(0,m.vi)(t)}(i);return e.run(r,(()=>n()))}})}():(0,m.$b)({getCurrentHub:Ge,runWithAsyncContext:Be})}const qe=["fatal","error","warning","log","info","debug"];class Le{constructor(){Le.prototype.__init.call(this)}static __initStatic(){this.id="Console"}__init(){this.name=Le.id}setupOnce(){for(const e of["debug","info","warn","error","log"])(0,a.hl)(console,e,Ve(e))}}function Ve(e){return function(t){const n=function(e){return"warn"===e?"warning":qe.includes(e)?e:"log"}(e);return function(){(0,m.Gd)().getIntegration(Le)&&(0,m.Gd)().addBreadcrumb({category:"console",level:n,message:Te.format.apply(void 0,arguments)},{input:[...arguments],level:e}),t.apply(this,arguments)}}}Le.__initStatic();var He=n(9181),ze=n(7612),Je=n(7578);class We{static __initStatic(){this.id="Http"}__init(){this.name=We.id}constructor(e={}){We.prototype.__init.call(this),this._breadcrumbs=void 0===e.breadcrumbs||e.breadcrumbs,this._tracing=e.tracing?!0===e.tracing?{}:e.tracing:void 0}setupOnce(e,t){if(!this._breadcrumbs&&!this._tracing)return;const s=(0,ae.x)([t,"call",e=>e(),"access",e=>e.getClient,"call",e=>e(),"optionalAccess",e=>e.getOptions,"call",e=>e()]);if(s&&"sentry"!==s.instrumenter)return void(("undefined"==typeof __SENTRY_DEBUG__||__SENTRY_DEBUG__)&&l.kg.log("HTTP Integration is skipped because of instrumenter configuration."));const i=this._tracing?{...s,...this._tracing}:void 0,r=n(3685),o=Xe(this._breadcrumbs,i,r);if((0,a.hl)(r,"get",o),(0,a.hl)(r,"request",o),$e.V.major&&$e.V.major>8){const e=n(5687),t=Xe(this._breadcrumbs,i,e);(0,a.hl)(e,"get",t),(0,a.hl)(e,"request",t)}}}function Xe(e,t,n){const s=new ze.LRUMap(100),i={};return function(r){return function(...o){const a=(0,Je.nY)(n,o),c=a[0],u=(0,Je.lx)(c),d=(0,Je.CA)(c);if((0,Je.ZB)(d))return r.apply(n,a);let h,f;const _=(0,m.Gd)().getScope(),g=c.method||"GET",y={url:d,"http.method":g};if(c.hash&&(y["http.fragment"]=c.hash.substring(1)),c.search&&(y["http.query"]=c.search.substring(1)),_&&t&&(e=>{if(void 0===(0,ae.x)([t,"optionalAccess",e=>e.shouldCreateSpanForRequest]))return!0;const n=s.get(e);if(void 0!==n)return n;const i=t.shouldCreateSpanForRequest(e);return s.set(e,i),i})(u)&&(f=_.getSpan(),f))if(h=f.startChild({description:`${g} ${y.url}`,op:"http.client",data:y}),(e=>void 0===(0,ae.x)([t,"optionalAccess",e=>e.tracePropagationTargets])||(i[e]||(i[e]=(0,p.U0)(e,t.tracePropagationTargets)),i[e]))(u)){const e=h.toTraceparent();if(("undefined"==typeof __SENTRY_DEBUG__||__SENTRY_DEBUG__)&&l.kg.log(`[Tracing] Adding sentry-trace header ${e} to outgoing request to "${d}": `),c.headers={...c.headers,"sentry-trace":e},f.transaction){const e=f.transaction.getDynamicSamplingContext(),t=(0,He.IQ)(e);let n;n=c.headers&&c.headers.baggage?t?Array.isArray(c.headers.baggage)?[...c.headers.baggage,t]:[c.headers.baggage,t]:c.headers.baggage:t,c.headers={...c.headers,...n&&{baggage:n}}}}else("undefined"==typeof __SENTRY_DEBUG__||__SENTRY_DEBUG__)&&l.kg.log(`[Tracing] Not adding sentry-trace header to outgoing request (${d}) due to mismatching tracePropagationTargets option.`);return r.apply(n,a).once("response",(function(t){e&&Ze("response",y,this,t),h&&(t.statusCode&&h.setHttpStatus(t.statusCode),h.description=(0,Je.Dt)(h.description,c,this),h.finish())})).once("error",(function(){e&&Ze("error",y,this),h&&(h.setHttpStatus(500),h.description=(0,Je.Dt)(h.description,c,this),h.finish())}))}}}function Ze(e,t,n,s){(0,m.Gd)().getIntegration(We)&&(0,m.Gd)().addBreadcrumb({category:"http",data:{status_code:s&&s.statusCode,...t},type:"http"},{event:e,request:n,response:s})}function Ke(e){console.error(e&&e.stack?e.stack:e);const t=(0,m.Gd)().getClient();void 0===t&&(("undefined"==typeof __SENTRY_DEBUG__||__SENTRY_DEBUG__)&&l.kg.warn("No NodeClient was defined, we are exiting the process now."),global.process.exit(1));const n=t.getOptions(),s=n&&n.shutdownTimeout&&n.shutdownTimeout>0&&n.shutdownTimeout||2e3;t.close(s).then((e=>{e||("undefined"==typeof __SENTRY_DEBUG__||__SENTRY_DEBUG__)&&l.kg.warn("We reached the timeout for emptying the request buffer, still exiting now!"),global.process.exit(1)}),(e=>{("undefined"==typeof __SENTRY_DEBUG__||__SENTRY_DEBUG__)&&l.kg.error(e)}))}We.__initStatic();class Qe{static __initStatic(){this.id="OnUncaughtException"}__init(){this.name=Qe.id}__init2(){this.handler=this._makeErrorHandler()}constructor(e={}){Qe.prototype.__init.call(this),Qe.prototype.__init2.call(this),this._options={exitEvenIfOtherHandlersAreRegistered:!0,...e}}setupOnce(){global.process.on("uncaughtException",this.handler)}_makeErrorHandler(){let e,t=!1,n=!1,s=!1;return i=>{let r=Ke;const o=(0,m.Gd)().getClient();this._options.onFatalError?r=this._options.onFatalError:o&&o.getOptions().onFatalError&&(r=o.getOptions().onFatalError);const a=0===global.process.listeners("uncaughtException").reduce(((e,t)=>"domainUncaughtExceptionClear"===t.name||t.tag&&"sentry_tracingErrorCallback"===t.tag||t===this.handler?e:e+1),0),c=this._options.exitEvenIfOtherHandlersAreRegistered||a;if(t)c&&(s?(("undefined"==typeof __SENTRY_DEBUG__||__SENTRY_DEBUG__)&&l.kg.warn("uncaught exception after calling fatal error shutdown callback - this is bad! forcing shutdown"),Ke(i)):n||(n=!0,setTimeout((()=>{s||(s=!0,r(e,i))}),2e3)));else{const n=(0,m.Gd)();e=i,t=!0,n.getIntegration(Qe)?n.withScope((e=>{e.setLevel("fatal"),n.captureException(i,{originalException:i,data:{mechanism:{handled:!1,type:"onuncaughtexception"}}}),!s&&c&&(s=!0,r(i))})):!s&&c&&(s=!0,r(i))}}}}Qe.__initStatic();class et{static __initStatic(){this.id="OnUnhandledRejection"}__init(){this.name=et.id}constructor(e={mode:"warn"}){this._options=e,et.prototype.__init.call(this)}setupOnce(){global.process.on("unhandledRejection",this.sendUnhandledPromise.bind(this))}sendUnhandledPromise(e,t){const n=(0,m.Gd)();n.getIntegration(et)&&n.withScope((s=>{s.setExtra("unhandledPromiseRejection",!0),n.captureException(e,{originalException:t,data:{mechanism:{handled:!1,type:"onunhandledrejection"}}})})),this._handleRejection(e)}_handleRejection(e){const t="This error originated either by throwing inside of an async function without a catch block, or by rejecting a promise which was not handled with .catch(). The promise rejected with the reason:";"warn"===this._options.mode?(0,l.Cf)((()=>{console.warn(t),console.error(e&&e.stack?e.stack:e)})):"strict"===this._options.mode&&((0,l.Cf)((()=>{console.warn(t)})),Ke(e))}}et.__initStatic();const tt=require("fs"),nt=new ze.LRUMap(100);class st{static __initStatic(){this.id="ContextLines"}__init(){this.name=st.id}constructor(e={}){this._options=e,st.prototype.__init.call(this)}get _contextLines(){return void 0!==this._options.frameContextLines?this._options.frameContextLines:7}setupOnce(e){e((e=>this.addSourceContext(e)))}async addSourceContext(e){const t={},n=[];if(this._contextLines>0&&(0,ae.x)([e,"access",e=>e.exception,"optionalAccess",e=>e.values]))for(const s of e.exception.values)if((0,ae.x)([s,"access",e=>e.stacktrace,"optionalAccess",e=>e.frames]))for(let e=s.stacktrace.frames.length-1;e>=0;e--){const i=s.stacktrace.frames[e];!i.filename||t[i.filename]||nt.get(i.filename)||(n.push(it(i.filename)),t[i.filename]=1)}if(n.length>0&&await Promise.all(n),this._contextLines>0&&(0,ae.x)([e,"access",e=>e.exception,"optionalAccess",e=>e.values]))for(const t of e.exception.values)t.stacktrace&&t.stacktrace.frames&&await this.addSourceContextToFrames(t.stacktrace.frames);return e}addSourceContextToFrames(e){for(const t of e)if(t.filename&&void 0===t.context_line){const e=nt.get(t.filename);if(e)try{(0,d.go)(e,t,this._contextLines)}catch(e){}}}}async function it(e){const t=nt.get(e);if(null===t)return null;if(void 0!==t)return t;let n=null;try{n=(await(s=e,new Promise(((e,t)=>{(0,tt.readFile)(s,"utf8",((n,s)=>{n?t(n):e(s)}))})))).split("\n")}catch(e){}var s;return nt.set(e,n),n}st.__initStatic();class rt{static __initStatic(){this.id="LinkedErrors"}__init(){this.name=rt.id}constructor(e={}){rt.prototype.__init.call(this),this._key=e.key||"cause",this._limit=e.limit||5}setupOnce(){(0,ee.c)((async(e,t)=>{const n=(0,m.Gd)(),s=n.getIntegration(rt),i=n.getClient();return i&&s&&s._handler&&"function"==typeof s._handler&&await s._handler(i.getOptions().stackParser,e,t),e}))}_handler(e,t,n){return t.exception&&t.exception.values&&(0,$.V9)(n.originalException,Error)?new N.cW((s=>{this._walkErrorTree(e,n.originalException,this._key).then((e=>{t&&t.exception&&t.exception.values&&(t.exception.values=[...e,...t.exception.values]),s(t)})).then(null,(()=>{s(t)}))})):(0,N.WD)(t)}async _walkErrorTree(e,t,n,s=[]){if(!(0,$.V9)(t[n],Error)||s.length+1>=this._limit)return Promise.resolve(s);const i=we(e,t[n]),r=(0,m.Gd)().getIntegration(st);return r&&(0,ae.x)([i,"access",e=>e.stacktrace,"optionalAccess",e=>e.frames])&&await r.addSourceContextToFrames(i.stacktrace.frames),new Promise(((r,o)=>{this._walkErrorTree(e,t[n],n,[i,...s]).then(r).then(null,(()=>{o()}))}))}}rt.__initStatic();var ot=n(1017);let at;class ct{constructor(){ct.prototype.__init.call(this)}static __initStatic(){this.id="Modules"}__init(){this.name=ct.id}setupOnce(e,t){e((e=>t().getIntegration(ct)?{...e,modules:{...e.modules,...this._getModules()}}:e))}_getModules(){return at||(at=function(){const e=n.c[n.s]&&n.c[n.s].paths||[],t=function(){try{return n.c?Object.keys(n.c):[]}catch(e){return[]}}(),s={},i={};return t.forEach((t=>{let n=t;const r=()=>{const t=n;if(n=(0,ot.dirname)(t),!n||t===n||i[t])return;if(e.indexOf(n)<0)return r();const o=(0,ot.join)(t,"package.json");if(i[t]=!0,!(0,tt.existsSync)(o))return r();try{const e=JSON.parse((0,tt.readFileSync)(o,"utf8"));s[e.name]=e.version}catch(e){}};r()})),s}()),at}}ct.__initStatic();const ut=require("child_process"),lt=(0,Te.promisify)(tt.readFile),dt=(0,Te.promisify)(tt.readdir);class pt{static __initStatic(){this.id="Context"}__init(){this.name=pt.id}constructor(e={app:!0,os:!0,device:!0,culture:!0}){this._options=e,pt.prototype.__init.call(this)}setupOnce(e){e((e=>this.addContext(e)))}async addContext(e){void 0===this._cachedContext&&(this._cachedContext=this._getContexts());const t=this._updateContext(await this._cachedContext);return e.contexts={...e.contexts,app:{...t.app,...(0,ae.x)([e,"access",e=>e.contexts,"optionalAccess",e=>e.app])},os:{...t.os,...(0,ae.x)([e,"access",e=>e.contexts,"optionalAccess",e=>e.os])},device:{...t.device,...(0,ae.x)([e,"access",e=>e.contexts,"optionalAccess",e=>e.device])},culture:{...t.culture,...(0,ae.x)([e,"access",e=>e.contexts,"optionalAccess",e=>e.culture])}},e}_updateContext(e){return(0,ae.x)([e,"optionalAccess",e=>e.app,"optionalAccess",e=>e.app_memory])&&(e.app.app_memory=process.memoryUsage().rss),(0,ae.x)([e,"optionalAccess",e=>e.device,"optionalAccess",e=>e.free_memory])&&(e.device.free_memory=Se.freemem()),e}async _getContexts(){const e={};if(this._options.os&&(e.os=await async function(){const e=Se.platform();switch(e){case"darwin":return async function(){const e={kernel_version:Se.release(),name:"Mac OS X",version:"10."+(Number(Se.release().split(".")[0])-4)};try{const t=await new Promise(((e,t)=>{(0,ut.execFile)("/usr/bin/sw_vers",((n,s)=>{n?t(n):e(s)}))}));e.name=gt(/^ProductName:\s+(.*)$/m,t),e.version=gt(/^ProductVersion:\s+(.*)$/m,t),e.build=gt(/^BuildVersion:\s+(.*)$/m,t)}catch(e){}return e}();case"linux":return async function(){const e={kernel_version:Se.release(),name:"Linux"};try{const t=await dt("/etc"),n=ft.find((e=>t.includes(e.name)));if(!n)return e;const s=(0,ot.join)("/etc",n.name),i=(await lt(s,{encoding:"utf-8"})).toLowerCase(),{distros:r}=n;e.name=r.find((e=>i.indexOf(mt(e))>=0))||r[0];const o=mt(e.name);e.version=_t[o](i)}catch(e){}return e}();default:return{name:ht[e]||e,version:Se.release()}}}()),this._options.app&&(e.app=function(){const e=process.memoryUsage().rss;return{app_start_time:new Date(Date.now()-1e3*process.uptime()).toISOString(),app_memory:e}}()),this._options.device&&(e.device=function(e){const t={},n=Se.uptime&&Se.uptime();if("number"==typeof n&&(t.boot_time=new Date(Date.now()-1e3*n).toISOString()),t.arch=Se.arch(),(!0===e||e.memory)&&(t.memory_size=Se.totalmem(),t.free_memory=Se.freemem()),!0===e||e.cpu){const e=Se.cpus();if(e&&e.length){const n=e[0];t.processor_count=e.length,t.cpu_description=n.model,t.processor_frequency=n.speed}}return t}(this._options.device)),this._options.culture){const t=function(){try{if("string"!=typeof process.versions.icu)return;const e=new Date(9e8);if("enero"===new Intl.DateTimeFormat("es",{month:"long"}).format(e)){const e=Intl.DateTimeFormat().resolvedOptions();return{locale:e.locale,timezone:e.timeZone}}}catch(e){}}();t&&(e.culture=t)}return e}}pt.__initStatic();const ht={aix:"IBM AIX",freebsd:"FreeBSD",openbsd:"OpenBSD",sunos:"SunOS",win32:"Windows"},ft=[{name:"fedora-release",distros:["Fedora"]},{name:"redhat-release",distros:["Red Hat Linux","Centos"]},{name:"redhat_version",distros:["Red Hat Linux"]},{name:"SuSE-release",distros:["SUSE Linux"]},{name:"lsb-release",distros:["Ubuntu Linux","Arch Linux"]},{name:"debian_version",distros:["Debian"]},{name:"debian_release",distros:["Debian"]},{name:"arch-release",distros:["Arch Linux"]},{name:"gentoo-release",distros:["Gentoo Linux"]},{name:"novell-release",distros:["SUSE Linux"]},{name:"alpine-release",distros:["Alpine Linux"]}],_t={alpine:e=>e,arch:e=>gt(/distrib_release=(.*)/,e),centos:e=>gt(/release ([^ ]+)/,e),debian:e=>e,fedora:e=>gt(/release (..)/,e),mint:e=>gt(/distrib_release=(.*)/,e),red:e=>gt(/release ([^ ]+)/,e),suse:e=>gt(/VERSION = (.*)\n/,e),ubuntu:e=>gt(/distrib_release=(.*)/,e)};function gt(e,t){const n=e.exec(t);return n?n[1]:void 0}function mt(e){return e.split(" ")[0].toLowerCase()}var yt=n(442),bt=n(6956),vt=n(6489);const Et={ip:!1,request:!0,transaction:!0,user:!0},St=["cookies","data","headers","method","query_string","url"],Tt=["id","username","email"];function kt(e,t={}){const n=e.method&&e.method.toUpperCase();let s="",i="url";t.customRoute||e.route?(s=t.customRoute||`${e.baseUrl||""}${e.route&&e.route.path}`,i="route"):(e.originalUrl||e.url)&&(s=(0,bt.rt)(e.originalUrl||e.url||""));let r="";return t.method&&n&&(r+=n),t.method&&t.path&&(r+=" "),t.path&&s&&(r+=s),[r,i]}function wt(e,t){const{include:n=St}=t||{},s={},i=e.headers||{},r=e.method,o=e.hostname||e.host||i.host||"<no host>",a="https"===e.protocol||e.socket&&e.socket.encrypted?"https":"http",c=e.originalUrl||e.url||"",u=c.startsWith(a)?c:`${a}://${o}${c}`;return n.forEach((t=>{switch(t){case"headers":s.headers=i,n.includes("cookies")||delete s.headers.cookie;break;case"method":s.method=r;break;case"url":s.url=u;break;case"cookies":s.cookies=e.cookies||i.cookie&&vt.Q(i.cookie)||{};break;case"query_string":s.query_string=function(e){let t=e.originalUrl||e.url||"";if(t)return t.startsWith("/")&&(t=`http://dogs.are.great${t}`),e.query||void 0!==typeof URL&&new URL(t).search.replace("?","")||Ne.parse(t).query||void 0}(e);break;case"data":if("GET"===r||"HEAD"===r)break;void 0!==e.body&&(s.data=(0,$.HD)(e.body)?e.body:JSON.stringify(j(e.body)));break;default:({}).hasOwnProperty.call(e,t)&&(s[t]=e[t])}})),s}function It(e,t,n){const s={...Et,...(0,ae.x)([n,"optionalAccess",e=>e.include])};if(s.request){const n=Array.isArray(s.request)?wt(t,{include:s.request}):wt(t);e.request={...e.request,...n}}if(s.user){const n=t.user&&(0,$.PO)(t.user)?function(e,t){const n={};return(Array.isArray(t)?t:Tt).forEach((t=>{e&&t in e&&(n[t]=e[t])})),n}(t.user,s.user):{};Object.keys(n).length&&(e.user={...e.user,...n})}if(s.ip){const n=t.ip||t.socket&&t.socket.remoteAddress;n&&(e.user={...e.user,ip_address:n})}return s.transaction&&!e.transaction&&(e.transaction=function(e,t){switch(t){case"path":return kt(e,{path:!0})[0];case"handler":return e.route&&e.route.stack&&e.route.stack[0]&&e.route.stack[0].name||"<anonymous>";default:return kt(e,{path:!0,method:!0})[0]}}(t,s.transaction)),e}const xt={include:{cookies:!0,data:!0,headers:!0,ip:!1,query_string:!0,url:!0,user:{id:!0,username:!0,email:!0}},transactionNamingScheme:"methodPath"};class Ct{static __initStatic(){this.id="RequestData"}__init(){this.name=Ct.id}constructor(e={}){Ct.prototype.__init.call(this),this._addRequestData=It,this._options={...xt,...e,include:{method:!0,...xt.include,...e.include,user:e.include&&"boolean"==typeof e.include.user?e.include.user:{...xt.include.user,...(e.include||{}).user}}}}setupOnce(e,t){const{transactionNamingScheme:n}=this._options;e((e=>{const s=t(),i=s.getIntegration(Ct),{sdkProcessingMetadata:r={}}=e,o=r.request;if(!i||!o)return e;const a=r.requestDataOptionsFromExpressHandler||r.requestDataOptionsFromGCPWrapper||function(e){const{transactionNamingScheme:t,include:{ip:n,user:s,...i}}=e,r=[];for(const[e,t]of Object.entries(i))t&&r.push(e);let o;if(void 0===s)o=!0;else if("boolean"==typeof s)o=s;else{const e=[];for(const[t,n]of Object.entries(s))n&&e.push(t);o=e}return{include:{ip:n,user:o,request:0!==r.length?r:void 0,transaction:t}}}(this._options),c=this._addRequestData(e,o,a);if("transaction"===e.type||"handler"===n)return c;const u=o._sentryTransaction;if(u){const e="sentry.javascript.nextjs"===function(e){try{return e.getClient().getOptions()._metadata.sdk.name}catch(e){return}}(s)?u.name.startsWith("/api"):"path"!==n,[t]=(0,yt.oA)(o,{path:!0,method:e,customRoute:u.name});c.transaction=t}return c}))}}function Ot(e){let t=[],n=!1;function s(s){t=[],n||(n=!0,e(s))}return t.push(s),{add:function(e){t.push(e)},next:function(e){const n=t.pop()||s;try{n(e)}catch(t){s(e)}}}}Ct.__initStatic();class Rt{constructor(){const{Session:e}=n(1405);this._session=new e}configureAndConnect(e,t){this._session.connect(),this._session.on("Debugger.paused",(t=>{e(t,(()=>{this._session.post("Debugger.resume")}))})),this._session.post("Debugger.enable"),this._session.post("Debugger.setPauseOnExceptions",{state:t?"all":"uncaught"})}getLocalVariables(e,t){this._getProperties(e,(e=>{const{add:n,next:s}=Ot(t);for(const t of e)if((0,ae.x)([t,"optionalAccess",e=>e.value,"optionalAccess",e=>e.objectId])&&"Array"===(0,ae.x)([t,"optionalAccess",e=>e.value,"access",e=>e.className])){const e=t.value.objectId;n((n=>this._unrollArray(e,t.name,n,s)))}else if((0,ae.x)([t,"optionalAccess",e=>e.value,"optionalAccess",e=>e.objectId])&&"Object"===(0,ae.x)([t,"optionalAccess",e=>e.value,"optionalAccess",e=>e.className])){const e=t.value.objectId;n((n=>this._unrollObject(e,t.name,n,s)))}else((0,ae.x)([t,"optionalAccess",e=>e.value,"optionalAccess",e=>e.value])||(0,ae.x)([t,"optionalAccess",e=>e.value,"optionalAccess",e=>e.description]))&&n((e=>this._unrollOther(t,e,s)));s({})}))}_getProperties(e,t){this._session.post("Runtime.getProperties",{objectId:e,ownProperties:!0},((e,n)=>{t(e?[]:n.result)}))}_unrollArray(e,t,n,s){this._getProperties(e,(e=>{n[t]=e.filter((e=>"length"!==e.name&&!isNaN(parseInt(e.name,10)))).sort(((e,t)=>parseInt(e.name,10)-parseInt(t.name,10))).map((e=>(0,ae.x)([e,"optionalAccess",e=>e.value,"optionalAccess",e=>e.value]))),s(n)}))}_unrollObject(e,t,n,s){this._getProperties(e,(e=>{n[t]=e.map((e=>[e.name,(0,ae.x)([e,"optionalAccess",e=>e.value,"optionalAccess",e=>e.value])])).reduce(((e,[t,n])=>(e[t]=n,e)),{}),s(n)}))}_unrollOther(e,t,n){(0,ae.x)([e,"optionalAccess",e=>e.value,"optionalAccess",e=>e.value])?t[e.name]=e.value.value:(0,ae.x)([e,"optionalAccess",e=>e.value,"optionalAccess",e=>e.description])&&"function"!==(0,ae.x)([e,"optionalAccess",e=>e.value,"optionalAccess",e=>e.type])&&(t[e.name]=`<${e.value.description}>`),n(t)}}function Dt(e){return void 0!==e&&["","?","<anonymous>"].includes(e)}function Nt(e){if(void 0!==e)return e.slice(-10).reduce(((e,t)=>`${e},${t.function},${t.lineno},${t.colno}`),"")}class At{static __initStatic(){this.id="LocalVariables"}__init(){this.name=At.id}__init2(){this._cachedFrames=new ze.LRUMap(20)}constructor(e={},t=function(){try{return new Rt}catch(e){return}}()){this._options=e,this._session=t,At.prototype.__init.call(this),At.prototype.__init2.call(this)}setupOnce(e,t){this._setup(e,(0,ae.x)([t,"call",e=>e(),"access",e=>e.getClient,"call",e=>e(),"optionalAccess",e=>e.getOptions,"call",e=>e()]))}_setup(e,t){if(this._session&&(0,ae.x)([t,"optionalAccess",e=>e.includeLocalVariables])){if(($e.V.major||0)<18)return void l.kg.log("The `LocalVariables` integration is only supported on Node >= v18.");this._session.configureAndConnect(((e,n)=>this._handlePaused(t.stackParser,e,n)),!!this._options.captureAllExceptions),e((async e=>this._addLocalVariables(e)))}}_handlePaused(e,{params:{reason:t,data:n,callFrames:s}},i){if("exception"!==t&&"promiseRejection"!==t)return void i();const r=function(e,t){if(void 0!==t)return Nt(e(t,1))}(e,(0,ae.x)([n,"optionalAccess",e=>e.description]));if(null==r)return void i();const{add:o,next:a}=Ot((e=>{this._cachedFrames.set(r,e),i()}));for(let e=0;e<Math.min(s.length,5);e++){const{scopeChain:t,functionName:n,this:i}=s[e],r=t.find((e=>"local"===e.type)),c="global"!==i.className&&i.className?`${i.className}.${n}`:n;if(void 0===(0,ae.x)([r,"optionalAccess",e=>e.object,"access",e=>e.objectId]))o((t=>{t[e]={function:c},a(t)}));else{const t=r.object.objectId;o((n=>(0,ae.x)([this,"access",e=>e._session,"optionalAccess",e=>e.getLocalVariables,"call",s=>s(t,(t=>{n[e]={function:c,vars:t},a(n)}))])))}}a([])}_addLocalVariables(e){for(const t of(0,ae.x)([e,"optionalAccess",e=>e.exception,"optionalAccess",e=>e.values])||[])this._addLocalVariablesToException(t);return e}_addLocalVariablesToException(e){const t=Nt((0,ae.x)([e,"optionalAccess",e=>e.stacktrace,"optionalAccess",e=>e.frames]));if(void 0===t)return;const n=this._cachedFrames.delete(t);if(void 0===n)return;const s=(0,ae.x)([e,"access",e=>e.stacktrace,"optionalAccess",e=>e.frames,"optionalAccess",e=>e.length])||0;for(let t=0;t<s;t++){const o=s-t-1;if(!(0,ae.x)([e,"optionalAccess",e=>e.stacktrace,"optionalAccess",e=>e.frames,"optionalAccess",e=>e[o]])||!n[t])break;void 0!==n[t].vars&&!1!==e.stacktrace.frames[o].in_app&&((i=e.stacktrace.frames[o].function)===(r=n[t].function)||Dt(i)&&Dt(r))&&(e.stacktrace.frames[o].vars=n[t].vars)}var i,r}}At.__initStatic();var Pt=n(1249);const Ut="\\"===ot.sep,$t=[new f,new u,new Le,new We,new Pt.Y,new Qe,new et,new st,new At,new pt,new ct,new Ct,new rt];function Mt(e={}){const t=(0,m.cu)();Fe();const n=(0,ae.x)([t,"access",e=>e.__SENTRY__,"optionalAccess",e=>e.integrations])||[];if(e.defaultIntegrations=!1===e.defaultIntegrations?[]:[...Array.isArray(e.defaultIntegrations)?e.defaultIntegrations:$t,...n],void 0===e.dsn&&process.env.SENTRY_DSN&&(e.dsn=process.env.SENTRY_DSN),void 0===e.tracesSampleRate&&process.env.SENTRY_TRACES_SAMPLE_RATE){const t=parseFloat(process.env.SENTRY_TRACES_SAMPLE_RATE);isFinite(t)&&(e.tracesSampleRate=t)}if(void 0===e.release){const t=Ft();void 0!==t?e.release=t:e.autoSessionTracking=!1}void 0===e.environment&&process.env.SENTRY_ENVIRONMENT&&(e.environment=process.env.SENTRY_ENVIRONMENT),void 0===e.autoSessionTracking&&void 0!==e.dsn&&(e.autoSessionTracking=!0),void 0===e.instrumenter&&(e.instrumenter="sentry");const s={...e,stackParser:(0,M.Sq)(e.stackParser||Lt),integrations:ue(e),transport:e.transport||Ue};!function(e,t){!0===t.debug&&("undefined"==typeof __SENTRY_DEBUG__||__SENTRY_DEBUG__?l.kg.enable():console.warn("[Sentry] Cannot initialize SDK with `debug` option using a non-debug bundle."));const n=(0,m.Gd)();n.getScope().update(t.initialScope);const s=new e(t);n.bindClient(s)}(Ie,s),e.autoSessionTracking&&function(){const e=(0,m.Gd)();e.startSession(),process.on("beforeExit",(()=>{const t=(0,ae.x)([e,"access",e=>e.getScope,"call",e=>e(),"optionalAccess",e=>e.getSession,"call",e=>e()]);t&&!["exited","crashed"].includes(t.status)&&e.endSession()}))}()}function jt(){return(0,m.Gd)().lastEventId()}async function Gt(e){const t=(0,m.Gd)().getClient();return t?t.flush(e):(("undefined"==typeof __SENTRY_DEBUG__||__SENTRY_DEBUG__)&&l.kg.warn("Cannot flush events. No client defined."),Promise.resolve(!1))}async function Bt(e){const t=(0,m.Gd)().getClient();return t?t.close(e):(("undefined"==typeof __SENTRY_DEBUG__||__SENTRY_DEBUG__)&&l.kg.warn("Cannot flush events and disable SDK. No client defined."),Promise.resolve(!1))}function Yt(e){if(void 0===e)return!1;const t=e&&e.getOptions();return!(!t||void 0===t.autoSessionTracking)&&t.autoSessionTracking}function Ft(e){return process.env.SENTRY_RELEASE?process.env.SENTRY_RELEASE:he.n2.SENTRY_RELEASE&&he.n2.SENTRY_RELEASE.id?he.n2.SENTRY_RELEASE.id:process.env.GITHUB_SHA||process.env.COMMIT_REF||process.env.VERCEL_GIT_COMMIT_SHA||process.env.VERCEL_GITHUB_COMMIT_SHA||process.env.VERCEL_GITLAB_COMMIT_SHA||process.env.VERCEL_BITBUCKET_COMMIT_SHA||process.env.ZEIT_GITHUB_COMMIT_SHA||process.env.ZEIT_GITLAB_COMMIT_SHA||process.env.ZEIT_BITBUCKET_COMMIT_SHA||e}function qt(e,t){const n="in_progress"!==e.status&&e.checkInId?e:{...e,checkInId:(0,d.DM)()},s=(0,m.Gd)().getClient();return s?s.captureCheckIn(n,t):("undefined"==typeof __SENTRY_DEBUG__||__SENTRY_DEBUG__)&&l.kg.warn("Cannot capture check in. No client defined."),n.checkInId}const Lt=(0,M.pE)((0,M.Ep)((function(e,t=Ut){if(!e)return;const s=t?e.replace(/^[A-Z]:/,"").replace(/\\/g,"/"):e;let{root:i,dir:r,base:o,ext:a}=ot.posix.parse(s);const c=`${n.c[n.s]&&n.c[n.s].filename&&r||global.process.cwd()}/`;let u=o;".js"===a&&(u=u.slice(0,u.length-3)),i||r||(r=".");let l=r.lastIndexOf("/node_modules/");if(l>-1)return`${r.slice(l+14).replace(/\//g,".")}:${u}`;if(l=`${r}/`.lastIndexOf(c,0),0===l){let e=r.slice(c.length).replace(/\//g,".");return e&&(e+=":"),e+=u,e}return u})));function Vt(e){const t=ot.resolve(e);if(!tt.existsSync(t))throw new Error(`Cannot read contents of ${t}. Directory does not exist.`);if(!tt.statSync(t).isDirectory())throw new Error(`Cannot read contents of ${t}, because it is not a directory.`);const n=e=>tt.readdirSync(e).reduce(((t,s)=>{const i=ot.join(e,s);return tt.statSync(i).isDirectory()?t.concat(n(i)):(t.push(i),t)}),[]);return n(t).map((e=>ot.relative(t,e)))}var Ht=n(7522);function zt(e,t){return wt(e,{include:t})}function Jt(e,t,n={}){return It(e,t,{include:n})}function Wt(){return function(e,t,n){const s=(0,m.Gd)(),i=(0,ae.x)([s,"access",e=>e.getClient,"call",e=>e(),"optionalAccess",e=>e.getOptions,"call",e=>e()]);if(!i||"sentry"!==i.instrumenter||"OPTIONS"===(0,ae.x)([e,"access",e=>e.method,"optionalAccess",e=>e.toUpperCase,"call",e=>e()])||"HEAD"===(0,ae.x)([e,"access",e=>e.method,"optionalAccess",e=>e.toUpperCase,"call",e=>e()]))return n();if(!(0,Ht.z)(i))return("undefined"==typeof __SENTRY_DEBUG__||__SENTRY_DEBUG__)&&l.kg.warn("Sentry `tracingHandler` is being used, but tracing is disabled. Please enable tracing by setting either `tracesSampleRate` or `tracesSampler` in your `Sentry.init()` options."),n();const r=e.headers&&(0,$.HD)(e.headers["sentry-trace"])&&(0,te.q)(e.headers["sentry-trace"]),o=(0,ae.x)([e,"access",e=>e.headers,"optionalAccess",e=>e.baggage]),a=(0,He.EN)(o),[c,u]=(0,yt.oA)(e,{path:!0,method:!0}),d=R({name:c,op:"http.server",...r,metadata:{dynamicSamplingContext:r&&!a?{}:a,request:e,source:u}},{request:wt(e)});s.configureScope((e=>{e.setSpan(d)})),t.__sentry_transaction=d,t.once("finish",(()=>{setImmediate((()=>{(0,yt.dB)(d,e),d.setHttpStatus(t.statusCode),d.finish()}))})),n()}}function Xt(e){const t=function(e={}){let t;if("include"in e)t={include:e.include};else{const{ip:n,request:s,transaction:i,user:r}=e;(n||s||i||r)&&(t={include:(0,a.Jr)({ip:n,request:s,transaction:i,user:r})})}return t}(e),n=(0,m.Gd)(),s=n.getClient();if(s&&Yt(s)){s.initSessionFlusher();const e=n.getScope();e&&e.getSession()&&e.setSession()}return function(n,s,i){if(e&&e.flushTimeout&&e.flushTimeout>0){const t=s.end;s.end=function(n,s,i){Gt(e.flushTimeout).then((()=>{t.call(this,n,s,i)})).then(null,(e=>{("undefined"==typeof __SENTRY_DEBUG__||__SENTRY_DEBUG__)&&l.kg.error(e),t.call(this,n,s,i)}))}}(0,m.Ok)((()=>{const e=(0,m.Gd)();e.configureScope((s=>{if(s.setSDKProcessingMetadata({request:n,requestDataOptionsFromExpressHandler:t}),Yt(e.getClient())){const t=e.getScope();t&&t.setRequestSession({status:"ok"})}})),s.once("finish",(()=>{const t=e.getClient();Yt(t)&&setImmediate((()=>{t&&t._captureRequestSession&&t._captureRequestSession()}))})),i()}))}}function Zt(e){const t=function(e){const t=e.status||e.statusCode||e.status_code||e.output&&e.output.statusCode;return t?parseInt(t,10):500}(e);return t>=500}function Kt(e){return function(t,n,s,i){(e&&e.shouldHandleError||Zt)(t)?O((e=>{e.setSDKProcessingMetadata({request:n});const r=s.__sentry_transaction;r&&void 0===e.getSpan()&&e.setSpan(r);const o=(0,m.Gd)().getClient();if(o&&Yt(o)&&void 0!==o._sessionFlusher){const t=e.getRequestSession();t&&void 0!==t.status&&(t.status="crashed")}const a=y(t);s.sentry=a,i(t)})):i(t)}}function Qt(e={}){return function({path:t,type:n,next:s,rawInput:i}){const r=(0,m.Gd)(),o=(0,ae.x)([r,"access",e=>e.getClient,"call",e=>e(),"optionalAccess",e=>e.getOptions,"call",e=>e()]),a=(0,ae.x)([r,"access",e=>e.getScope,"call",e=>e(),"optionalAccess",e=>e.getTransaction,"call",e=>e()]);if(a){a.setName(`trpc/${t}`,"route"),a.op="rpc.server";const s={procedure_type:n};(void 0!==e.attachRpcInput?e.attachRpcInput:(0,ae.x)([o,"optionalAccess",e=>e.sendDefaultPii]))&&(s.input=j(i)),a.setContext("trpc",s)}return s()}}var en=n(2716),tn=n(8737),nn=n(1791),sn=n(6169),rn=n(24),on=n(1370),an=n(9889);const cn={...s,...r,...o}},1249:(e,t,n)=>{"use strict";n.d(t,{Y:()=>l});var s,i=n(2176),r=n(6956),o=n(7321),a=n(9181),c=n(9656),u=n(7578);e=n.hmd(e),function(e){e.RequestCreate="undici:request:create",e.RequestEnd="undici:request:headers",e.RequestError="undici:request:error"}(s||(s={}));class l{static __initStatic(){this.id="Undici"}__init(){this.name=l.id}constructor(e={}){l.prototype.__init.call(this),this._options={breadcrumbs:void 0===e.breadcrumbs||e.breadcrumbs,shouldCreateSpanForRequest:e.shouldCreateSpanForRequest||(()=>!0)}}setupOnce(t,n){if(c.V.major&&c.V.major<16)return;let d;try{d=(0,i.l$)(e,"diagnostics_channel")}catch(e){}d&&d.subscribe&&(d.subscribe(s.RequestCreate,(e=>{const t=n();if(!t.getIntegration(l))return;const{request:s}=e,i=new URL(s.path,s.origin),c=i.toString();if((0,u.ZB)(c)||void 0!==s.__sentry__)return;const d=t.getClient(),p=t.getScope().getSpan();if(p&&d){const e=d.getOptions();if(this._options.shouldCreateSpanForRequest(c)){const t=s.method||"GET",n={"http.method":t},u=i.searchParams.toString();u&&(n["http.query"]=`?${u}`),i.hash&&(n["http.fragment"]=i.hash);const l=p.startChild({op:"http.client",description:`${t} ${(0,r.rt)(c)}`,data:n});if(s.__sentry__=l,(!e.tracePropagationTargets||(0,o.U0)(c,e.tracePropagationTargets))&&(s.addHeader("sentry-trace",l.toTraceparent()),l.transaction)){const e=l.transaction.getDynamicSamplingContext(),t=(0,a.IQ)(e);t&&s.addHeader("baggage",t)}}}})),d.subscribe(s.RequestEnd,(e=>{const t=n();if(!t.getIntegration(l))return;const{request:s,response:i}=e,r=new URL(s.path,s.origin).toString();if((0,u.ZB)(r))return;const o=s.__sentry__;o&&(o.setHttpStatus(i.statusCode),o.finish()),this._options.breadcrumbs&&t.addBreadcrumb({category:"http",data:{method:s.method,status_code:i.statusCode,url:r},type:"http"},{event:"response",request:s,response:i})})),d.subscribe(s.RequestError,(e=>{const t=n();if(!t.getIntegration(l))return;const{request:s}=e,i=new URL(s.path,s.origin).toString();if((0,u.ZB)(i))return;const r=s.__sentry__;r&&(r.setStatus("internal_error"),r.finish()),this._options.breadcrumbs&&t.addBreadcrumb({category:"http",data:{method:s.method,url:i},level:"error",type:"http"},{event:"error",request:s})})))}}l.__initStatic()},7578:(e,t,n)=>{"use strict";n.d(t,{CA:()=>u,Dt:()=>l,ZB:()=>a,lx:()=>c,nY:()=>p});var s=n(4307),i=n(5659),r=n(7310),o=n(9656);function a(e){const t=(0,s.x)([i.Gd,"call",e=>e(),"access",e=>e.getClient,"call",e=>e(),"optionalAccess",e=>e.getDsn,"call",e=>e()]);return!!t&&e.includes(t.host)}function c(e){return`${e.protocol||""}//${e.hostname||e.host||""}${e.port&&80!==e.port&&443!==e.port?`:${e.port}`:""}${e.path?e.path:"/"}`}function u(e){const t=e.protocol||"",n=e.hostname||e.host||"",s=e.port&&80!==e.port&&443!==e.port?`:${e.port}`:"",i=e.pathname||"/";return`${t}//${e.auth?function(e){const[t,n]=e.split(":");return`${t?"[Filtered]":""}:${n?"[Filtered]":""}@`}(e.auth):""}${n}${s}${i}`}function l(e,t,n){if(!e)return e;let[i,r]=e.split(" ");return t.host&&!t.protocol&&(t.protocol=(0,s.x)([n,"optionalAccess",e=>e.agent,"optionalAccess",e=>e.protocol]),r=u(t)),(0,s.x)([r,"optionalAccess",e=>e.startsWith,"call",e=>e("///")])&&(r=r.slice(2)),`${i} ${r}`}function d(e){const t={protocol:e.protocol,hostname:"string"==typeof e.hostname&&e.hostname.startsWith("[")?e.hostname.slice(1,-1):e.hostname,hash:e.hash,search:e.search,pathname:e.pathname,path:`${e.pathname||""}${e.search||""}`,href:e.href};return""!==e.port&&(t.port=Number(e.port)),(e.username||e.password)&&(t.auth=`${e.username}:${e.password}`),t}function p(e,t){let n,i;return"function"==typeof t[t.length-1]&&(n=t.pop()),i="string"==typeof t[0]?d(new r.URL(t[0])):t[0]instanceof r.URL?d(t[0]):t[0],2===t.length&&(i={...i,...t[1]}),void 0===i.protocol&&(o.V.major&&o.V.major>8?i.protocol=(0,s.x)([(0,s.x)([e,"optionalAccess",e=>e.globalAgent]),"optionalAccess",e=>e.protocol])||(0,s.x)([i.agent,"optionalAccess",e=>e.protocol])||(0,s.x)([i._defaultAgent,"optionalAccess",e=>e.protocol]):i.protocol=(0,s.x)([i.agent,"optionalAccess",e=>e.protocol])||(0,s.x)([i._defaultAgent,"optionalAccess",e=>e.protocol])||(0,s.x)([(0,s.x)([e,"optionalAccess",e=>e.globalAgent]),"optionalAccess",e=>e.protocol])),n?[i,n]:[i]}},9656:(e,t,n)=>{"use strict";n.d(t,{V:()=>s});const s=(0,n(2844).J4)(process.versions.node)},5605:(e,t,n)=>{"use strict";n.r(t),n.d(t,{BROWSER_TRACING_INTEGRATION_ID:()=>ce,BrowserTracing:()=>te,IdleTransaction:()=>he,Integrations:()=>me,Span:()=>ae,SpanStatus:()=>ge,TRACEPARENT_REGEXP:()=>pe,Transaction:()=>oe,addExtensionMethods:()=>ne,defaultRequestInstrumentationOptions:()=>ue,extractTraceparentData:()=>ie,getActiveTransaction:()=>se,hasTracingEnabled:()=>le,instrumentOutgoingRequests:()=>fe,spanStatusfromHttpCode:()=>re,startIdleTransaction:()=>_e,stripUrlQueryAndFragment:()=>de});var s=n(5544),i=n(6890),r=n(7638),o=n(9791),a=n(2343),c=n(9181),u=n(8464);const l=n(1235).n2;var d=n(1170);const p=(e,t,n)=>{let s,i;return r=>{t.value>=0&&(r||n)&&(i=t.value-(s||0),(i||void 0===s)&&(s=t.value,t.delta=i,e(t)))}},h=()=>l.__WEB_VITALS_POLYFILL__?l.performance&&(performance.getEntriesByType&&performance.getEntriesByType("navigation")[0]||(()=>{const e=l.performance.timing,t=l.performance.navigation.type,n={entryType:"navigation",startTime:0,type:2==t?"back_forward":1===t?"reload":"navigate"};for(const t in e)"navigationStart"!==t&&"toJSON"!==t&&(n[t]=Math.max(e[t]-e.navigationStart,0));return n})()):l.performance&&performance.getEntriesByType&&performance.getEntriesByType("navigation")[0],f=()=>{const e=h();return e&&e.activationStart||0},_=(e,t)=>{const n=h();let s="navigate";return n&&(s=l.document.prerendering||f()>0?"prerender":n.type.replace(/_/g,"-")),{name:e,value:void 0===t?-1:t,rating:"good",delta:0,entries:[],id:`v3-${Date.now()}-${Math.floor(8999999999999*Math.random())+1e12}`,navigationType:s}},g=(e,t,n)=>{try{if(PerformanceObserver.supportedEntryTypes.includes(e)){const s=new PerformanceObserver((e=>{t(e.getEntries())}));return s.observe(Object.assign({type:e,buffered:!0},n||{})),s}}catch(e){}},m=(e,t)=>{const n=s=>{"pagehide"!==s.type&&"hidden"!==l.document.visibilityState||(e(s),t&&(removeEventListener("visibilitychange",n,!0),removeEventListener("pagehide",n,!0)))};addEventListener("visibilitychange",n,!0),addEventListener("pagehide",n,!0)};let y=-1;const b=()=>(y<0&&(y="hidden"!==l.document.visibilityState||l.document.prerendering?1/0:0,m((({timeStamp:e})=>{y=e}),!0)),{get firstHiddenTime(){return y}}),v={};function E(e){return"number"==typeof e&&isFinite(e)}function S(e,{startTimestamp:t,...n}){return t&&e.startTimestamp>t&&(e.startTimestamp=t),e.startChild({startTimestamp:t,...n})}function T(e){return e/1e3}function k(){return l&&l.addEventListener&&l.performance}let w,I,x=0,C={};function O(){const e=k();if(e&&d.Z1){e.mark&&l.performance.mark("sentry-tracing-init"),(e=>{const t=b(),n=_("FID");let s;const i=e=>{e.startTime<t.firstHiddenTime&&(n.value=e.processingStart-e.startTime,n.entries.push(e),s(!0))},r=e=>{e.forEach(i)},o=g("first-input",r);s=p(e,n),o&&m((()=>{r(o.takeRecords()),o.disconnect()}),!0)})((e=>{const t=e.entries.pop();if(!t)return;const n=T(d.Z1),s=T(t.startTime);("undefined"==typeof __SENTRY_DEBUG__||__SENTRY_DEBUG__)&&a.kg.log("[Measurements] Adding FID"),C.fid={value:e.value,unit:"millisecond"},C["mark.fid"]={value:n+s,unit:"second"}}));const t=(e=>{const t=_("CLS",0);let n,s=0,i=[];const r=e=>{e.forEach((e=>{if(!e.hadRecentInput){const r=i[0],o=i[i.length-1];s&&0!==i.length&&e.startTime-o.startTime<1e3&&e.startTime-r.startTime<5e3?(s+=e.value,i.push(e)):(s=e.value,i=[e]),s>t.value&&(t.value=s,t.entries=i,n&&n())}}))},o=g("layout-shift",r);if(o){n=p(e,t);const s=()=>{r(o.takeRecords()),n(!0)};return m(s),s}})((e=>{const t=e.entries.pop();t&&(("undefined"==typeof __SENTRY_DEBUG__||__SENTRY_DEBUG__)&&a.kg.log("[Measurements] Adding CLS"),C.cls={value:e.value,unit:""},I=t)})),n=(e=>{const t=b(),n=_("LCP");let s;const i=e=>{const i=e[e.length-1];if(i){const e=Math.max(i.startTime-f(),0);e<t.firstHiddenTime&&(n.value=e,n.entries=[i],s())}},r=g("largest-contentful-paint",i);if(r){s=p(e,n);const t=()=>{v[n.id]||(i(r.takeRecords()),r.disconnect(),v[n.id]=!0,s(!0))};return["keydown","click"].forEach((e=>{addEventListener(e,t,{once:!0,capture:!0})})),m(t,!0),t}})((e=>{const t=e.entries.pop();t&&(("undefined"==typeof __SENTRY_DEBUG__||__SENTRY_DEBUG__)&&a.kg.log("[Measurements] Adding LCP"),C.lcp={value:e.value,unit:"millisecond"},w=t)}));return()=>{t&&t(),n&&n()}}return()=>{}}function R(e,t,n,s,i,r){const o=r?t[r]:t[`${n}End`],a=t[`${n}Start`];a&&o&&S(e,{op:"browser",description:i||n,startTimestamp:s+T(a),endTimestamp:s+T(o)})}var D=n(7522),N=n(5659),A=n(1688),P=n(7321),U=n(7597);const $=["localhost",/^\//],M={traceFetch:!0,traceXHR:!0,tracingOrigins:$,tracePropagationTargets:$};function j(e){const{traceFetch:t,traceXHR:n,tracePropagationTargets:s,tracingOrigins:i,shouldCreateSpanForRequest:r}={traceFetch:M.traceFetch,traceXHR:M.traceXHR,...e},o="function"==typeof r?r:e=>!0,a=e=>function(e,t){return(0,P.U0)(e,t||$)}(e,s||i),u={};t&&(0,A.oq)("fetch",(e=>{!function(e,t,n,s){if(!(0,D.z)()||!e.fetchData||!t(e.fetchData.url))return;if(e.endTimestamp){const t=e.fetchData.__span;if(!t)return;const n=s[t];return void(n&&(e.response?n.setHttpStatus(e.response.status):e.error&&n.setStatus("internal_error"),n.finish(),delete s[t]))}const i=e.response&&e.response.headers&&e.response.headers.get("content-length"),r=(0,N.Gd)().getScope(),o=r&&r.getSpan(),a=o&&o.transaction;if(o&&a){const{method:t,url:r}=e.fetchData,u=o.startChild({data:{url:r,type:"fetch",...i?{"http.response_content_length":i}:{},"http.method":t},description:`${t} ${r}`,op:"http.client"});e.fetchData.__span=u.spanId,s[u.spanId]=u;const l=e.args[0];e.args[1]=e.args[1]||{};const d=e.args[1];n(e.fetchData.url)&&(d.headers=function(e,t,n,s){const i=(0,c.IQ)(t),r=n.toTraceparent(),o="undefined"!=typeof Request&&(0,U.V9)(e,Request)?e.headers:s.headers;if(o){if("undefined"!=typeof Headers&&(0,U.V9)(o,Headers)){const e=new Headers(o);return e.append("sentry-trace",r),i&&e.append(c.bU,i),e}if(Array.isArray(o)){const e=[...o,["sentry-trace",r]];return i&&e.push([c.bU,i]),e}{const e="baggage"in o?o.baggage:void 0,t=[];return Array.isArray(e)?t.push(...e):e&&t.push(e),i&&t.push(i),{...o,"sentry-trace":r,baggage:t.length>0?t.join(","):void 0}}}return{"sentry-trace":r,baggage:i}}(l,a.getDynamicSamplingContext(),u,d))}}(e,o,a,u)})),n&&(0,A.oq)("xhr",(e=>{!function(e,t,n,s){const i=e.xhr,r=i&&i[A.xU];if(!(0,D.z)()||i&&i.__sentry_own_request__||!(i&&r&&t(r.url)))return;if(e.endTimestamp){const e=i.__sentry_xhr_span_id__;if(!e)return;const t=s[e];return void(t&&(t.setHttpStatus(r.status_code),t.finish(),delete s[e]))}const o=(0,N.Gd)().getScope(),a=o&&o.getSpan(),u=a&&a.transaction;if(a&&u){const e=a.startChild({data:{...r.data,type:"xhr","http.method":r.method,url:r.url},description:`${r.method} ${r.url}`,op:"http.client"});if(i.__sentry_xhr_span_id__=e.spanId,s[i.__sentry_xhr_span_id__]=e,i.setRequestHeader&&n(r.url))try{i.setRequestHeader("sentry-trace",e.toTraceparent());const t=u.getDynamicSamplingContext(),n=(0,c.IQ)(t);n&&i.setRequestHeader(c.bU,n)}catch(e){}}}(e,o,a,u)}))}const G="BrowserTracing",B={...s.AT,markBackgroundTransactions:!0,routingInstrumentation:function(e,t=!0,n=!0){if(!l||!l.location)return void(("undefined"==typeof __SENTRY_DEBUG__||__SENTRY_DEBUG__)&&a.kg.warn("Could not initialize routing instrumentation due to invalid location"));let s,i=l.location.href;t&&(s=e({name:l.location.pathname,startTimestamp:d.Z1?d.Z1/1e3:void 0,op:"pageload",metadata:{source:"url"}})),n&&(0,A.oq)("history",(({to:t,from:n})=>{void 0===n&&i&&-1!==i.indexOf(t)?i=void 0:n!==t&&(i=void 0,s&&(("undefined"==typeof __SENTRY_DEBUG__||__SENTRY_DEBUG__)&&a.kg.log(`[Tracing] Finishing current transaction with op: ${s.op}`),s.finish()),s=e({name:l.location.pathname,op:"navigation",metadata:{source:"url"}}))}))},startTransactionOnLocationChange:!0,startTransactionOnPageLoad:!0,enableLongTask:!0,_experiments:{},...M};class Y{__init(){this.name=G}constructor(e){Y.prototype.__init.call(this),(0,i.T)(),this.options={...B,...e},void 0!==this.options._experiments.enableLongTask&&(this.options.enableLongTask=this.options._experiments.enableLongTask),e&&!e.tracePropagationTargets&&e.tracingOrigins&&(this.options.tracePropagationTargets=e.tracingOrigins),this._collectWebVitals=O(),this.options.enableLongTask&&g("longtask",(e=>{for(const t of e){const e=(0,o.x1)();if(!e)return;const n=T(d.Z1+t.startTime),s=T(t.duration);e.startChild({description:"Main UI thread blocked",op:"ui.long-task",startTimestamp:n,endTimestamp:n+s})}})),this.options._experiments.enableInteractions&&g("event",(e=>{for(const t of e){const e=(0,o.x1)();if(!e)return;if("click"===t.name){const n=T(d.Z1+t.startTime),s=T(t.duration);e.startChild({description:(0,u.Rt)(t.target),op:`ui.interaction.${t.name}`,startTimestamp:n,endTimestamp:n+s})}}}),{durationThreshold:0})}setupOnce(e,t){this._getCurrentHub=t;const{routingInstrumentation:n,startTransactionOnLocationChange:s,startTransactionOnPageLoad:i,markBackgroundTransactions:r,traceFetch:c,traceXHR:u,tracePropagationTargets:d,shouldCreateSpanForRequest:p,_experiments:h}=this.options;n((e=>{const n=this._createRouteTransaction(e);return this.options._experiments.onStartRouteTransaction&&this.options._experiments.onStartRouteTransaction(n,e,t),n}),i,s),r&&(l&&l.document?l.document.addEventListener("visibilitychange",(()=>{const e=(0,o.x1)();if(l.document.hidden&&e){const t="cancelled";("undefined"==typeof __SENTRY_DEBUG__||__SENTRY_DEBUG__)&&a.kg.log(`[Tracing] Transaction: ${t} -> since tab moved to the background, op: ${e.op}`),e.status||e.setStatus(t),e.setTag("visibilitychange","document.hidden"),e.finish()}})):("undefined"==typeof __SENTRY_DEBUG__||__SENTRY_DEBUG__)&&a.kg.warn("[Tracing] Could not set up background tab detection due to lack of global document")),h.enableInteractions&&this._registerInteractionListener(),j({traceFetch:c,traceXHR:u,tracePropagationTargets:d,shouldCreateSpanForRequest:p})}_createRouteTransaction(e){if(!this._getCurrentHub)return void(("undefined"==typeof __SENTRY_DEBUG__||__SENTRY_DEBUG__)&&a.kg.warn(`[Tracing] Did not create ${e.op} transaction because _getCurrentHub is invalid.`));const{beforeNavigate:t,idleTimeout:n,finalTimeout:s,heartbeatInterval:o}=this.options,p="pageload"===e.op,h=p?F("sentry-trace"):null,f=p?F("baggage"):null,_=h?(0,r.q)(h):void 0,g=f?(0,c.EN)(f):void 0,m={...e,..._,metadata:{...e.metadata,dynamicSamplingContext:_&&!g?{}:g},trimEnd:!0},y="function"==typeof t?t(m):m,v=void 0===y?{...m,sampled:!1}:y;v.metadata=v.name!==m.name?{...v.metadata,source:"custom"}:v.metadata,this._latestRouteName=v.name,this._latestRouteSource=v.metadata&&v.metadata.source,!1===v.sampled&&("undefined"==typeof __SENTRY_DEBUG__||__SENTRY_DEBUG__)&&a.kg.log(`[Tracing] Will not send ${v.op} transaction because of beforeNavigate.`),("undefined"==typeof __SENTRY_DEBUG__||__SENTRY_DEBUG__)&&a.kg.log(`[Tracing] Starting ${v.op} transaction on scope`);const O=this._getCurrentHub(),{location:D}=l,N=(0,i.l)(O,v,n,s,!0,{location:D},o);return N.registerBeforeFinishCallback((e=>{this._collectWebVitals(),function(e){const t=k();if(!t||!l.performance.getEntries||!d.Z1)return;("undefined"==typeof __SENTRY_DEBUG__||__SENTRY_DEBUG__)&&a.kg.log("[Tracing] Adding & adjusting spans using Performance API");const n=T(d.Z1),s=t.getEntries();let i,r;if(s.slice(x).forEach((t=>{const s=T(t.startTime),o=T(t.duration);if(!("navigation"===e.op&&n+s<e.startTimestamp))switch(t.entryType){case"navigation":!function(e,t,n){["unloadEvent","redirect","domContentLoadedEvent","loadEvent","connect"].forEach((s=>{R(e,t,s,n)})),R(e,t,"secureConnection",n,"TLS/SSL","connectEnd"),R(e,t,"fetch",n,"cache","domainLookupStart"),R(e,t,"domainLookup",n,"DNS"),function(e,t,n){S(e,{op:"browser",description:"request",startTimestamp:n+T(t.requestStart),endTimestamp:n+T(t.responseEnd)}),S(e,{op:"browser",description:"response",startTimestamp:n+T(t.responseStart),endTimestamp:n+T(t.responseEnd)})}(e,t,n)}(e,t,n),i=n+T(t.responseStart),r=n+T(t.requestStart);break;case"mark":case"paint":case"measure":{!function(e,t,n,s,i){const r=i+n,o=r+s;S(e,{description:t.name,endTimestamp:o,op:t.entryType,startTimestamp:r})}(e,t,s,o,n);const i=b(),r=t.startTime<i.firstHiddenTime;"first-paint"===t.name&&r&&(("undefined"==typeof __SENTRY_DEBUG__||__SENTRY_DEBUG__)&&a.kg.log("[Measurements] Adding FP"),C.fp={value:t.startTime,unit:"millisecond"}),"first-contentful-paint"===t.name&&r&&(("undefined"==typeof __SENTRY_DEBUG__||__SENTRY_DEBUG__)&&a.kg.log("[Measurements] Adding FCP"),C.fcp={value:t.startTime,unit:"millisecond"});break}case"resource":{const i=t.name.replace(l.location.origin,"");!function(e,t,n,s,i,r){if("xmlhttprequest"===t.initiatorType||"fetch"===t.initiatorType)return;const o={};"transferSize"in t&&(o["http.response_transfer_size"]=t.transferSize),"encodedBodySize"in t&&(o["http.response_content_length"]=t.encodedBodySize),"decodedBodySize"in t&&(o["http.decoded_response_content_length"]=t.decodedBodySize),"renderBlockingStatus"in t&&(o["resource.render_blocking_status"]=t.renderBlockingStatus);const a=r+s;S(e,{description:n,endTimestamp:a+i,op:t.initiatorType?`resource.${t.initiatorType}`:"resource.other",startTimestamp:a,data:o})}(e,t,i,s,o,n);break}}})),x=Math.max(s.length-1,0),function(e){const t=l.navigator;if(!t)return;const n=t.connection;n&&(n.effectiveType&&e.setTag("effectiveConnectionType",n.effectiveType),n.type&&e.setTag("connectionType",n.type),E(n.rtt)&&(C["connection.rtt"]={value:n.rtt,unit:"millisecond"})),E(t.deviceMemory)&&e.setTag("deviceMemory",`${t.deviceMemory} GB`),E(t.hardwareConcurrency)&&e.setTag("hardwareConcurrency",String(t.hardwareConcurrency))}(e),"pageload"===e.op){"number"==typeof i&&(("undefined"==typeof __SENTRY_DEBUG__||__SENTRY_DEBUG__)&&a.kg.log("[Measurements] Adding TTFB"),C.ttfb={value:1e3*(i-e.startTimestamp),unit:"millisecond"},"number"==typeof r&&r<=i&&(C["ttfb.requestTime"]={value:1e3*(i-r),unit:"millisecond"})),["fcp","fp","lcp"].forEach((t=>{if(!C[t]||n>=e.startTimestamp)return;const s=C[t].value,i=n+T(s),r=Math.abs(1e3*(i-e.startTimestamp)),o=r-s;("undefined"==typeof __SENTRY_DEBUG__||__SENTRY_DEBUG__)&&a.kg.log(`[Measurements] Normalized ${t} from ${s} to ${r} (${o})`),C[t].value=r}));const t=C["mark.fid"];t&&C.fid&&(S(e,{description:"first input delay",endTimestamp:t.value+T(C.fid.value),op:"ui.action",startTimestamp:t.value}),delete C["mark.fid"]),"fcp"in C||delete C.cls,Object.keys(C).forEach((t=>{e.setMeasurement(t,C[t].value,C[t].unit)})),function(e){w&&(("undefined"==typeof __SENTRY_DEBUG__||__SENTRY_DEBUG__)&&a.kg.log("[Measurements] Adding LCP Data"),w.element&&e.setTag("lcp.element",(0,u.Rt)(w.element)),w.id&&e.setTag("lcp.id",w.id),w.url&&e.setTag("lcp.url",w.url.trim().slice(0,200)),e.setTag("lcp.size",w.size)),I&&I.sources&&(("undefined"==typeof __SENTRY_DEBUG__||__SENTRY_DEBUG__)&&a.kg.log("[Measurements] Adding CLS Data"),I.sources.forEach(((t,n)=>e.setTag(`cls.source.${n+1}`,(0,u.Rt)(t.node)))))}(e)}w=void 0,I=void 0,C={}}(e)})),N}_registerInteractionListener(){let e;const t=()=>{const{idleTimeout:t,finalTimeout:n,heartbeatInterval:s}=this.options,r="ui.action.click",c=(0,o.x1)();if(c&&c.op&&["navigation","pageload"].includes(c.op))return void(("undefined"==typeof __SENTRY_DEBUG__||__SENTRY_DEBUG__)&&a.kg.warn(`[Tracing] Did not create ${r} transaction because a pageload or navigation transaction is in progress.`));if(e&&(e.setFinishReason("interactionInterrupted"),e.finish(),e=void 0),!this._getCurrentHub)return void(("undefined"==typeof __SENTRY_DEBUG__||__SENTRY_DEBUG__)&&a.kg.warn(`[Tracing] Did not create ${r} transaction because _getCurrentHub is invalid.`));if(!this._latestRouteName)return void(("undefined"==typeof __SENTRY_DEBUG__||__SENTRY_DEBUG__)&&a.kg.warn(`[Tracing] Did not create ${r} transaction because _latestRouteName is missing.`));const u=this._getCurrentHub(),{location:d}=l,p={name:this._latestRouteName,op:r,trimEnd:!0,metadata:{source:this._latestRouteSource||"url"}};e=(0,i.l)(u,p,t,n,!0,{location:d},s)};["click"].forEach((e=>{addEventListener(e,t,{once:!1,capture:!0})}))}}function F(e){const t=(0,u.qT)(`meta[name=${e}]`);return t?t.getAttribute("content"):null}var q,L=n(758),V=n(8903),H=n(8069),z=n(6956);!function(e){e.Ok="ok",e.DeadlineExceeded="deadline_exceeded",e.Unauthenticated="unauthenticated",e.PermissionDenied="permission_denied",e.NotFound="not_found",e.ResourceExhausted="resource_exhausted",e.InvalidArgument="invalid_argument",e.Unimplemented="unimplemented",e.Unavailable="unavailable",e.InternalError="internal_error",e.UnknownError="unknown_error",e.Cancelled="cancelled",e.AlreadyExists="already_exists",e.FailedPrecondition="failed_precondition",e.Aborted="aborted",e.OutOfRange="out_of_range",e.DataLoss="data_loss"}(q||(q={}));var J=n(2716),W=n(8737),X=n(1791),Z=n(6169),K=n(24),Q=n(1370),ee=n(9889);const te=Y,ne=L.r,se=o.x1,ie=r.q,re=V.Zd,oe=H.Y,ae=V.Dr,ce=G,ue=M,le=D.z,de=z.rt,pe=r.K,he=s.io,fe=j,_e=i.l,ge=q,me={BrowserTracing:te,Apollo:J._,Express:W.N,GraphQL:X.k,Mongo:Z._,Mysql:K.m,Postgres:Q.E,Prisma:ee.g};("undefined"==typeof __SENTRY_TRACING__||__SENTRY_TRACING__)&&(0,L.r)()},9181:(e,t,n)=>{"use strict";n.d(t,{EN:()=>u,IQ:()=>l,bU:()=>r});var s=n(7597),i=n(2343);const r="baggage",o="sentry-",a=/^sentry-/,c=8192;function u(e){if(!(0,s.HD)(e)&&!Array.isArray(e))return;let t={};if(Array.isArray(e))t=e.reduce(((e,t)=>({...e,...d(t)})),{});else{if(!e)return;t=d(e)}const n=Object.entries(t).reduce(((e,[t,n])=>(t.match(a)&&(e[t.slice(o.length)]=n),e)),{});return Object.keys(n).length>0?n:void 0}function l(e){return function(e){if(0!==Object.keys(e).length)return Object.entries(e).reduce(((e,[t,n],s)=>{const r=`${encodeURIComponent(t)}=${encodeURIComponent(n)}`,o=0===s?r:`${e},${r}`;return o.length>c?(("undefined"==typeof __SENTRY_DEBUG__||__SENTRY_DEBUG__)&&i.kg.warn(`Not adding key: ${t} with val: ${n} to baggage header due to exceeding baggage size limits.`),e):o}),"")}(Object.entries(e).reduce(((e,[t,n])=>(n&&(e[`${o}${t}`]=n),e)),{}))}function d(e){return e.split(",").map((e=>e.split("=").map((e=>decodeURIComponent(e.trim()))))).reduce(((e,[t,n])=>(e[t]=n,e)),{})}},8464:(e,t,n)=>{"use strict";n.d(t,{Rt:()=>o,qT:()=>c});var s=n(7597);const i=(0,n(1235).Rf)(),r=80;function o(e,t={}){try{let n=e;const s=5,i=[];let o=0,c=0;const u=" > ",l=u.length;let d;const p=Array.isArray(t)?t:t.keyAttrs,h=!Array.isArray(t)&&t.maxStringLength||r;for(;n&&o++<s&&(d=a(n,p),!("html"===d||o>1&&c+i.length*l+d.length>=h));)i.push(d),c+=d.length,n=n.parentNode;return i.reverse().join(u)}catch(e){return"<unknown>"}}function a(e,t){const n=e,i=[];let r,o,a,c,u;if(!n||!n.tagName)return"";i.push(n.tagName.toLowerCase());const l=t&&t.length?t.filter((e=>n.getAttribute(e))).map((e=>[e,n.getAttribute(e)])):null;if(l&&l.length)l.forEach((e=>{i.push(`[${e[0]}="${e[1]}"]`)}));else if(n.id&&i.push(`#${n.id}`),r=n.className,r&&(0,s.HD)(r))for(o=r.split(/\s+/),u=0;u<o.length;u++)i.push(`.${o[u]}`);const d=["aria-label","type","name","title","alt"];for(u=0;u<d.length;u++)a=d[u],c=n.getAttribute(a),c&&i.push(`[${a}="${c}"]`);return i.join("")}function c(e){return i.document&&i.document.querySelector?i.document.querySelector(e):null}},4307:(e,t,n)=>{"use strict";function s(e){let t,n=e[0],s=1;for(;s<e.length;){const i=e[s],r=e[s+1];if(s+=2,("optionalAccess"===i||"optionalCall"===i)&&null==n)return;"access"===i||"optionalAccess"===i?(t=n,n=r(n)):"call"!==i&&"optionalCall"!==i||(n=r(((...e)=>n.call(t,...e))),t=void 0)}return n}n.d(t,{x:()=>s})},1688:(e,t,n)=>{"use strict";n.d(t,{xU:()=>p,oq:()=>g});var s=n(7597),i=n(2343),r=n(535),o=n(6147),a=n(1235);const c=(0,a.Rf)();function u(e){return e&&/^function fetch\(\)\s+\{\s+\[native code\]\s+\}$/.test(e.toString())}const l=(0,a.Rf)(),d=(0,a.Rf)(),p="__sentry_xhr_v2__",h={},f={};function _(e){if(!f[e])switch(f[e]=!0,e){case"console":"console"in d&&i.RU.forEach((function(e){e in d.console&&(0,r.hl)(d.console,e,(function(t){return function(...n){m("console",{args:n,level:e}),t&&t.apply(d.console,n)}}))}));break;case"dom":!function(){if(!("document"in d))return;const e=m.bind(null,"dom"),t=k(e,!0);d.document.addEventListener("click",t,!1),d.document.addEventListener("keypress",t,!1),["EventTarget","Node"].forEach((t=>{const n=d[t]&&d[t].prototype;n&&n.hasOwnProperty&&n.hasOwnProperty("addEventListener")&&((0,r.hl)(n,"addEventListener",(function(t){return function(n,s,i){if("click"===n||"keypress"==n)try{const s=this,r=s.__sentry_instrumentation_handlers__=s.__sentry_instrumentation_handlers__||{},o=r[n]=r[n]||{refCount:0};if(!o.handler){const s=k(e);o.handler=s,t.call(this,n,s,i)}o.refCount++}catch(e){}return t.call(this,n,s,i)}})),(0,r.hl)(n,"removeEventListener",(function(e){return function(t,n,s){if("click"===t||"keypress"==t)try{const n=this,i=n.__sentry_instrumentation_handlers__||{},r=i[t];r&&(r.refCount--,r.refCount<=0&&(e.call(this,t,r.handler,s),r.handler=void 0,delete i[t]),0===Object.keys(i).length&&delete n.__sentry_instrumentation_handlers__)}catch(e){}return e.call(this,t,n,s)}})))}))}();break;case"xhr":!function(){if(!("XMLHttpRequest"in d))return;const e=XMLHttpRequest.prototype;(0,r.hl)(e,"open",(function(e){return function(...t){const n=t[1],i=this[p]={method:(0,s.HD)(t[0])?t[0].toUpperCase():t[0],url:t[1],request_headers:{}};(0,s.HD)(n)&&"POST"===i.method&&n.match(/sentry_key/)&&(this.__sentry_own_request__=!0);const o=()=>{const e=this[p];if(e&&4===this.readyState){try{e.status_code=this.status}catch(e){}m("xhr",{args:t,endTimestamp:Date.now(),startTimestamp:Date.now(),xhr:this})}};return"onreadystatechange"in this&&"function"==typeof this.onreadystatechange?(0,r.hl)(this,"onreadystatechange",(function(e){return function(...t){return o(),e.apply(this,t)}})):this.addEventListener("readystatechange",o),(0,r.hl)(this,"setRequestHeader",(function(e){return function(...t){const[n,s]=t,i=this[p];return i&&(i.request_headers[n.toLowerCase()]=s),e.apply(this,t)}})),e.apply(this,t)}})),(0,r.hl)(e,"send",(function(e){return function(...t){const n=this[p];return n&&void 0!==t[0]&&(n.body=t[0]),m("xhr",{args:t,startTimestamp:Date.now(),xhr:this}),e.apply(this,t)}}))}();break;case"fetch":(function(){if(!function(){if(!("fetch"in c))return!1;try{return new Headers,new Request("http://www.example.com"),new Response,!0}catch(e){return!1}}())return!1;if(u(c.fetch))return!0;let e=!1;const t=c.document;if(t&&"function"==typeof t.createElement)try{const n=t.createElement("iframe");n.hidden=!0,t.head.appendChild(n),n.contentWindow&&n.contentWindow.fetch&&(e=u(n.contentWindow.fetch)),t.head.removeChild(n)}catch(e){("undefined"==typeof __SENTRY_DEBUG__||__SENTRY_DEBUG__)&&i.kg.warn("Could not create sandbox iframe for pure fetch check, bailing to window.fetch: ",e)}return e})()&&(0,r.hl)(d,"fetch",(function(e){return function(...t){const{method:n,url:s}=function(e){if(0===e.length)return{method:"GET",url:""};if(2===e.length){const[t,n]=e;return{url:b(t),method:y(n,"method")?String(n.method).toUpperCase():"GET"}}const t=e[0];return{url:b(t),method:y(t,"method")?String(t.method).toUpperCase():"GET"}}(t),i={args:t,fetchData:{method:n,url:s},startTimestamp:Date.now()};return m("fetch",{...i}),e.apply(d,t).then((e=>(m("fetch",{...i,endTimestamp:Date.now(),response:e}),e)),(e=>{throw m("fetch",{...i,endTimestamp:Date.now(),error:e}),e}))}}));break;case"history":!function(){if(!function(){const e=l.chrome,t=e&&e.app&&e.app.runtime,n="history"in l&&!!l.history.pushState&&!!l.history.replaceState;return!t&&n}())return;const e=d.onpopstate;function t(e){return function(...t){const n=t.length>2?t[2]:void 0;if(n){const e=v,t=String(n);v=t,m("history",{from:e,to:t})}return e.apply(this,t)}}d.onpopstate=function(...t){const n=d.location.href,s=v;if(v=n,m("history",{from:s,to:n}),e)try{return e.apply(this,t)}catch(e){}},(0,r.hl)(d.history,"pushState",t),(0,r.hl)(d.history,"replaceState",t)}();break;case"error":w=d.onerror,d.onerror=function(e,t,n,s,i){return m("error",{column:s,error:i,line:n,msg:e,url:t}),!(!w||w.__SENTRY_LOADER__)&&w.apply(this,arguments)},d.onerror.__SENTRY_INSTRUMENTED__=!0;break;case"unhandledrejection":I=d.onunhandledrejection,d.onunhandledrejection=function(e){return m("unhandledrejection",e),!(I&&!I.__SENTRY_LOADER__)||I.apply(this,arguments)},d.onunhandledrejection.__SENTRY_INSTRUMENTED__=!0;break;default:return void(("undefined"==typeof __SENTRY_DEBUG__||__SENTRY_DEBUG__)&&i.kg.warn("unknown instrumentation type:",e))}}function g(e,t){h[e]=h[e]||[],h[e].push(t),_(e)}function m(e,t){if(e&&h[e])for(const n of h[e]||[])try{n(t)}catch(t){("undefined"==typeof __SENTRY_DEBUG__||__SENTRY_DEBUG__)&&i.kg.error(`Error while triggering instrumentation handler.\nType: ${e}\nName: ${(0,o.$P)(n)}\nError:`,t)}}function y(e,t){return!!e&&"object"==typeof e&&!!e[t]}function b(e){return"string"==typeof e?e:e?y(e,"url")?e.url:e.toString?e.toString():"":""}let v;const E=1e3;let S,T;function k(e,t=!1){return n=>{if(!n||T===n)return;if(function(e){if("keypress"!==e.type)return!1;try{const t=e.target;if(!t||!t.tagName)return!0;if("INPUT"===t.tagName||"TEXTAREA"===t.tagName||t.isContentEditable)return!1}catch(e){}return!0}(n))return;const s="keypress"===n.type?"input":n.type;(void 0===S||function(e,t){if(!e)return!0;if(e.type!==t.type)return!0;try{if(e.target!==t.target)return!0}catch(e){}return!1}(T,n))&&(e({event:n,name:s,global:t}),T=n),clearTimeout(S),S=d.setTimeout((()=>{S=void 0}),E)}}let w=null,I=null},7597:(e,t,n)=>{"use strict";n.d(t,{Cy:()=>h,HD:()=>o,J8:()=>p,Kj:()=>d,PO:()=>c,V9:()=>_,VZ:()=>i,cO:()=>u,i2:()=>f,kK:()=>l,pt:()=>a});const s=Object.prototype.toString;function i(e){switch(s.call(e)){case"[object Error]":case"[object Exception]":case"[object DOMException]":return!0;default:return _(e,Error)}}function r(e,t){return s.call(e)===`[object ${t}]`}function o(e){return r(e,"String")}function a(e){return null===e||"object"!=typeof e&&"function"!=typeof e}function c(e){return r(e,"Object")}function u(e){return"undefined"!=typeof Event&&_(e,Event)}function l(e){return"undefined"!=typeof Element&&_(e,Element)}function d(e){return r(e,"RegExp")}function p(e){return Boolean(e&&e.then&&"function"==typeof e.then)}function h(e){return c(e)&&"nativeEvent"in e&&"preventDefault"in e&&"stopPropagation"in e}function f(e){return"number"==typeof e&&e!=e}function _(e,t){try{return e instanceof t}catch(e){return!1}}},2343:(e,t,n)=>{"use strict";n.d(t,{Cf:()=>r,RU:()=>i,kg:()=>a});var s=n(1235);const i=["debug","info","warn","error","log","assert","trace"];function r(e){if(!("console"in s.n2))return e();const t=s.n2.console,n={};i.forEach((e=>{const s=t[e]&&t[e].__sentry_original__;e in t&&s&&(n[e]=t[e],t[e]=s)}));try{return e()}finally{Object.keys(n).forEach((e=>{t[e]=n[e]}))}}function o(){let e=!1;const t={enable:()=>{e=!0},disable:()=>{e=!1}};return"undefined"==typeof __SENTRY_DEBUG__||__SENTRY_DEBUG__?i.forEach((n=>{t[n]=(...t)=>{e&&r((()=>{s.n2.console[n](`Sentry Logger [${n}]:`,...t)}))}})):i.forEach((e=>{t[e]=()=>{}})),t}let a;a="undefined"==typeof __SENTRY_DEBUG__||__SENTRY_DEBUG__?(0,s.YO)("logger",o):o()},2844:(e,t,n)=>{"use strict";n.d(t,{DM:()=>o,Db:()=>u,EG:()=>l,J4:()=>p,YO:()=>f,go:()=>h,jH:()=>c,lE:()=>_});var s=n(535),i=n(7321),r=n(1235);function o(){const e=r.n2,t=e.crypto||e.msCrypto;if(t&&t.randomUUID)return t.randomUUID().replace(/-/g,"");const n=t&&t.getRandomValues?()=>t.getRandomValues(new Uint8Array(1))[0]:()=>16*Math.random();return([1e7]+1e3+4e3+8e3+1e11).replace(/[018]/g,(e=>(e^(15&n())>>e/4).toString(16)))}function a(e){return e.exception&&e.exception.values?e.exception.values[0]:void 0}function c(e){const{message:t,event_id:n}=e;if(t)return t;const s=a(e);return s?s.type&&s.value?`${s.type}: ${s.value}`:s.type||s.value||n||"<unknown>":n||"<unknown>"}function u(e,t,n){const s=e.exception=e.exception||{},i=s.values=s.values||[],r=i[0]=i[0]||{};r.value||(r.value=t||""),r.type||(r.type=n||"Error")}function l(e,t){const n=a(e);if(!n)return;const s=n.mechanism;if(n.mechanism={type:"generic",handled:!0,...s,...t},t&&"data"in t){const e={...s&&s.data,...t.data};n.mechanism.data=e}}const d=/^(0|[1-9]\d*)\.(0|[1-9]\d*)\.(0|[1-9]\d*)(?:-((?:0|[1-9]\d*|\d*[a-zA-Z-][0-9a-zA-Z-]*)(?:\.(?:0|[1-9]\d*|\d*[a-zA-Z-][0-9a-zA-Z-]*))*))?(?:\+([0-9a-zA-Z-]+(?:\.[0-9a-zA-Z-]+)*))?$/;function p(e){const t=e.match(d)||[],n=parseInt(t[1],10),s=parseInt(t[2],10),i=parseInt(t[3],10);return{buildmetadata:t[5],major:isNaN(n)?void 0:n,minor:isNaN(s)?void 0:s,patch:isNaN(i)?void 0:i,prerelease:t[4]}}function h(e,t,n=5){if(void 0===t.lineno)return;const s=e.length,r=Math.max(Math.min(s,t.lineno-1),0);t.pre_context=e.slice(Math.max(0,r-n),r).map((e=>(0,i.JM)(e,0))),t.context_line=(0,i.JM)(e[Math.min(s-1,r)],t.colno||0),t.post_context=e.slice(Math.min(r+1,s),r+1+n).map((e=>(0,i.JM)(e,0)))}function f(e){if(e&&e.__sentry_captured__)return!0;try{(0,s.xp)(e,"__sentry_captured__",!0)}catch(e){}return!1}function _(e){return Array.isArray(e)?e:[e]}},2176:(e,t,n)=>{"use strict";function s(){return!("undefined"!=typeof __SENTRY_BROWSER_BUNDLE__&&__SENTRY_BROWSER_BUNDLE__)&&"[object process]"===Object.prototype.toString.call("undefined"!=typeof process?process:0)}function i(e,t){return e.require(t)}function r(t){let n;try{n=i(e,t)}catch(e){}try{const{cwd:s}=i(e,"process");n=i(e,`${s()}/node_modules/${t}`)}catch(e){}return n}n.d(t,{l$:()=>i,KV:()=>s,$y:()=>r}),e=n.hmd(e)},535:(e,t,n)=>{"use strict";n.d(t,{HK:()=>c,Jr:()=>f,Sh:()=>l,_j:()=>u,hl:()=>o,xp:()=>a,zf:()=>h});var s=n(8464),i=n(7597),r=n(7321);function o(e,t,n){if(!(t in e))return;const s=e[t],i=n(s);if("function"==typeof i)try{!function(e,t){const n=t.prototype||{};e.prototype=t.prototype=n,a(e,"__sentry_original__",t)}(i,s)}catch(e){}e[t]=i}function a(e,t,n){Object.defineProperty(e,t,{value:n,writable:!0,configurable:!0})}function c(e){return e.__sentry_original__}function u(e){return Object.keys(e).map((t=>`${encodeURIComponent(t)}=${encodeURIComponent(e[t])}`)).join("&")}function l(e){if((0,i.VZ)(e))return{message:e.message,name:e.name,stack:e.stack,...p(e)};if((0,i.cO)(e)){const t={type:e.type,target:d(e.target),currentTarget:d(e.currentTarget),...p(e)};return"undefined"!=typeof CustomEvent&&(0,i.V9)(e,CustomEvent)&&(t.detail=e.detail),t}return e}function d(e){try{return(0,i.kK)(e)?(0,s.Rt)(e):Object.prototype.toString.call(e)}catch(e){return"<unknown>"}}function p(e){if("object"==typeof e&&null!==e){const t={};for(const n in e)Object.prototype.hasOwnProperty.call(e,n)&&(t[n]=e[n]);return t}return{}}function h(e,t=40){const n=Object.keys(l(e));if(n.sort(),!n.length)return"[object has no keys]";if(n[0].length>=t)return(0,r.$G)(n[0],t);for(let e=n.length;e>0;e--){const s=n.slice(0,e).join(", ");if(!(s.length>t))return e===n.length?s:(0,r.$G)(s,t)}return""}function f(e){return _(e,new Map)}function _(e,t){if((0,i.PO)(e)){const n=t.get(e);if(void 0!==n)return n;const s={};t.set(e,s);for(const n of Object.keys(e))void 0!==e[n]&&(s[n]=_(e[n],t));return s}if(Array.isArray(e)){const n=t.get(e);if(void 0!==n)return n;const s=[];return t.set(e,s),e.forEach((e=>{s.push(_(e,t))})),s}return e}},442:(e,t,n)=>{"use strict";n.d(t,{dB:()=>i,oA:()=>r});var s=n(6956);function i(e,t,n){e&&(e.metadata.source&&"url"!==e.metadata.source||e.setName(...r(t,{path:!0,method:!0})),e.setData("url",t.originalUrl||t.url),t.baseUrl&&e.setData("baseUrl",t.baseUrl),e.setData("query",function(e,t){let n=e.originalUrl||e.url||"";if(n)return n.startsWith("/")&&(n=`http://dogs.are.great${n}`),e.query||void 0!==typeof URL&&new URL(n).search.replace("?","")||t&&t.url&&t.url.parse(n).query||void 0}(t,n)))}function r(e,t={}){const n=e.method&&e.method.toUpperCase();let i="",r="url";t.customRoute||e.route?(i=t.customRoute||`${e.baseUrl||""}${e.route&&e.route.path}`,r="route"):(e.originalUrl||e.url)&&(i=(0,s.rt)(e.originalUrl||e.url||""));let o="";return t.method&&n&&(o+=n),t.method&&t.path&&(o+=" "),t.path&&i&&(o+=i),[o,r]}},6147:(e,t,n)=>{"use strict";function s(e){const t=/^\s*[-]{4,}$/,n=/at (?:async )?(?:(.+?)\s+\()?(?:(.+):(\d+):(\d+)?|([^)]+))\)?/;return s=>{const i=s.match(n);if(i){let t,n,s,r,o;if(i[1]){s=i[1];let e=s.lastIndexOf(".");if("."===s[e-1]&&e--,e>0){t=s.slice(0,e),n=s.slice(e+1);const i=t.indexOf(".Module");i>0&&(s=s.slice(i+1),t=t.slice(0,i))}r=void 0}n&&(r=t,o=n),"<anonymous>"===n&&(o=void 0,s=void 0),void 0===s&&(o=o||"<anonymous>",s=r?`${r}.${o}`:o);let a=i[2]&&i[2].startsWith("file://")?i[2].slice(7):i[2];const c="native"===i[5];a||!i[5]||c||(a=i[5]);const u=!(c||a&&!a.startsWith("/")&&!a.includes(":\\")&&!a.startsWith(".")&&!a.match(/^[a-zA-Z]([a-zA-Z0-9.\-+])*:\/\//)||void 0===a||a.includes("node_modules/"));return{filename:a,module:e?e(a):void 0,function:s,lineno:parseInt(i[3],10)||void 0,colno:parseInt(i[4],10)||void 0,in_app:u}}if(s.match(t))return{filename:s}}}n.d(t,{pE:()=>o,$P:()=>u,Ep:()=>l,Sq:()=>a});const i=50,r=/\(error: (.*)\)/;function o(...e){const t=e.sort(((e,t)=>e[0]-t[0])).map((e=>e[1]));return(e,n=0)=>{const s=[],o=e.split("\n");for(let e=n;e<o.length;e++){const n=o[e];if(n.length>1024)continue;const a=r.test(n)?n.replace(r,"$1"):n;if(!a.match(/\S*Error: /)){for(const e of t){const t=e(a);if(t){s.push(t);break}}if(s.length>=i)break}}return function(e){if(!e.length)return[];const t=e.slice(0,i),n=t[t.length-1].function;n&&/sentryWrapped/.test(n)&&t.pop(),t.reverse();const s=t[t.length-1].function;return s&&/captureMessage|captureException/.test(s)&&t.pop(),t.map((e=>({...e,filename:e.filename||t[t.length-1].filename,function:e.function||"?"})))}(s)}}function a(e){return Array.isArray(e)?o(...e):e}const c="<anonymous>";function u(e){try{return e&&"function"==typeof e&&e.name||c}catch(e){return c}}function l(e){return[90,s(e)]}},7321:(e,t,n)=>{"use strict";n.d(t,{$G:()=>i,JM:()=>r,U0:()=>o});var s=n(7597);function i(e,t=0){return"string"!=typeof e||0===t||e.length<=t?e:`${e.slice(0,t)}...`}function r(e,t){let n=e;const s=n.length;if(s<=150)return n;t>s&&(t=s);let i=Math.max(t-60,0);i<5&&(i=0);let r=Math.min(i+140,s);return r>s-5&&(r=s),r===s&&(i=Math.max(r-140,0)),n=n.slice(i,r),i>0&&(n=`'{snip} ${n}`),r<s&&(n+=" {snip}"),n}function o(e,t=[],n=!1){return t.some((t=>function(e,t,n=!1){return!!(0,s.HD)(e)&&((0,s.Kj)(t)?t.test(e):!!(0,s.HD)(t)&&(n?e===t:e.includes(t)))}(e,t,n)))}},6893:(e,t,n)=>{"use strict";n.d(t,{$2:()=>o,WD:()=>r,cW:()=>a});var s,i=n(7597);function r(e){return new a((t=>{t(e)}))}function o(e){return new a(((t,n)=>{n(e)}))}!function(e){e[e.PENDING=0]="PENDING",e[e.RESOLVED=1]="RESOLVED",e[e.REJECTED=2]="REJECTED"}(s||(s={}));class a{__init(){this._state=s.PENDING}__init2(){this._handlers=[]}constructor(e){a.prototype.__init.call(this),a.prototype.__init2.call(this),a.prototype.__init3.call(this),a.prototype.__init4.call(this),a.prototype.__init5.call(this),a.prototype.__init6.call(this);try{e(this._resolve,this._reject)}catch(e){this._reject(e)}}then(e,t){return new a(((n,s)=>{this._handlers.push([!1,t=>{if(e)try{n(e(t))}catch(e){s(e)}else n(t)},e=>{if(t)try{n(t(e))}catch(e){s(e)}else s(e)}]),this._executeHandlers()}))}catch(e){return this.then((e=>e),e)}finally(e){return new a(((t,n)=>{let s,i;return this.then((t=>{i=!1,s=t,e&&e()}),(t=>{i=!0,s=t,e&&e()})).then((()=>{i?n(s):t(s)}))}))}__init3(){this._resolve=e=>{this._setResult(s.RESOLVED,e)}}__init4(){this._reject=e=>{this._setResult(s.REJECTED,e)}}__init5(){this._setResult=(e,t)=>{this._state===s.PENDING&&((0,i.J8)(t)?t.then(this._resolve,this._reject):(this._state=e,this._value=t,this._executeHandlers()))}}__init6(){this._executeHandlers=()=>{if(this._state===s.PENDING)return;const e=this._handlers.slice();this._handlers=[],e.forEach((e=>{e[0]||(this._state===s.RESOLVED&&e[1](this._value),this._state===s.REJECTED&&e[2](this._value),e[0]=!0)}))}}}},1170:(e,t,n)=>{"use strict";n.d(t,{Z1:()=>p,ph:()=>l,yW:()=>u});var s=n(2176),i=n(1235);e=n.hmd(e);const r=(0,i.Rf)(),o={nowSeconds:()=>Date.now()/1e3},a=(0,s.KV)()?function(){try{return(0,s.l$)(e,"perf_hooks").performance}catch(e){return}}():function(){const{performance:e}=r;if(e&&e.now)return{now:()=>e.now(),timeOrigin:Date.now()-e.now()}}(),c=void 0===a?o:{nowSeconds:()=>(a.timeOrigin+a.now())/1e3},u=o.nowSeconds.bind(o),l=c.nowSeconds.bind(c);let d;const p=(()=>{const{performance:e}=r;if(!e||!e.now)return void(d="none");const t=36e5,n=e.now(),s=Date.now(),i=e.timeOrigin?Math.abs(e.timeOrigin+n-s):t,o=i<t,a=e.timing&&e.timing.navigationStart,c="number"==typeof a?Math.abs(a+n-s):t;return o||c<t?i<=c?(d="timeOrigin",e.timeOrigin):(d="navigationStart",a):(d="dateNow",s)})()},7638:(e,t,n)=>{"use strict";n.d(t,{K:()=>s,q:()=>i});const s=new RegExp("^[ \\t]*([0-9a-f]{32})?-?([0-9a-f]{16})?-?([01])?[ \\t]*$");function i(e){const t=e.match(s);if(!e||!t)return;let n;return"1"===t[3]?n=!0:"0"===t[3]&&(n=!1),{traceId:t[1],parentSampled:n,parentSpanId:t[2]}}},6956:(e,t,n)=>{"use strict";function s(e){return e.split(/[\?#]/,1)[0]}function i(e){return e.split(/\\?\//).filter((e=>e.length>0&&","!==e)).length}n.d(t,{$A:()=>i,rt:()=>s})},1235:(e,t,n)=>{"use strict";function s(e){return e&&e.Math==Math?e:void 0}n.d(t,{Rf:()=>r,YO:()=>o,n2:()=>i});const i="object"==typeof globalThis&&s(globalThis)||"object"==typeof window&&s(window)||"object"==typeof self&&s(self)||"object"==typeof global&&s(global)||function(){return this}()||{};function r(){return i}function o(e,t,n){const s=n||i,r=s.__SENTRY__=s.__SENTRY__||{};return r[e]||(r[e]=t())}},8054:function(e,t,n){"use strict";var s=this&&this.__importDefault||function(e){return e&&e.__esModule?e:{default:e}};const i=n(2361),r=s(n(5158)),o=s(n(6304)),a=r.default("agent-base");function c(){const{stack:e}=new Error;return"string"==typeof e&&e.split("\n").some((e=>-1!==e.indexOf("(https.js:")||-1!==e.indexOf("node:https:")))}function u(e,t){return new u.Agent(e,t)}!function(e){class t extends i.EventEmitter{constructor(e,t){super();let n=t;"function"==typeof e?this.callback=e:e&&(n=e),this.timeout=null,n&&"number"==typeof n.timeout&&(this.timeout=n.timeout),this.maxFreeSockets=1,this.maxSockets=1,this.maxTotalSockets=1/0,this.sockets={},this.freeSockets={},this.requests={},this.options={}}get defaultPort(){return"number"==typeof this.explicitDefaultPort?this.explicitDefaultPort:c()?443:80}set defaultPort(e){this.explicitDefaultPort=e}get protocol(){return"string"==typeof this.explicitProtocol?this.explicitProtocol:c()?"https:":"http:"}set protocol(e){this.explicitProtocol=e}callback(e,t,n){throw new Error('"agent-base" has no default implementation, you must subclass and override `callback()`')}addRequest(e,t){const n=Object.assign({},t);"boolean"!=typeof n.secureEndpoint&&(n.secureEndpoint=c()),null==n.host&&(n.host="localhost"),null==n.port&&(n.port=n.secureEndpoint?443:80),null==n.protocol&&(n.protocol=n.secureEndpoint?"https:":"http:"),n.host&&n.path&&delete n.path,delete n.agent,delete n.hostname,delete n._defaultAgent,delete n.defaultPort,delete n.createConnection,e._last=!0,e.shouldKeepAlive=!1;let s=!1,i=null;const r=n.timeout||this.timeout,u=t=>{e._hadError||(e.emit("error",t),e._hadError=!0)},l=()=>{i=null,s=!0;const e=new Error(`A "socket" was not created for HTTP request before ${r}ms`);e.code="ETIMEOUT",u(e)},d=e=>{s||(null!==i&&(clearTimeout(i),i=null),u(e))},p=t=>{if(s)return;if(null!=i&&(clearTimeout(i),i=null),r=t,Boolean(r)&&"function"==typeof r.addRequest)return a("Callback returned another Agent instance %o",t.constructor.name),void t.addRequest(e,n);var r;if(t)return t.once("free",(()=>{this.freeSocket(t,n)})),void e.onSocket(t);const o=new Error(`no Duplex stream was returned to agent-base for \`${e.method} ${e.path}\``);u(o)};if("function"==typeof this.callback){this.promisifiedCallback||(this.callback.length>=3?(a("Converting legacy callback function to promise"),this.promisifiedCallback=o.default(this.callback)):this.promisifiedCallback=this.callback),"number"==typeof r&&r>0&&(i=setTimeout(l,r)),"port"in n&&"number"!=typeof n.port&&(n.port=Number(n.port));try{a("Resolving socket for %o request: %o",n.protocol,`${e.method} ${e.path}`),Promise.resolve(this.promisifiedCallback(e,n)).then(p,d)}catch(e){Promise.reject(e).catch(d)}}else u(new Error("`callback` is not defined"))}freeSocket(e,t){a("Freeing socket %o %o",e.constructor.name,t),e.destroy()}destroy(){a("Destroying agent %o",this.constructor.name)}}e.Agent=t,e.prototype=e.Agent.prototype}(u||(u={})),e.exports=u},6304:(e,t)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.default=function(e){return function(t,n){return new Promise(((s,i)=>{e.call(this,t,n,((e,t)=>{e?i(e):s(t)}))}))}}},6489:(e,t)=>{"use strict";t.Q=function(e,t){if("string"!=typeof e)throw new TypeError("argument str must be a string");for(var i={},r=t||{},o=e.split(";"),a=r.decode||n,c=0;c<o.length;c++){var u=o[c],l=u.indexOf("=");if(!(l<0)){var d=u.substring(0,l).trim();if(null==i[d]){var p=u.substring(l+1,u.length).trim();'"'===p[0]&&(p=p.slice(1,-1)),i[d]=s(p,a)}}}return i};var n=decodeURIComponent;encodeURIComponent;function s(e,t){try{return t(e)}catch(t){return e}}},7319:(e,t,n)=>{"use strict";const s=n(4341);e.exports=(e,t={})=>{if("function"!=typeof e)throw new TypeError(`Expected the first argument to be a function, got \`${typeof e}\``);const{wait:n=0,maxWait:i=0,before:r=!1,after:o=!0}=t;if(!r&&!o)throw new Error("Both `before` and `after` are false, function wouldn't be called.");let a,c,u;const l=function(...t){const s=this,l=r&&!a;return clearTimeout(a),a=setTimeout((()=>{a=void 0,c&&(clearTimeout(c),c=void 0),o&&(u=e.apply(s,t))}),n),i>0&&!c&&o&&(c=setTimeout((()=>{c=void 0,a&&(clearTimeout(a),a=void 0),u=e.apply(s,t)}),i)),l&&(u=e.apply(s,t)),u};return s(l,e),l.cancel=()=>{a&&(clearTimeout(a),a=void 0),c&&(clearTimeout(c),c=void 0)},l}},1227:(e,t,n)=>{t.formatArgs=function(t){if(t[0]=(this.useColors?"%c":"")+this.namespace+(this.useColors?" %c":" ")+t[0]+(this.useColors?"%c ":" ")+"+"+e.exports.humanize(this.diff),!this.useColors)return;const n="color: "+this.color;t.splice(1,0,n,"color: inherit");let s=0,i=0;t[0].replace(/%[a-zA-Z%]/g,(e=>{"%%"!==e&&(s++,"%c"===e&&(i=s))})),t.splice(i,0,n)},t.save=function(e){try{e?t.storage.setItem("debug",e):t.storage.removeItem("debug")}catch(e){}},t.load=function(){let e;try{e=t.storage.getItem("debug")}catch(e){}return!e&&"undefined"!=typeof process&&"env"in process&&(e=process.env.DEBUG),e},t.useColors=function(){return!("undefined"==typeof window||!window.process||"renderer"!==window.process.type&&!window.process.__nwjs)||("undefined"==typeof navigator||!navigator.userAgent||!navigator.userAgent.toLowerCase().match(/(edge|trident)\/(\d+)/))&&("undefined"!=typeof document&&document.documentElement&&document.documentElement.style&&document.documentElement.style.WebkitAppearance||"undefined"!=typeof window&&window.console&&(window.console.firebug||window.console.exception&&window.console.table)||"undefined"!=typeof navigator&&navigator.userAgent&&navigator.userAgent.toLowerCase().match(/firefox\/(\d+)/)&&parseInt(RegExp.$1,10)>=31||"undefined"!=typeof navigator&&navigator.userAgent&&navigator.userAgent.toLowerCase().match(/applewebkit\/(\d+)/))},t.storage=function(){try{return localStorage}catch(e){}}(),t.destroy=(()=>{let e=!1;return()=>{e||(e=!0,console.warn("Instance method `debug.destroy()` is deprecated and no longer does anything. It will be removed in the next major version of `debug`."))}})(),t.colors=["#0000CC","#0000FF","#0033CC","#0033FF","#0066CC","#0066FF","#0099CC","#0099FF","#00CC00","#00CC33","#00CC66","#00CC99","#00CCCC","#00CCFF","#3300CC","#3300FF","#3333CC","#3333FF","#3366CC","#3366FF","#3399CC","#3399FF","#33CC00","#33CC33","#33CC66","#33CC99","#33CCCC","#33CCFF","#6600CC","#6600FF","#6633CC","#6633FF","#66CC00","#66CC33","#9900CC","#9900FF","#9933CC","#9933FF","#99CC00","#99CC33","#CC0000","#CC0033","#CC0066","#CC0099","#CC00CC","#CC00FF","#CC3300","#CC3333","#CC3366","#CC3399","#CC33CC","#CC33FF","#CC6600","#CC6633","#CC9900","#CC9933","#CCCC00","#CCCC33","#FF0000","#FF0033","#FF0066","#FF0099","#FF00CC","#FF00FF","#FF3300","#FF3333","#FF3366","#FF3399","#FF33CC","#FF33FF","#FF6600","#FF6633","#FF9900","#FF9933","#FFCC00","#FFCC33"],t.log=console.debug||console.log||(()=>{}),e.exports=n(2447)(t);const{formatters:s}=e.exports;s.j=function(e){try{return JSON.stringify(e)}catch(e){return"[UnexpectedJSONParseError]: "+e.message}}},2447:(e,t,n)=>{e.exports=function(e){function t(e){let n,i,r,o=null;function a(...e){if(!a.enabled)return;const s=a,i=Number(new Date),r=i-(n||i);s.diff=r,s.prev=n,s.curr=i,n=i,e[0]=t.coerce(e[0]),"string"!=typeof e[0]&&e.unshift("%O");let o=0;e[0]=e[0].replace(/%([a-zA-Z%])/g,((n,i)=>{if("%%"===n)return"%";o++;const r=t.formatters[i];if("function"==typeof r){const t=e[o];n=r.call(s,t),e.splice(o,1),o--}return n})),t.formatArgs.call(s,e),(s.log||t.log).apply(s,e)}return a.namespace=e,a.useColors=t.useColors(),a.color=t.selectColor(e),a.extend=s,a.destroy=t.destroy,Object.defineProperty(a,"enabled",{enumerable:!0,configurable:!1,get:()=>null!==o?o:(i!==t.namespaces&&(i=t.namespaces,r=t.enabled(e)),r),set:e=>{o=e}}),"function"==typeof t.init&&t.init(a),a}function s(e,n){const s=t(this.namespace+(void 0===n?":":n)+e);return s.log=this.log,s}function i(e){return e.toString().substring(2,e.toString().length-2).replace(/\.\*\?$/,"*")}return t.debug=t,t.default=t,t.coerce=function(e){return e instanceof Error?e.stack||e.message:e},t.disable=function(){const e=[...t.names.map(i),...t.skips.map(i).map((e=>"-"+e))].join(",");return t.enable(""),e},t.enable=function(e){let n;t.save(e),t.namespaces=e,t.names=[],t.skips=[];const s=("string"==typeof e?e:"").split(/[\s,]+/),i=s.length;for(n=0;n<i;n++)s[n]&&("-"===(e=s[n].replace(/\*/g,".*?"))[0]?t.skips.push(new RegExp("^"+e.slice(1)+"$")):t.names.push(new RegExp("^"+e+"$")))},t.enabled=function(e){if("*"===e[e.length-1])return!0;let n,s;for(n=0,s=t.skips.length;n<s;n++)if(t.skips[n].test(e))return!1;for(n=0,s=t.names.length;n<s;n++)if(t.names[n].test(e))return!0;return!1},t.humanize=n(7824),t.destroy=function(){console.warn("Instance method `debug.destroy()` is deprecated and no longer does anything. It will be removed in the next major version of `debug`.")},Object.keys(e).forEach((n=>{t[n]=e[n]})),t.names=[],t.skips=[],t.formatters={},t.selectColor=function(e){let n=0;for(let t=0;t<e.length;t++)n=(n<<5)-n+e.charCodeAt(t),n|=0;return t.colors[Math.abs(n)%t.colors.length]},t.enable(t.load()),t}},5158:(e,t,n)=>{"undefined"==typeof process||"renderer"===process.type||!0===process.browser||process.__nwjs?e.exports=n(1227):e.exports=n(39)},39:(e,t,n)=>{const s=n(6224),i=n(3837);t.init=function(e){e.inspectOpts={};const n=Object.keys(t.inspectOpts);for(let s=0;s<n.length;s++)e.inspectOpts[n[s]]=t.inspectOpts[n[s]]},t.log=function(...e){return process.stderr.write(i.format(...e)+"\n")},t.formatArgs=function(n){const{namespace:s,useColors:i}=this;if(i){const t=this.color,i="[3"+(t<8?t:"8;5;"+t),r=`  ${i};1m${s} [0m`;n[0]=r+n[0].split("\n").join("\n"+r),n.push(i+"m+"+e.exports.humanize(this.diff)+"[0m")}else n[0]=(t.inspectOpts.hideDate?"":(new Date).toISOString()+" ")+s+" "+n[0]},t.save=function(e){e?process.env.DEBUG=e:delete process.env.DEBUG},t.load=function(){return process.env.DEBUG},t.useColors=function(){return"colors"in t.inspectOpts?Boolean(t.inspectOpts.colors):s.isatty(process.stderr.fd)},t.destroy=i.deprecate((()=>{}),"Instance method `debug.destroy()` is deprecated and no longer does anything. It will be removed in the next major version of `debug`."),t.colors=[6,2,3,4,5,1];try{const e=n(2130);e&&(e.stderr||e).level>=2&&(t.colors=[20,21,26,27,32,33,38,39,40,41,42,43,44,45,56,57,62,63,68,69,74,75,76,77,78,79,80,81,92,93,98,99,112,113,128,129,134,135,148,149,160,161,162,163,164,165,166,167,168,169,170,171,172,173,178,179,184,185,196,197,198,199,200,201,202,203,204,205,206,207,208,209,214,215,220,221])}catch(e){}t.inspectOpts=Object.keys(process.env).filter((e=>/^debug_/i.test(e))).reduce(((e,t)=>{const n=t.substring(6).toLowerCase().replace(/_([a-z])/g,((e,t)=>t.toUpperCase()));let s=process.env[t];return s=!!/^(yes|on|true|enabled)$/i.test(s)||!/^(no|off|false|disabled)$/i.test(s)&&("null"===s?null:Number(s)),e[n]=s,e}),{}),e.exports=n(2447)(t);const{formatters:r}=e.exports;r.o=function(e){return this.inspectOpts.colors=this.useColors,i.inspect(e,this.inspectOpts).split("\n").map((e=>e.trim())).join(" ")},r.O=function(e){return this.inspectOpts.colors=this.useColors,i.inspect(e,this.inspectOpts)}},2559:e=>{!function(){"use strict";var t=[,function(e,t){function n(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,s=new Array(t);n<t;n++)s[n]=e[n];return s}function s(e){return s="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(e){return typeof e}:function(e){return e&&"function"==typeof Symbol&&e.constructor===Symbol&&e!==Symbol.prototype?"symbol":typeof e},s(e)}Object.defineProperty(t,"__esModule",{value:!0}),t.lengthOf=t.keysOf=t.isObject=t.isInfOrNaN=t.isFunction=t.isArguments=t.hasOwn=t.handleError=t.convertMapToObject=t.checkError=void 0,t.isFunction=function(e){return"function"==typeof e},t.isObject=function(e){return"object"===s(e)},t.keysOf=function(e){return Object.keys(e)},t.lengthOf=function(e){return Object.keys(e).length};var i=function(e,t){return Object.prototype.hasOwnProperty.call(e,t)};t.hasOwn=i,t.convertMapToObject=function(e){return Array.from(e).reduce((function(e,t){var s,i,r=(i=2,function(e){if(Array.isArray(e))return e}(s=t)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=n){var s,i,r=[],o=!0,a=!1;try{for(n=n.call(e);!(o=(s=n.next()).done)&&(r.push(s.value),!t||r.length!==t);o=!0);}catch(e){a=!0,i=e}finally{try{o||null==n.return||n.return()}finally{if(a)throw i}}return r}}(s,i)||function(e,t){if(e){if("string"==typeof e)return n(e,t);var s=Object.prototype.toString.call(e).slice(8,-1);return"Object"===s&&e.constructor&&(s=e.constructor.name),"Map"===s||"Set"===s?Array.from(e):"Arguments"===s||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(s)?n(e,t):void 0}}(s,i)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()),o=r[0],a=r[1];return e[o]=a,e}),{})},t.isArguments=function(e){return null!=e&&i(e,"callee")},t.isInfOrNaN=function(e){return Number.isNaN(e)||e===1/0||e===-1/0};var r={maxStack:function(e){return new RegExp("Maximum call stack size exceeded","g").test(e)}};t.checkError=r,t.handleError=function(e){return function(){try{return e.apply(this,arguments)}catch(e){if(r.maxStack(e.message))throw new Error("Converting circular structure to JSON");throw e}}}},function(e,t){Object.defineProperty(t,"__esModule",{value:!0}),t.Base64=void 0;for(var n=Object.create(null),s=function(e){return"ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/".charAt(e)},i=0;i<64;i++)n[s(i)]=i;var r=function(e){if("undefined"==typeof Uint8Array||"undefined"==typeof ArrayBuffer){for(var t=[],n=0;n<e;n++)t.push(0);return t.$Uint8ArrayPolyfill=!0,t}return new Uint8Array(new ArrayBuffer(e))},o={encode:function(e){if("string"==typeof e){var t=e;e=r(t.length);for(var n=0;n<t.length;n++){var i=t.charCodeAt(n);if(i>255)throw new Error("Not ascii. Base64.encode can only take ascii strings.");e[n]=i}}for(var o=[],a=null,c=null,u=null,l=null,d=0;d<e.length;d++)switch(d%3){case 0:a=e[d]>>2&63,c=(3&e[d])<<4;break;case 1:c|=e[d]>>4&15,u=(15&e[d])<<2;break;case 2:u|=e[d]>>6&3,l=63&e[d],o.push(s(a)),o.push(s(c)),o.push(s(u)),o.push(s(l)),a=null,c=null,u=null,l=null}return null!=a&&(o.push(s(a)),o.push(s(c)),null==u?o.push("="):o.push(s(u)),null==l&&o.push("=")),o.join("")},decode:function(e){var t=Math.floor(3*e.length/4);"="==e.charAt(e.length-1)&&(t--,"="==e.charAt(e.length-2)&&t--);for(var s,i=r(t),o=null,a=null,c=null,u=0,l=0;l<e.length;l++){var d="="===(s=e.charAt(l))?-1:n[s];switch(l%4){case 0:if(d<0)throw new Error("invalid base64 string");o=d<<2;break;case 1:if(d<0)throw new Error("invalid base64 string");o|=d>>4,i[u++]=o,a=(15&d)<<4;break;case 2:d>=0&&(a|=d>>2,i[u++]=a,c=(3&d)<<6);break;case 3:d>=0&&(i[u++]=c|d)}}return i},newBinary:r};t.Base64=o},function(e){e.exports={_noYieldsAllowed:function(e){return e()}}},function(e,t){function n(e){return n="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(e){return typeof e}:function(e){return e&&"function"==typeof Symbol&&e.constructor===Symbol&&e!==Symbol.prototype?"symbol":typeof e},n(e)}function s(e){return JSON.stringify(e)}Object.defineProperty(t,"__esModule",{value:!0}),t.default=void 0;var i=function e(t,i,r,o,a){var c=i[t];switch(n(c)){case"string":return s(c);case"number":return isFinite(c)?String(c):"null";case"boolean":return String(c);case"object":if(!c)return"null";var u,l=o+r,d=[];if(Array.isArray(c)||{}.hasOwnProperty.call(c,"callee")){for(var p=c.length,h=0;h<p;h+=1)d[h]=e(h,c,r,l,a)||"null";return u=0===d.length?"[]":l?"[\n"+l+d.join(",\n"+l)+"\n"+o+"]":"["+d.join(",")+"]"}var f=Object.keys(c);return a&&(f=f.sort()),f.forEach((function(t){(u=e(t,c,r,l,a))&&d.push(s(t)+(l?": ":":")+u)})),u=0===d.length?"{}":l?"{\n"+l+d.join(",\n"+l)+"\n"+o+"}":"{"+d.join(",")+"}"}};t.default=function(e,t){var n=Object.assign({indent:"",canonical:!1},t);if(!0===n.indent)n.indent="  ";else if("number"==typeof n.indent){for(var s="",r=0;r<n.indent;r++)s+=" ";n.indent=s}return i("",{"":e},n.indent,"",n.canonical)},e.exports=t.default}],n={};function s(e){var i=n[e];if(void 0!==i)return i.exports;var r=n[e]={exports:{}};return t[e](r,r.exports,s),r.exports}var i={};!function(){var e=i,t=s(2).Base64,n=s(3);Object.defineProperty(e,"__esModule",{value:!0}),e.EJSON=void 0;var r=s(1),o={};e.EJSON=o;var a=new Map;o.addType=function(e,t){if(a.has(e))throw new Error("Type ".concat(e," already present"));a.set(e,t)};var c=[{matchJSONValue:function(e){return(0,r.hasOwn)(e,"$date")&&1===(0,r.lengthOf)(e)},matchObject:function(e){return e instanceof Date},toJSONValue:function(e){return{$date:e.getTime()}},fromJSONValue:function(e){return new Date(e.$date)}},{matchJSONValue:function(e){return(0,r.hasOwn)(e,"$regexp")&&(0,r.hasOwn)(e,"$flags")&&2===(0,r.lengthOf)(e)},matchObject:function(e){return e instanceof RegExp},toJSONValue:function(e){return{$regexp:e.source,$flags:e.flags}},fromJSONValue:function(e){return new RegExp(e.$regexp,e.$flags.slice(0,50).replace(/[^gimuy]/g,"").replace(/(.)(?=.*\1)/g,""))}},{matchJSONValue:function(e){return(0,r.hasOwn)(e,"$InfNaN")&&1===(0,r.lengthOf)(e)},matchObject:r.isInfOrNaN,toJSONValue:function(e){return{$InfNaN:Number.isNaN(e)?0:e===1/0?1:-1}},fromJSONValue:function(e){return e.$InfNaN/0}},{matchJSONValue:function(e){return(0,r.hasOwn)(e,"$binary")&&1===(0,r.lengthOf)(e)},matchObject:function(e){return"undefined"!=typeof Uint8Array&&e instanceof Uint8Array||e&&(0,r.hasOwn)(e,"$Uint8ArrayPolyfill")},toJSONValue:function(e){return{$binary:t.encode(e)}},fromJSONValue:function(e){return t.decode(e.$binary)}},{matchJSONValue:function(e){return(0,r.hasOwn)(e,"$escape")&&1===(0,r.lengthOf)(e)},matchObject:function(e){var t=!1;if(e){var n=(0,r.lengthOf)(e);1!==n&&2!==n||(t=c.some((function(t){return t.matchJSONValue(e)})))}return t},toJSONValue:function(e){var t={};return(0,r.keysOf)(e).forEach((function(n){t[n]=o.toJSONValue(e[n])})),{$escape:t}},fromJSONValue:function(e){var t={};return(0,r.keysOf)(e.$escape).forEach((function(n){t[n]=o.fromJSONValue(e.$escape[n])})),t}},{matchJSONValue:function(e){return(0,r.hasOwn)(e,"$type")&&(0,r.hasOwn)(e,"$value")&&2===(0,r.lengthOf)(e)},matchObject:function(e){return o._isCustomType(e)},toJSONValue:function(e){var t=n._noYieldsAllowed((function(){return e.toJSONValue()}));return{$type:e.typeName(),$value:t}},fromJSONValue:function(e){var t=e.$type;if(!a.has(t))throw new Error("Custom EJSON type ".concat(t," is not defined"));var s=a.get(t);return n._noYieldsAllowed((function(){return s(e.$value)}))}}];o._isCustomType=function(e){return e&&(0,r.isFunction)(e.toJSONValue)&&(0,r.isFunction)(e.typeName)&&a.has(e.typeName())},o._getTypes=function(){return arguments.length>0&&void 0!==arguments[0]&&arguments[0]?a:(0,r.convertMapToObject)(a)},o._getConverters=function(){return c};var u=function(e){for(var t=0;t<c.length;t++){var n=c[t];if(n.matchObject(e))return n.toJSONValue(e)}},l=function e(t){if(null===t)return null;var n=u(t);return void 0!==n?n:(0,r.isObject)(t)?((0,r.keysOf)(t).forEach((function(n){var s=t[n];if((0,r.isObject)(s)||void 0===s||(0,r.isInfOrNaN)(s)){var i=u(s);i?t[n]=i:e(s)}})),t):t};o._adjustTypesToJSONValue=l,o.toJSONValue=function(e){var t=u(e);if(void 0!==t)return t;var n=e;return(0,r.isObject)(e)&&(n=o.clone(e),l(n)),n};var d=function(e){if((0,r.isObject)(e)&&null!==e){var t=(0,r.keysOf)(e);if(t.length<=2&&t.every((function(e){return"string"==typeof e&&"$"===e.substr(0,1)})))for(var n=0;n<c.length;n++){var s=c[n];if(s.matchJSONValue(e))return s.fromJSONValue(e)}}return e},p=function e(t){if(null===t)return null;var n=d(t);return n!==t?n:(0,r.isObject)(t)?((0,r.keysOf)(t).forEach((function(n){var s=t[n];if((0,r.isObject)(s)){var i=d(s);if(s!==i)return void(t[n]=i);e(s)}})),t):t};o._adjustTypesFromJSONValue=p,o.fromJSONValue=function(e){var t=d(e);return t===e&&(0,r.isObject)(e)&&(t=o.clone(e),p(t)),t},o.stringify=(0,r.handleError)((function(e,t){var n=o.toJSONValue(e);return t&&(t.canonical||t.indent)?s(4)(n,t):JSON.stringify(n)})),o.parse=function(e){if("string"!=typeof e)throw new Error("EJSON.parse argument should be a string");return o.fromJSONValue(JSON.parse(e))},o.isBinary=function(e){return!!("undefined"!=typeof Uint8Array&&e instanceof Uint8Array||e&&e.$Uint8ArrayPolyfill)},o.equals=function(e,t,n){var s,i=!(!n||!n.keyOrderSensitive);if(e===t)return!0;if(Number.isNaN(e)&&Number.isNaN(t))return!0;if(!e||!t)return!1;if(!(0,r.isObject)(e)||!(0,r.isObject)(t))return!1;if(e instanceof Date&&t instanceof Date)return e.valueOf()===t.valueOf();if(o.isBinary(e)&&o.isBinary(t)){if(e.length!==t.length)return!1;for(s=0;s<e.length;s++)if(e[s]!==t[s])return!1;return!0}if((0,r.isFunction)(e.equals))return e.equals(t,n);if((0,r.isFunction)(t.equals))return t.equals(e,n);var a,c=Array.isArray(e),u=Array.isArray(t);if(c!==u)return!1;if(c&&u){if(e.length!==t.length)return!1;for(s=0;s<e.length;s++)if(!o.equals(e[s],t[s],n))return!1;return!0}switch(o._isCustomType(e)+o._isCustomType(t)){case 1:return!1;case 2:return o.equals(o.toJSONValue(e),o.toJSONValue(t))}var l=(0,r.keysOf)(e),d=(0,r.keysOf)(t);return i?(s=0,a=l.every((function(i){return!(s>=d.length||i!==d[s]||!o.equals(e[i],t[d[s]],n)||(s++,0))}))):(s=0,a=l.every((function(i){return!!(0,r.hasOwn)(t,i)&&!!o.equals(e[i],t[i],n)&&(s++,!0)}))),a&&s===d.length},o.clone=function(e){var t;if(!(0,r.isObject)(e))return e;if(null===e)return null;if(e instanceof Date)return new Date(e.getTime());if(e instanceof RegExp)return e;if(o.isBinary(e)){t=o.newBinary(e.length);for(var n=0;n<e.length;n++)t[n]=e[n];return t}return Array.isArray(e)?e.map(o.clone):(0,r.isArguments)(e)?Array.from(e).map(o.clone):(0,r.isFunction)(e.clone)?e.clone():o._isCustomType(e)?o.fromJSONValue(o.clone(o.toJSONValue(e)),!0):(t={},(0,r.keysOf)(e).forEach((function(n){t[n]=o.clone(e[n])})),t)},o.newBinary=t.newBinary}(),e.exports=i.EJSON}()},6729:e=>{"use strict";var t=Object.prototype.hasOwnProperty,n="~";function s(){}function i(e,t,n){this.fn=e,this.context=t,this.once=n||!1}function r(e,t,s,r,o){if("function"!=typeof s)throw new TypeError("The listener must be a function");var a=new i(s,r||e,o),c=n?n+t:t;return e._events[c]?e._events[c].fn?e._events[c]=[e._events[c],a]:e._events[c].push(a):(e._events[c]=a,e._eventsCount++),e}function o(e,t){0==--e._eventsCount?e._events=new s:delete e._events[t]}function a(){this._events=new s,this._eventsCount=0}Object.create&&(s.prototype=Object.create(null),(new s).__proto__||(n=!1)),a.prototype.eventNames=function(){var e,s,i=[];if(0===this._eventsCount)return i;for(s in e=this._events)t.call(e,s)&&i.push(n?s.slice(1):s);return Object.getOwnPropertySymbols?i.concat(Object.getOwnPropertySymbols(e)):i},a.prototype.listeners=function(e){var t=n?n+e:e,s=this._events[t];if(!s)return[];if(s.fn)return[s.fn];for(var i=0,r=s.length,o=new Array(r);i<r;i++)o[i]=s[i].fn;return o},a.prototype.listenerCount=function(e){var t=n?n+e:e,s=this._events[t];return s?s.fn?1:s.length:0},a.prototype.emit=function(e,t,s,i,r,o){var a=n?n+e:e;if(!this._events[a])return!1;var c,u,l=this._events[a],d=arguments.length;if(l.fn){switch(l.once&&this.removeListener(e,l.fn,void 0,!0),d){case 1:return l.fn.call(l.context),!0;case 2:return l.fn.call(l.context,t),!0;case 3:return l.fn.call(l.context,t,s),!0;case 4:return l.fn.call(l.context,t,s,i),!0;case 5:return l.fn.call(l.context,t,s,i,r),!0;case 6:return l.fn.call(l.context,t,s,i,r,o),!0}for(u=1,c=new Array(d-1);u<d;u++)c[u-1]=arguments[u];l.fn.apply(l.context,c)}else{var p,h=l.length;for(u=0;u<h;u++)switch(l[u].once&&this.removeListener(e,l[u].fn,void 0,!0),d){case 1:l[u].fn.call(l[u].context);break;case 2:l[u].fn.call(l[u].context,t);break;case 3:l[u].fn.call(l[u].context,t,s);break;case 4:l[u].fn.call(l[u].context,t,s,i);break;default:if(!c)for(p=1,c=new Array(d-1);p<d;p++)c[p-1]=arguments[p];l[u].fn.apply(l[u].context,c)}}return!0},a.prototype.on=function(e,t,n){return r(this,e,t,n,!1)},a.prototype.once=function(e,t,n){return r(this,e,t,n,!0)},a.prototype.removeListener=function(e,t,s,i){var r=n?n+e:e;if(!this._events[r])return this;if(!t)return o(this,r),this;var a=this._events[r];if(a.fn)a.fn!==t||i&&!a.once||s&&a.context!==s||o(this,r);else{for(var c=0,u=[],l=a.length;c<l;c++)(a[c].fn!==t||i&&!a[c].once||s&&a[c].context!==s)&&u.push(a[c]);u.length?this._events[r]=1===u.length?u[0]:u:o(this,r)}return this},a.prototype.removeAllListeners=function(e){var t;return e?(t=n?n+e:e,this._events[t]&&o(this,t)):(this._events=new s,this._eventsCount=0),this},a.prototype.off=a.prototype.removeListener,a.prototype.addListener=a.prototype.on,a.prefixed=n,a.EventEmitter=a,e.exports=a},4063:e=>{"use strict";e.exports=function e(t,n){if(t===n)return!0;if(t&&n&&"object"==typeof t&&"object"==typeof n){if(t.constructor!==n.constructor)return!1;var s,i,r;if(Array.isArray(t)){if((s=t.length)!=n.length)return!1;for(i=s;0!=i--;)if(!e(t[i],n[i]))return!1;return!0}if(t.constructor===RegExp)return t.source===n.source&&t.flags===n.flags;if(t.valueOf!==Object.prototype.valueOf)return t.valueOf()===n.valueOf();if(t.toString!==Object.prototype.toString)return t.toString()===n.toString();if((s=(r=Object.keys(t)).length)!==Object.keys(n).length)return!1;for(i=s;0!=i--;)if(!Object.prototype.hasOwnProperty.call(n,r[i]))return!1;for(i=s;0!=i--;){var o=r[i];if(!e(t[o],n[o]))return!1}return!0}return t!=t&&n!=n}},6560:e=>{"use strict";e.exports=(e,t=process.argv)=>{const n=e.startsWith("-")?"":1===e.length?"-":"--",s=t.indexOf(n+e),i=t.indexOf("--");return-1!==s&&(-1===i||s<i)}},9146:function(e,t,n){"use strict";var s=this&&this.__awaiter||function(e,t,n,s){return new(n||(n=Promise))((function(i,r){function o(e){try{c(s.next(e))}catch(e){r(e)}}function a(e){try{c(s.throw(e))}catch(e){r(e)}}function c(e){var t;e.done?i(e.value):(t=e.value,t instanceof n?t:new n((function(e){e(t)}))).then(o,a)}c((s=s.apply(e,t||[])).next())}))},i=this&&this.__importDefault||function(e){return e&&e.__esModule?e:{default:e}};Object.defineProperty(t,"__esModule",{value:!0});const r=i(n(1808)),o=i(n(4404)),a=i(n(7310)),c=i(n(9491)),u=i(n(5158)),l=n(8054),d=i(n(9829)),p=u.default("https-proxy-agent:agent");class h extends l.Agent{constructor(e){let t;if(t="string"==typeof e?a.default.parse(e):e,!t)throw new Error("an HTTP(S) proxy server `host` and `port` must be specified!");p("creating new HttpsProxyAgent instance: %o",t),super(t);const n=Object.assign({},t);var s;this.secureProxy=t.secureProxy||"string"==typeof(s=n.protocol)&&/^https:?$/i.test(s),n.host=n.hostname||n.host,"string"==typeof n.port&&(n.port=parseInt(n.port,10)),!n.port&&n.host&&(n.port=this.secureProxy?443:80),this.secureProxy&&!("ALPNProtocols"in n)&&(n.ALPNProtocols=["http 1.1"]),n.host&&n.path&&(delete n.path,delete n.pathname),this.proxy=n}callback(e,t){return s(this,void 0,void 0,(function*(){const{proxy:n,secureProxy:s}=this;let i;s?(p("Creating `tls.Socket`: %o",n),i=o.default.connect(n)):(p("Creating `net.Socket`: %o",n),i=r.default.connect(n));const a=Object.assign({},n.headers);let u=`CONNECT ${t.host}:${t.port} HTTP/1.1\r\n`;n.auth&&(a["Proxy-Authorization"]=`Basic ${Buffer.from(n.auth).toString("base64")}`);let{host:l,port:h,secureEndpoint:_}=t;(function(e,t){return Boolean(!t&&80===e||t&&443===e)})(h,_)||(l+=`:${h}`),a.Host=l,a.Connection="close";for(const e of Object.keys(a))u+=`${e}: ${a[e]}\r\n`;const g=d.default(i);i.write(`${u}\r\n`);const{statusCode:m,buffered:y}=yield g;if(200===m){if(e.once("socket",f),t.secureEndpoint){p("Upgrading socket connection to TLS");const e=t.servername||t.host;return o.default.connect(Object.assign(Object.assign({},function(e,...t){const n={};let s;for(s in e)t.includes(s)||(n[s]=e[s]);return n}(t,"host","hostname","path","port")),{socket:i,servername:e}))}return i}i.destroy();const b=new r.default.Socket({writable:!1});return b.readable=!0,e.once("socket",(e=>{p("replaying proxy buffer for failed request"),c.default(e.listenerCount("data")>0),e.push(y),e.push(null)})),b}))}}function f(e){e.resume()}t.default=h},6018:function(e,t,n){"use strict";const s=(this&&this.__importDefault||function(e){return e&&e.__esModule?e:{default:e}})(n(9146));function i(e){return new s.default(e)}!function(e){e.HttpsProxyAgent=s.default,e.prototype=s.default.prototype}(i||(i={})),e.exports=i},9829:function(e,t,n){"use strict";var s=this&&this.__importDefault||function(e){return e&&e.__esModule?e:{default:e}};Object.defineProperty(t,"__esModule",{value:!0});const i=s(n(5158)).default("https-proxy-agent:parse-proxy-response");t.default=function(e){return new Promise(((t,n)=>{let s=0;const r=[];function o(){const n=e.read();n?function(e){r.push(e),s+=e.length;const n=Buffer.concat(r,s);if(-1===n.indexOf("\r\n\r\n"))return i("have not received end of HTTP headers yet..."),void o();const a=n.toString("ascii",0,n.indexOf("\r\n")),c=+a.split(" ")[1];i("got proxy server response: %o",a),t({statusCode:c,buffered:n})}(n):e.once("readable",o)}function a(e){i("onclose had error %o",e)}function c(){i("onend")}e.on("error",(function t(s){e.removeListener("end",c),e.removeListener("error",t),e.removeListener("close",a),e.removeListener("readable",o),i("onerror %o",s),n(s)})),e.on("close",a),e.on("end",c),o()}))}},7612:function(e,t,n){var s,i;!function(r,o){const a=t;!function(e){const t=Symbol("newer"),n=Symbol("older");function s(e,t){"number"!=typeof e&&(t=e,e=0),this.size=0,this.limit=e,this.oldest=this.newest=void 0,this._keymap=new Map,t&&(this.assign(t),e<1&&(this.limit=this.size))}function i(e,s){this.key=e,this.value=s,this[t]=void 0,this[n]=void 0}function r(e){this.entry=e}function o(e){this.entry=e}function a(e){this.entry=e}e.LRUMap=s,s.prototype._markEntryAsUsed=function(e){e!==this.newest&&(e[t]&&(e===this.oldest&&(this.oldest=e[t]),e[t][n]=e[n]),e[n]&&(e[n][t]=e[t]),e[t]=void 0,e[n]=this.newest,this.newest&&(this.newest[t]=e),this.newest=e)},s.prototype.assign=function(e){let s,r=this.limit||Number.MAX_VALUE;this._keymap.clear();let o=e[Symbol.iterator]();for(let e=o.next();!e.done;e=o.next()){let o=new i(e.value[0],e.value[1]);if(this._keymap.set(o.key,o),s?(s[t]=o,o[n]=s):this.oldest=o,s=o,0==r--)throw new Error("overflow")}this.newest=s,this.size=this._keymap.size},s.prototype.get=function(e){var t=this._keymap.get(e);if(t)return this._markEntryAsUsed(t),t.value},s.prototype.set=function(e,s){var r=this._keymap.get(e);return r?(r.value=s,this._markEntryAsUsed(r),this):(this._keymap.set(e,r=new i(e,s)),this.newest?(this.newest[t]=r,r[n]=this.newest):this.oldest=r,this.newest=r,++this.size,this.size>this.limit&&this.shift(),this)},s.prototype.shift=function(){var e=this.oldest;if(e)return this.oldest[t]?(this.oldest=this.oldest[t],this.oldest[n]=void 0):(this.oldest=void 0,this.newest=void 0),e[t]=e[n]=void 0,this._keymap.delete(e.key),--this.size,[e.key,e.value]},s.prototype.find=function(e){let t=this._keymap.get(e);return t?t.value:void 0},s.prototype.has=function(e){return this._keymap.has(e)},s.prototype.delete=function(e){var s=this._keymap.get(e);if(s)return this._keymap.delete(s.key),s[t]&&s[n]?(s[n][t]=s[t],s[t][n]=s[n]):s[t]?(s[t][n]=void 0,this.oldest=s[t]):s[n]?(s[n][t]=void 0,this.newest=s[n]):this.oldest=this.newest=void 0,this.size--,s.value},s.prototype.clear=function(){this.oldest=this.newest=void 0,this.size=0,this._keymap.clear()},r.prototype[Symbol.iterator]=function(){return this},r.prototype.next=function(){let e=this.entry;return e?(this.entry=e[t],{done:!1,value:[e.key,e.value]}):{done:!0,value:void 0}},o.prototype[Symbol.iterator]=function(){return this},o.prototype.next=function(){let e=this.entry;return e?(this.entry=e[t],{done:!1,value:e.key}):{done:!0,value:void 0}},a.prototype[Symbol.iterator]=function(){return this},a.prototype.next=function(){let e=this.entry;return e?(this.entry=e[t],{done:!1,value:e.value}):{done:!0,value:void 0}},s.prototype.keys=function(){return new o(this.oldest)},s.prototype.values=function(){return new a(this.oldest)},s.prototype.entries=function(){return this},s.prototype[Symbol.iterator]=function(){return new r(this.oldest)},s.prototype.forEach=function(e,n){"object"!=typeof n&&(n=this);let s=this.oldest;for(;s;)e.call(n,s.value,s.key,this),s=s[t]},s.prototype.toJSON=function(){for(var e=new Array(this.size),n=0,s=this.oldest;s;)e[n++]={key:s.key,value:s.value},s=s[t];return e},s.prototype.toString=function(){for(var e="",n=this.oldest;n;)e+=String(n.key)+":"+n.value,(n=n[t])&&(e+=" < ");return e}}(a),void 0===(i="function"==typeof(s=a)?s.call(t,n,t,e):s)||(e.exports=i)}()},4341:e=>{"use strict";const t=(e,t,s,i)=>{if("length"===s||"prototype"===s)return;if("arguments"===s||"caller"===s)return;const r=Object.getOwnPropertyDescriptor(e,s),o=Object.getOwnPropertyDescriptor(t,s);!n(r,o)&&i||Object.defineProperty(e,s,o)},n=function(e,t){return void 0===e||e.configurable||e.writable===t.writable&&e.enumerable===t.enumerable&&e.configurable===t.configurable&&(e.writable||e.value===t.value)},s=(e,t)=>`/* Wrapped ${e}*/\n${t}`,i=Object.getOwnPropertyDescriptor(Function.prototype,"toString"),r=Object.getOwnPropertyDescriptor(Function.prototype.toString,"name");e.exports=(e,n,{ignoreNonConfigurable:o=!1}={})=>{const{name:a}=e;for(const s of Reflect.ownKeys(n))t(e,n,s,o);return((e,t)=>{const n=Object.getPrototypeOf(t);n!==Object.getPrototypeOf(e)&&Object.setPrototypeOf(e,n)})(e,n),((e,t,n)=>{const o=""===n?"":`with ${n.trim()}() `,a=s.bind(null,o,t.toString());Object.defineProperty(a,"name",r),Object.defineProperty(e,"toString",{...i,value:a})})(e,n,a),e}},7824:e=>{var t=1e3,n=60*t,s=60*n,i=24*s;function r(e,t,n,s){var i=t>=1.5*n;return Math.round(e/n)+" "+s+(i?"s":"")}e.exports=function(e,o){o=o||{};var a,c,u=typeof e;if("string"===u&&e.length>0)return function(e){if(!((e=String(e)).length>100)){var r=/^(-?(?:\d+)?\.?\d+) *(milliseconds?|msecs?|ms|seconds?|secs?|s|minutes?|mins?|m|hours?|hrs?|h|days?|d|weeks?|w|years?|yrs?|y)?$/i.exec(e);if(r){var o=parseFloat(r[1]);switch((r[2]||"ms").toLowerCase()){case"years":case"year":case"yrs":case"yr":case"y":return 315576e5*o;case"weeks":case"week":case"w":return 6048e5*o;case"days":case"day":case"d":return o*i;case"hours":case"hour":case"hrs":case"hr":case"h":return o*s;case"minutes":case"minute":case"mins":case"min":case"m":return o*n;case"seconds":case"second":case"secs":case"sec":case"s":return o*t;case"milliseconds":case"millisecond":case"msecs":case"msec":case"ms":return o;default:return}}}}(e);if("number"===u&&isFinite(e))return o.long?(a=e,(c=Math.abs(a))>=i?r(a,c,i,"day"):c>=s?r(a,c,s,"hour"):c>=n?r(a,c,n,"minute"):c>=t?r(a,c,t,"second"):a+" ms"):function(e){var r=Math.abs(e);return r>=i?Math.round(e/i)+"d":r>=s?Math.round(e/s)+"h":r>=n?Math.round(e/n)+"m":r>=t?Math.round(e/t)+"s":e+"ms"}(e);throw new Error("val is not a non-empty string or a valid number. val="+JSON.stringify(e))}},7345:e=>{"use strict";e.exports=(e,t)=>(t=t||(()=>{}),e.then((e=>new Promise((e=>{e(t())})).then((()=>e))),(e=>new Promise((e=>{e(t())})).then((()=>{throw e})))))},5860:(e,t,n)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0});const s=n(6729),i=n(6512),r=n(6506),o=()=>{},a=new i.TimeoutError;t.default=class extends s{constructor(e){var t,n,s,i;if(super(),this._intervalCount=0,this._intervalEnd=0,this._pendingCount=0,this._resolveEmpty=o,this._resolveIdle=o,!("number"==typeof(e=Object.assign({carryoverConcurrencyCount:!1,intervalCap:1/0,interval:0,concurrency:1/0,autoStart:!0,queueClass:r.default},e)).intervalCap&&e.intervalCap>=1))throw new TypeError(`Expected \`intervalCap\` to be a number from 1 and up, got \`${null!==(n=null===(t=e.intervalCap)||void 0===t?void 0:t.toString())&&void 0!==n?n:""}\` (${typeof e.intervalCap})`);if(void 0===e.interval||!(Number.isFinite(e.interval)&&e.interval>=0))throw new TypeError(`Expected \`interval\` to be a finite number >= 0, got \`${null!==(i=null===(s=e.interval)||void 0===s?void 0:s.toString())&&void 0!==i?i:""}\` (${typeof e.interval})`);this._carryoverConcurrencyCount=e.carryoverConcurrencyCount,this._isIntervalIgnored=e.intervalCap===1/0||0===e.interval,this._intervalCap=e.intervalCap,this._interval=e.interval,this._queue=new e.queueClass,this._queueClass=e.queueClass,this.concurrency=e.concurrency,this._timeout=e.timeout,this._throwOnTimeout=!0===e.throwOnTimeout,this._isPaused=!1===e.autoStart}get _doesIntervalAllowAnother(){return this._isIntervalIgnored||this._intervalCount<this._intervalCap}get _doesConcurrentAllowAnother(){return this._pendingCount<this._concurrency}_next(){this._pendingCount--,this._tryToStartAnother(),this.emit("next")}_resolvePromises(){this._resolveEmpty(),this._resolveEmpty=o,0===this._pendingCount&&(this._resolveIdle(),this._resolveIdle=o,this.emit("idle"))}_onResumeInterval(){this._onInterval(),this._initializeIntervalIfNeeded(),this._timeoutId=void 0}_isIntervalPaused(){const e=Date.now();if(void 0===this._intervalId){const t=this._intervalEnd-e;if(!(t<0))return void 0===this._timeoutId&&(this._timeoutId=setTimeout((()=>{this._onResumeInterval()}),t)),!0;this._intervalCount=this._carryoverConcurrencyCount?this._pendingCount:0}return!1}_tryToStartAnother(){if(0===this._queue.size)return this._intervalId&&clearInterval(this._intervalId),this._intervalId=void 0,this._resolvePromises(),!1;if(!this._isPaused){const e=!this._isIntervalPaused();if(this._doesIntervalAllowAnother&&this._doesConcurrentAllowAnother){const t=this._queue.dequeue();return!!t&&(this.emit("active"),t(),e&&this._initializeIntervalIfNeeded(),!0)}}return!1}_initializeIntervalIfNeeded(){this._isIntervalIgnored||void 0!==this._intervalId||(this._intervalId=setInterval((()=>{this._onInterval()}),this._interval),this._intervalEnd=Date.now()+this._interval)}_onInterval(){0===this._intervalCount&&0===this._pendingCount&&this._intervalId&&(clearInterval(this._intervalId),this._intervalId=void 0),this._intervalCount=this._carryoverConcurrencyCount?this._pendingCount:0,this._processQueue()}_processQueue(){for(;this._tryToStartAnother(););}get concurrency(){return this._concurrency}set concurrency(e){if(!("number"==typeof e&&e>=1))throw new TypeError(`Expected \`concurrency\` to be a number from 1 and up, got \`${e}\` (${typeof e})`);this._concurrency=e,this._processQueue()}async add(e,t={}){return new Promise(((n,s)=>{this._queue.enqueue((async()=>{this._pendingCount++,this._intervalCount++;try{const r=void 0===this._timeout&&void 0===t.timeout?e():i.default(Promise.resolve(e()),void 0===t.timeout?this._timeout:t.timeout,(()=>{(void 0===t.throwOnTimeout?this._throwOnTimeout:t.throwOnTimeout)&&s(a)}));n(await r)}catch(e){s(e)}this._next()}),t),this._tryToStartAnother(),this.emit("add")}))}async addAll(e,t){return Promise.all(e.map((async e=>this.add(e,t))))}start(){return this._isPaused?(this._isPaused=!1,this._processQueue(),this):this}pause(){this._isPaused=!0}clear(){this._queue=new this._queueClass}async onEmpty(){if(0!==this._queue.size)return new Promise((e=>{const t=this._resolveEmpty;this._resolveEmpty=()=>{t(),e()}}))}async onIdle(){if(0!==this._pendingCount||0!==this._queue.size)return new Promise((e=>{const t=this._resolveIdle;this._resolveIdle=()=>{t(),e()}}))}get size(){return this._queue.size}sizeBy(e){return this._queue.filter(e).length}get pending(){return this._pendingCount}get isPaused(){return this._isPaused}get timeout(){return this._timeout}set timeout(e){this._timeout=e}}},7489:(e,t)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.default=function(e,t,n){let s=0,i=e.length;for(;i>0;){const r=i/2|0;let o=s+r;n(e[o],t)<=0?(s=++o,i-=r+1):i=r}return s}},6506:(e,t,n)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0});const s=n(7489);t.default=class{constructor(){this._queue=[]}enqueue(e,t){const n={priority:(t=Object.assign({priority:0},t)).priority,run:e};if(this.size&&this._queue[this.size-1].priority>=t.priority)return void this._queue.push(n);const i=s.default(this._queue,n,((e,t)=>t.priority-e.priority));this._queue.splice(i,0,n)}dequeue(){const e=this._queue.shift();return null==e?void 0:e.run}filter(e){return this._queue.filter((t=>t.priority===e.priority)).map((e=>e.run))}get size(){return this._queue.length}}},6512:(e,t,n)=>{"use strict";const s=n(7345);class i extends Error{constructor(e){super(e),this.name="TimeoutError"}}const r=(e,t,n)=>new Promise(((r,o)=>{if("number"!=typeof t||t<0)throw new TypeError("Expected `milliseconds` to be a positive number");if(t===1/0)return void r(e);const a=setTimeout((()=>{if("function"==typeof n){try{r(n())}catch(e){o(e)}return}const s=n instanceof Error?n:new i("string"==typeof n?n:`Promise timed out after ${t} milliseconds`);"function"==typeof e.cancel&&e.cancel(),o(s)}),t);s(e.then(r,o),(()=>{clearTimeout(a)}))}));e.exports=r,e.exports.default=r,e.exports.TimeoutError=i},2130:(e,t,n)=>{"use strict";const s=n(2037),i=n(6224),r=n(6560),{env:o}=process;let a;function c(e){return 0!==e&&{level:e,hasBasic:!0,has256:e>=2,has16m:e>=3}}function u(e,t){if(0===a)return 0;if(r("color=16m")||r("color=full")||r("color=truecolor"))return 3;if(r("color=256"))return 2;if(e&&!t&&void 0===a)return 0;const n=a||0;if("dumb"===o.TERM)return n;if("win32"===process.platform){const e=s.release().split(".");return Number(e[0])>=10&&Number(e[2])>=10586?Number(e[2])>=14931?3:2:1}if("CI"in o)return["TRAVIS","CIRCLECI","APPVEYOR","GITLAB_CI","GITHUB_ACTIONS","BUILDKITE"].some((e=>e in o))||"codeship"===o.CI_NAME?1:n;if("TEAMCITY_VERSION"in o)return/^(9\.(0*[1-9]\d*)\.|\d{2,}\.)/.test(o.TEAMCITY_VERSION)?1:0;if("truecolor"===o.COLORTERM)return 3;if("TERM_PROGRAM"in o){const e=parseInt((o.TERM_PROGRAM_VERSION||"").split(".")[0],10);switch(o.TERM_PROGRAM){case"iTerm.app":return e>=3?3:2;case"Apple_Terminal":return 2}}return/-256(color)?$/i.test(o.TERM)?2:/^screen|^xterm|^vt100|^vt220|^rxvt|color|ansi|cygwin|linux/i.test(o.TERM)||"COLORTERM"in o?1:n}r("no-color")||r("no-colors")||r("color=false")||r("color=never")?a=0:(r("color")||r("colors")||r("color=true")||r("color=always"))&&(a=1),"FORCE_COLOR"in o&&(a="true"===o.FORCE_COLOR?1:"false"===o.FORCE_COLOR?0:0===o.FORCE_COLOR.length?1:Math.min(parseInt(o.FORCE_COLOR,10),3)),e.exports={supportsColor:function(e){return c(u(e,e&&e.isTTY))},stdout:c(u(!0,i.isatty(1))),stderr:c(u(!0,i.isatty(2)))}},9491:e=>{"use strict";e.exports=require("assert")},6113:e=>{"use strict";e.exports=require("crypto")},1891:e=>{"use strict";e.exports=require("dgram")},2361:e=>{"use strict";e.exports=require("events")},3292:e=>{"use strict";e.exports=require("fs/promises")},3685:e=>{"use strict";e.exports=require("http")},5687:e=>{"use strict";e.exports=require("https")},1405:e=>{"use strict";e.exports=require("inspector")},1808:e=>{"use strict";e.exports=require("net")},2037:e=>{"use strict";e.exports=require("os")},1017:e=>{"use strict";e.exports=require("path")},2781:e=>{"use strict";e.exports=require("stream")},4404:e=>{"use strict";e.exports=require("tls")},6224:e=>{"use strict";e.exports=require("tty")},7310:e=>{"use strict";e.exports=require("url")},3837:e=>{"use strict";e.exports=require("util")},2764:(e,t)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0})},7359:(e,t,n)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.runEntrypoint=void 0;const s=n(1460),i=n(9913),r=s.__importDefault(n(3292)),o=n(2068),a=n(2640);n(5605);const c=n(8221),u=s.__importDefault(n(1017));let l,d=!1;t.runEntrypoint=function(e,t){Promise.resolve().then((async()=>{if(d)throw new Error("runEntrypoint can only be called once");d=!0;const n=process.env.MODULE_MANIFEST;if(!n)throw new Error("Module initialise is missing MODULE_MANIFEST");const s=await r.default.readFile(n),p=JSON.parse(s.toString());if(p.runtime?.api!==i.HostApiNodeJsIpc)throw new Error("Module manifest 'api' mismatch");if(!p.runtime.apiVersion)throw new Error("Module manifest 'apiVersion' missing");let h=p.runtime.apiVersion;if("0.0.0"===h)try{const e=await r.default.readFile(u.default.join(__dirname,"../package.json")),t=JSON.parse(e.toString());"@companion-module/base"===t.name&&(h=t.version)}catch(e){throw new Error("Failed to determine module api version")}if(!process.send)throw new Error("Module is not being run with ipc");console.log(`Starting up module class: ${e.name}`);const f=process.env.CONNECTION_ID;if("string"!=typeof f||!f)throw new Error("Module initialise is missing CONNECTION_ID");const _=process.env.VERIFICATION_TOKEN;if("string"!=typeof _||!_)throw new Error("Module initialise is missing VERIFICATION_TOKEN");const g=process.env.SENTRY_DSN,m=process.env.SENTRY_USERID,y=process.env.SENTRY_COMPANION_VERSION;g&&m&&"https://"==g.substring(0,8)?(console.log("Sentry enabled"),(0,a.init)({dsn:g,release:`${p.name}@${p.version}`,beforeSend:e=>(e.exception&&console.log("sentry","error",e.exception),e)}),(0,a.configureScope)((e=>{e.setUser({id:m}),e.setTag("companion",y)}))):console.log("Sentry disabled");const b=new c.IpcWrapper({},(e=>{process.send(e)}),5e3);process.once("message",(e=>{b.receivedMessage(e)})),l=new e((0,o.literal)({id:f,upgradeScripts:t,_isInstanceBaseProps:!0})),b.sendWithCb("register",{apiVersion:h,connectionId:f,verificationToken:_}).then((()=>{console.log("Module-host accepted registration")}),(e=>{console.error("Module registration failed",e),process.exit(11)}))})).catch((e=>{console.error("Failed to startup module:"),console.error(e.stack||e.message),process.exit(1)}))}},1972:(e,t,n)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.UDPHelper=t.TelnetHelper=t.TCPHelper=void 0;var s=n(9159);Object.defineProperty(t,"TCPHelper",{enumerable:!0,get:function(){return s.TCPHelper}});var i=n(6226);Object.defineProperty(t,"TelnetHelper",{enumerable:!0,get:function(){return i.TelnetHelper}});var r=n(8473);Object.defineProperty(t,"UDPHelper",{enumerable:!0,get:function(){return r.UDPHelper}})},9159:(e,t,n)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.TCPHelper=void 0;const s=n(1460).__importDefault(n(1808)),i=n(6729),r=n(609);class o extends i.EventEmitter{#e;#t;_socket;#n;#s=!1;#i=!1;#r=!1;#o;#a;get isConnected(){return this.#s}get isConnecting(){return this.#i}get isDestroyed(){return this.#r}constructor(e,t,n){super(),this.#e=e,this.#t=t,this.#n={reconnect_interval:2e3,reconnect:!0,...n},this._socket=new s.default.Socket,this._socket.setKeepAlive(!0),this._socket.setNoDelay(!0),this._socket.on("error",(e=>{this.#i=!1,this.#s=!1,this.#n.reconnect&&this.#c(),this.#u(r.InstanceStatus.UnknownError,e.message),this.emit("error",e)})),this._socket.on("ready",(()=>{this.#s=!0,this.#i=!1,this.#u(r.InstanceStatus.Ok),this.emit("connect")})),this._socket.on("end",(()=>{this.#s=!1,this.#u(r.InstanceStatus.Disconnected),!this.#i&&this.#n.reconnect&&this.#c(),this.emit("end")})),this._socket.on("data",(e=>this.emit("data",e))),this._socket.on("drain",(()=>this.emit("drain"))),setImmediate((()=>this.connect())),setTimeout((()=>{this.#r||this.listenerCount("error")||console.error(`Danger: TCP client for ${this.#e}:${this.#t} is missing an error handler!`)}),5e3)}connect(){if(this.#r)throw new Error("Cannot connect destroyed socket");return!this.#i&&(this.#i=!0,this._socket.connect(this.#t,this.#e),!0)}async send(e){if(this.#r||this._socket.destroyed)throw new Error("Cannot write to destroyed socket");if(!e||!e.length)throw new Error("No message to send");if(!this.#s)return!1;try{return new Promise(((t,n)=>{this._socket.write(e,(e=>{e?n(e):t(!0)}))}))}catch(e){this.#s=!1;const t=e instanceof Error?e:new Error(`${e}`);throw this.#u(r.InstanceStatus.UnknownError,t.message),this.emit("error",t),t}}destroy(){this.#r=!0,void 0!==this.#a&&clearTimeout(this.#a),this._socket.removeAllListeners(),this.removeAllListeners(),this._socket.destroy()}#c(){void 0!==this.#a&&clearTimeout(this.#a),this.#a=setTimeout((()=>{this.#a=void 0,this.#u(r.InstanceStatus.Connecting),this.connect()}),this.#n.reconnect_interval)}#u(e,t){this.#o!=e&&(this.#o=e,this.emit("status_change",e,t))}}t.TCPHelper=o},6226:(e,t,n)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.TelnetHelper=void 0;const s=n(1460).__importDefault(n(6729)),i=n(2781),r=n(9159);class o extends s.default{#l;#d;get isConnected(){return this.#l.isConnected}get isConnecting(){return this.#l.isConnecting}get isDestroyed(){return this.#l.isDestroyed}constructor(e,t,n){super(),this.#l=new r.TCPHelper(e,t,n),this.#d=new a,this.#l._socket.pipe(this.#d),this.#l.on("connect",(()=>this.emit("connect"))),this.#l.on("end",(()=>this.emit("end"))),this.#l.on("error",(e=>this.emit("error",e))),this.#l.on("status_change",((e,t)=>this.emit("status_change",e,t))),this.#d.on("iac",((e,t)=>this.emit("iac",e,t))),this.#d.on("sb",(e=>this.emit("sb",e))),this.#d.on("data",(e=>this.emit("data",e))),this.#d.on("drain",(()=>this.emit("drain"))),setTimeout((()=>{this.isDestroyed||this.listenerCount("error")||console.error(`Danger: Telnet client for ${e}:${t} is missing an error handler!`)}),5e3)}connect(){return this.#l.connect()}async send(e){return this.#l.send(e)}destroy(){this.#l.destroy(),this.#d.removeAllListeners(),this.#d.destroy()}}t.TelnetHelper=o;class a extends i.Transform{#p;#h;#f;constructor(e){super(e),this.#p=Buffer.alloc(0),this.#h=Buffer.alloc(0),this.#f=0}_transform(e,t,n){for(let t=0;t<e.length;++t)this.#_(e[t]);const s=this.#g();s.length&&this.push(s),n()}#_(e){if(0===this.#f){if(255===e)return void(this.#f=255);this.#p=Buffer.concat([this.#p,Buffer.from([e])])}else if(255===this.#f)switch(e){case 250:case 251:case 252:case 253:case 254:this.#f=e;break;default:this.#f=0}else{if(this.#f>=251&&this.#f<=254){let t;switch(this.#f){case 251:t="WILL";break;case 252:t="WONT";break;case 253:t="DO";break;case 254:t="DONT";break;default:return}return this.emit("iac",t,e),void(this.#f=0)}if(250===this.#f){if(240===e)return this.emit("sb",this.#h),this.#f=0,void(this.#h=Buffer.alloc(0));this.#h=Buffer.concat([this.#h,Buffer.from([e])])}}}#g(){const e=this.#p;return this.#p=Buffer.alloc(0),e}}},8473:(e,t,n)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.UDPHelper=void 0;const s=n(1460).__importDefault(n(1891)),i=n(6729),r=n(609);class o extends i.EventEmitter{#e;#t;#m;#n;#r=!1;#o;get isDestroyed(){return this.#r}constructor(e,t,n){super(),this.#e=e,this.#t=t,this.#n={...n},this.#m=s.default.createSocket("udp4");try{this.#m.bind(this.#n.bind_port||0,this.#n.bind_ip)}catch(e){throw new Error(`Unable to bind to ip/port: ${this.#n.bind_ip}:${this.#n.bind_port}`)}this.#n.broadcast&&this.#m.setBroadcast(!0),void 0!==this.#n.ttl&&this.#m.setTTL(this.#n.ttl),void 0!==this.#n.multicast_ttl&&this.#m.setMulticastTTL(this.#n.multicast_ttl),this.#m.on("error",(e=>{this.#u(r.InstanceStatus.UnknownError,e.message),this.emit("error",e)})),this.#m.on("listening",(()=>{this.#n.multicast_interface&&this.#m.setMulticastInterface(this.#n.multicast_interface),this.#u(r.InstanceStatus.Ok),this.emit("listening")})),this.#m.on("message",(e=>this.emit("data",e))),setTimeout((()=>{this.#r||this.listenerCount("error")||console.error(`Danger: UDP socket for ${this.#e}:${this.#t} is missing an error handler!`)}),5e3)}async send(e){if(this.#r)throw new Error("Cannot write to destroyed socket");if(!e||!e.length)throw new Error("No message to send");return new Promise(((t,n)=>{this.#m.send(e,this.#t,this.#e,(e=>{e?n(e):t()}))}))}destroy(){this.#r=!0,this.#m.removeAllListeners(),this.#m.close(),this.removeAllListeners()}#u(e,t){this.#o!=e&&(this.#o=e,this.emit("status_change",e,t))}}t.UDPHelper=o},8221:(e,t,n)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IpcWrapper=void 0;const s=n(1460),i=n(4300),r=n(2068),o=s.__importDefault(n(2559));t.IpcWrapper=class{#y;#b;#v;#E={};constructor(e,t,n){this.#y=e,this.#b=t,this.#v=n}async sendWithCb(e,t,n,s=0){s<=0&&(s=this.#v);const r={timeout:void 0,resolve:()=>null,reject:()=>null},a=new Promise(((e,t)=>{r.resolve=e,r.reject=t})),c=(0,i.nanoid)();this.#E[c]=r,this.#b({direction:"call",name:String(e),payload:o.default.stringify(t),callbackId:c});const u=new Error("Call timed out");return r.timeout=setTimeout((()=>{r.reject(n?n():u),delete this.#E[c]}),s),a}sendWithNoCb(e,t){this.#b({direction:"call",name:String(e),payload:o.default.stringify(t),callbackId:void 0})}receivedMessage(e){const t=e;switch(e.direction){case"call":{const t=this.#y[e.name];if(!t)return void(e.callbackId&&this.#b({direction:"response",callbackId:e.callbackId,success:!1,payload:o.default.stringify({message:`Unknown command "${e.name}"`})}));t(e.payload?o.default.parse(e.payload):void 0).then((t=>{e.callbackId&&this.#b({direction:"response",callbackId:e.callbackId,success:!0,payload:o.default.stringify(t)})}),(t=>{e.callbackId&&this.#b({direction:"response",callbackId:e.callbackId,success:!1,payload:t instanceof Error?JSON.stringify(t,Object.getOwnPropertyNames(t)):o.default.stringify(t)})}));break}case"response":{if(!e.callbackId)return void console.error("Ipc: Response message has no callbackId");const t=this.#E[e.callbackId];if(delete this.#E[e.callbackId],!t)return;clearTimeout(t.timeout);const n=e.payload?o.default.parse(e.payload):void 0;if(e.success)t.resolve(n);else{let e=n;n&&"message"in n&&(e=new Error(n.message),n.stack&&(e.stack=n.stack)),t.reject(e)}break}default:(0,r.assertNever)(e),console.error(`Ipc: Message of unknown direction "${t.direction}"`)}}}},9913:(e,t)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.HostApiNodeJsIpc=void 0,t.HostApiNodeJsIpc="nodejs-ipc"},8049:(e,t,n)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.runEntrypoint=t.assertNever=t.splitRgb=t.combineRgb=t.literal=void 0;const s=n(1460);s.__exportStar(n(7517),t),s.__exportStar(n(4911),t),s.__exportStar(n(2764),t);var i=n(2068);Object.defineProperty(t,"literal",{enumerable:!0,get:function(){return i.literal}}),Object.defineProperty(t,"combineRgb",{enumerable:!0,get:function(){return i.combineRgb}}),Object.defineProperty(t,"splitRgb",{enumerable:!0,get:function(){return i.splitRgb}}),Object.defineProperty(t,"assertNever",{enumerable:!0,get:function(){return i.assertNever}}),s.__exportStar(n(1972),t);var r=n(7359);Object.defineProperty(t,"runEntrypoint",{enumerable:!0,get:function(){return r.runEntrypoint}})},4391:(e,t,n)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ActionManager=void 0;const s=n(2557);function i(e){return{id:e.id,actionId:e.actionId,controlId:e.controlId,options:e.options}}t.ActionManager=class{#S;#T;#k;#w=new Map;#I=new Map;constructor(e,t,n){this.#S=e,this.#T=t,this.#k=n}async handleExecuteAction(e){const t=this.#w.get(e.action.actionId);if(!t)throw new Error(`Unknown action: ${e.action.actionId}`);const n={parseVariablesInString:async t=>(await this.#S({text:t,controlId:e.action.controlId,actionInstanceId:e.action.id,feedbackInstanceId:void 0})).text};await t.callback({id:e.action.id,actionId:e.action.actionId,controlId:e.action.controlId,options:e.action.options,surfaceId:e.surfaceId??e.deviceId,_deviceId:e.surfaceId??e.deviceId,_page:e.action.page,_bank:e.action.bank},n)}handleUpdateActions(e){for(const[t,n]of Object.entries(e)){const e=this.#I.get(t);if(e){const t=this.#w.get(e.actionId);if(t?.unsubscribe){const n={parseVariablesInString:async t=>(await this.#S({text:t,controlId:e.controlId,actionInstanceId:e.id,feedbackInstanceId:void 0})).text};Promise.resolve(t.unsubscribe(i(e),n)).catch((t=>{this.#k("error",`Action unsubscribe failed: ${JSON.stringify(e)} - ${t?.message??t} ${t?.stack}`)}))}}if(!n||n.disabled)this.#I.delete(t);else{this.#I.set(t,n);const e=this.#w.get(n.actionId);if(e?.subscribe){const t={parseVariablesInString:async e=>(await this.#S({text:e,controlId:n.controlId,actionInstanceId:n.id,feedbackInstanceId:void 0})).text};Promise.resolve(e.subscribe(i(n),t)).catch((e=>{this.#k("error",`Action subscribe failed: ${JSON.stringify(n)} - ${e?.message??e} ${e?.stack}`)}))}}}}async handleLearnAction(e){const t=this.#w.get(e.action.actionId);if(t&&t.learn){const n={parseVariablesInString:async t=>(await this.#S({text:t,controlId:e.action.controlId,actionInstanceId:e.action.id,feedbackInstanceId:void 0})).text};return{options:await t.learn({id:e.action.id,actionId:e.action.actionId,controlId:e.action.controlId,options:e.action.options,surfaceId:void 0,_deviceId:void 0,_page:e.action.page,_bank:e.action.bank},n)}}return{options:void 0}}setActionDefinitions(e){const t=[];this.#w.clear();for(const[n,i]of Object.entries(e))i&&(t.push({id:n,name:i.name,description:i.description,options:(0,s.serializeIsVisibleFn)(i.options),hasLearn:!!i.learn}),this.#w.set(n,i));this.#T({actions:t})}_getAllActions(){return Array.from(this.#I.values()).map((e=>({id:e.id,actionId:e.actionId,controlId:e.controlId,options:e.options})))}subscribeActions(e){let t=Array.from(this.#I.values());const n=new Set(e);n.size&&(t=t.filter((e=>n.has(e.actionId))));for(const e of t){const t=this.#w.get(e.actionId);if(t?.subscribe){const n={parseVariablesInString:async t=>(await this.#S({text:t,controlId:e.controlId,actionInstanceId:e.id,feedbackInstanceId:void 0})).text};Promise.resolve(t.subscribe(i(e),n)).catch((t=>{this.#k("error",`Action subscribe failed: ${JSON.stringify(e)} - ${t?.message??t} ${t?.stack}`)}))}}}unsubscribeActions(e){let t=Array.from(this.#I.values());const n=new Set(e);n.size&&(t=t.filter((e=>n.has(e.actionId))));for(const e of t){const t=this.#w.get(e.actionId);if(t&&t.unsubscribe){const n={parseVariablesInString:async t=>(await this.#S({text:t,controlId:e.controlId,actionInstanceId:e.id,feedbackInstanceId:void 0})).text};Promise.resolve(t.unsubscribe(i(e),n)).catch((t=>{this.#k("error",`Action unsubscribe failed: ${JSON.stringify(e)} - ${t?.message??t} ${t?.stack}`)}))}}}}},2557:(e,t)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isInstanceBaseProps=t.serializeIsVisibleFn=void 0,t.serializeIsVisibleFn=function(e){return e.map((e=>"isVisible"in e&&"function"==typeof e.isVisible?{...e,isVisibleFn:e.isVisible.toString(),isVisible:void 0}:{...e,isVisibleFn:void 0}))},t.isInstanceBaseProps=function(e){const t=e;return"object"==typeof t&&"string"==typeof t.id&&!0===t._isInstanceBaseProps}},7550:(e,t,n)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FeedbackManager=void 0;const s=n(1460),i=n(2557),r=s.__importDefault(n(7319));function o(e,t){return{type:e,id:t.id,feedbackId:t.feedbackId,controlId:t.controlId,options:t.options}}t.FeedbackManager=class{#S;#x;#C;#k;#O=new Map;#R=new Map;#D=new Map;#N=new Map;#A;get parseVariablesContext(){return this.#A}constructor(e,t,n,s){this.#S=e,this.#x=t,this.#C=n,this.#k=s}getDefinitionIds(){return Array.from(this.#O.keys())}getInstanceIds(){return Array.from(this.#R.keys())}handleUpdateFeedbacks(e){for(const[t,n]of Object.entries(e)){const e=this.#R.get(t);if(e){const t=this.#O.get(e.feedbackId);if(t?.unsubscribe){const n={parseVariablesInString:async t=>(await this.#S({text:t,controlId:e.controlId,actionInstanceId:void 0,feedbackInstanceId:e.id})).text};Promise.resolve(t.unsubscribe(o(t.type,e),n)).catch((t=>{this.#k("error",`Feedback unsubscribe failed: ${JSON.stringify(e)} - ${t?.message??t} ${t?.stack}`)}))}}if(!n||n.disabled)this.#R.delete(t);else{this.#R.set(t,{...n,referencedVariables:null});const e=this.#O.get(n.feedbackId);if(e?.subscribe){const t={parseVariablesInString:async e=>(await this.#S({text:e,controlId:n.controlId,actionInstanceId:void 0,feedbackInstanceId:n.id})).text};Promise.resolve(e.subscribe(o(e.type,n),t)).catch((e=>{this.#k("error",`Feedback subscribe failed: ${JSON.stringify(n)} - ${e?.message??e} ${e?.stack}`)}))}this.#P(t)}}}async handleLearnFeedback(e){const t=this.#O.get(e.feedback.feedbackId);if(t&&t.learn){const n={parseVariablesInString:async t=>(await this.#S({text:t,controlId:e.feedback.controlId,actionInstanceId:void 0,feedbackInstanceId:e.feedback.id})).text};return{options:await t.learn({id:e.feedback.id,feedbackId:e.feedback.feedbackId,controlId:e.feedback.controlId,options:e.feedback.options,type:t.type},n)}}return{options:void 0}}handleVariablesChanged(e){if(!e.variablesIds.length)return;const t=new Set(e.variablesIds);for(const t of this.#N.values())for(const n of e.variablesIds)t.changedVariables.add(n);const n=new Set;for(const e of this.#R.values())if(!this.#N.has(e.id)&&e.referencedVariables)for(const s of e.referencedVariables)if(t.has(s)){n.add(e.id);break}for(const e of n)setImmediate((()=>{this.#P(e)}))}#P(e){const t=this.#N.get(e);if(t)return void(t.needsRecheck=!0);const n=this.#R.get(e);if(!n)return;const s=n,i={needsRecheck:!1,changedVariables:new Set};this.#N.set(e,i),Promise.resolve().then((async()=>{const t=this.#O.get(s.feedbackId);let n;const i=new Set;if(t){this.#A=`Feedback ${s.feedbackId} (${e})`;const r={parseVariablesInString:async t=>{const n=await this.#S({text:t,controlId:s.controlId,actionInstanceId:void 0,feedbackInstanceId:e});if(n.variableIds&&n.variableIds.length)for(const e of n.variableIds)i.add(e);return n.text}};n="boolean"===t.type?t.callback({...o("boolean",s),type:"boolean",_rawBank:s.rawBank},r):t.callback({...o("advanced",s),type:"advanced",image:s.image,_page:s.page,_bank:s.bank,_rawBank:s.rawBank},r),this.#A=void 0}const r=await n;this.#D.set(e,{id:e,controlId:s.controlId,value:r}),this.#U(),s.referencedVariables=i.size>0?Array.from(i):null})).catch((e=>{console.error(`Feedback check failed: ${JSON.stringify(s)} - ${e?.message??e} ${e?.stack}`)})).finally((()=>{this.#A=void 0,this.#N.delete(e);let t=!1;if(s.referencedVariables)for(const e of s.referencedVariables)if(i.changedVariables.has(e)){t=!0;break}(t||i.needsRecheck)&&setImmediate((()=>{this.#P(e)}))}))}#U=(0,r.default)((()=>{const e=this.#D;this.#D=new Map,e.size>0&&this.#x({values:Array.from(e.values())})}),{wait:5,maxWait:25});setFeedbackDefinitions(e){const t=[];this.#O.clear();for(const[n,s]of Object.entries(e))s&&(t.push({id:n,name:s.name,description:s.description,options:(0,i.serializeIsVisibleFn)(s.options),type:s.type,defaultStyle:"defaultStyle"in s?s.defaultStyle:void 0,hasLearn:!!s.learn}),this.#O.set(n,s));this.#C({feedbacks:t})}checkFeedbacks(e){const t=new Set(e);for(const[e,n]of this.#R.entries())this.#O.get(n.feedbackId)&&(0===t.size||t.has(n.feedbackId))&&this.#P(e)}checkFeedbacksById(e){for(const t of e)this.#P(t)}_getAllFeedbacks(){return Array.from(this.#R.values()).map((e=>({id:e.id,feedbackId:e.feedbackId,controlId:e.controlId,options:e.options})))}subscribeFeedbacks(e){let t=Array.from(this.#R.values());const n=new Set(e);n.size&&(t=t.filter((e=>n.has(e.feedbackId))));for(const e of t){const t=this.#O.get(e.feedbackId);if(t?.subscribe){const n={parseVariablesInString:async t=>(await this.#S({text:t,controlId:e.controlId,actionInstanceId:void 0,feedbackInstanceId:e.id})).text};Promise.resolve(t.subscribe(o(t.type,e),n)).catch((t=>{this.#k("error",`Feedback subscribe failed: ${JSON.stringify(e)} - ${t?.message??t} ${t?.stack}`)}))}}}unsubscribeFeedbacks(e){let t=Array.from(this.#R.values());const n=new Set(e);n.size&&(t=t.filter((e=>n.has(e.feedbackId))));for(const e of t){const t=this.#O.get(e.feedbackId);if(t&&t.unsubscribe){const n={parseVariablesInString:async t=>(await this.#S({text:t,controlId:e.controlId,actionInstanceId:void 0,feedbackInstanceId:e.id})).text};Promise.resolve(t.unsubscribe(o(t.type,e),n)).catch((t=>{this.#k("error",`Feedback unsubscribe failed: ${JSON.stringify(e)} - ${t?.message??t} ${t?.stack}`)}))}}}}},1806:(e,t,n)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.runThroughUpgradeScripts=void 0;const s=n(2068);function i(e){return JSON.parse(JSON.stringify(e))}t.runThroughUpgradeScripts=function(e,t,n,r,o,a){const c=new Map,u=e=>{let t=c.get(e);return t||(t={actions:[],feedbacks:[],config:!1},c.set(e,t)),t};for(const t of Object.values(e)){const e=t?.upgradeIndex??n;t&&"number"==typeof e&&u(e).actions.push(t.id)}for(const e of Object.values(t)){const t=e?.upgradeIndex??n;e&&"number"==typeof t&&u(t).feedbacks.push(e.id)}if(!a)for(let e=n??-1;e<r.length;e++)u(e).config=!0;const l={},d={};let p;if(c.size>0){const a=Array.from(c.keys()).sort(),u=Math.min(...a,n??-1)+1,h=[],f=[],_=r.length;for(let n=u;n<_;n++){const a=c.get(n-1);a&&(h.push(...a.actions),f.push(...a.feedbacks));const u=!!a?.config;if(!u&&0===h.length&&0===f.length)continue;const _=p??o,g=(0,r[n])({currentConfig:i(_)},{config:u?_:null,actions:h.map((t=>{const n=e[t];if(n)return(0,s.literal)({id:n.id,controlId:n.controlId,actionId:n.actionId,options:void 0!==n.options?i(n.options):{}})})).filter((e=>!!e)),feedbacks:f.map((e=>{const n=t[e];if(n)return(0,s.literal)({id:n.id,controlId:n.controlId,feedbackId:n.feedbackId,options:void 0!==n.options?i(n.options):{}})})).filter((e=>!!e))});u&&g.updatedConfig&&(p=g.updatedConfig);for(const t of g.updatedActions)if(t){const n=e[t.id];n&&(n.actionId=t.actionId,n.options=t.options,d[t.id]=n)}for(const e of g.updatedFeedbacks)if(e){const n=t[e.id];n&&(n.feedbackId=e.feedbackId,n.options=e.options,l[e.id]={...n,style:l[e.id]?.style??e.style})}}for(const[t,n]of Object.entries(e))d[t]||"number"!=typeof n?.upgradeIndex||(d[t]=n);for(const[e,n]of Object.entries(t))l[e]||"number"!=typeof n?.upgradeIndex||(l[e]=n)}return{updatedActions:d,updatedFeedbacks:l,updatedConfig:p}}},7517:(e,t,n)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.validateManifest=void 0;const s=n(1460).__importDefault(n(4618));t.validateManifest=function(e){if(!(0,s.default)(e)){const e=s.default.errors;if(!e)throw new Error("Manifest failed validation with unknown reason");throw new Error(`Manifest validation failed: ${JSON.stringify(e)}`)}}},8322:(e,t)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0})},5203:(e,t,n)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.InstanceBase=void 0;const s=n(1460),i=n(2068),r=s.__importDefault(n(5860)),o=n(2557),a=n(1806),c=n(7550),u=n(8221),l=n(4391);t.InstanceBase=class{#$;#M;id;#j=new r.default({concurrency:1});#G=!1;#B=!1;#Y={};#F;#q;#L=new Map;#V=new Map;#n;#H;get instanceOptions(){return this.#n}get label(){return this.#H}constructor(e){if(!(0,o.isInstanceBaseProps)(e)||!e._isInstanceBaseProps)throw new Error("Module instance is being constructed incorrectly. Make sure you aren't trying to do this manually");this.#n={disableVariableValidation:!1},this.#$=new u.IpcWrapper({init:this._handleInit.bind(this),destroy:this._handleDestroy.bind(this),updateConfigAndLabel:this._handleConfigUpdateAndLabel.bind(this),updateConfig:async()=>{},executeAction:this._handleExecuteAction.bind(this),updateFeedbacks:this._handleUpdateFeedbacks.bind(this),updateActions:this._handleUpdateActions.bind(this),getConfigFields:this._handleGetConfigFields.bind(this),handleHttpRequest:this._handleHttpRequest.bind(this),learnAction:this._handleLearnAction.bind(this),learnFeedback:this._handleLearnFeedback.bind(this),startStopRecordActions:this._handleStartStopRecordActions.bind(this),variablesChanged:this._handleVariablesChanged.bind(this)},(e=>{process.send(e)}),5e3),process.on("message",(e=>{this.#$.receivedMessage(e)})),this.#F=new l.ActionManager((async e=>this.#$.sendWithCb("parseVariablesInString",e)),(e=>this.#$.sendWithNoCb("setActionDefinitions",e)),this.log.bind(this)),this.#q=new c.FeedbackManager((async e=>this.#$.sendWithCb("parseVariablesInString",e)),(e=>this.#$.sendWithNoCb("updateFeedbackValues",e)),(e=>this.#$.sendWithNoCb("setFeedbackDefinitions",e)),this.log.bind(this)),this.#M=e.upgradeScripts,this.id=e.id,this.#H=e.id,this.log("debug","Initializing")}async _handleInit(e){return this.#j.add((async()=>{if(this.#G)throw new Error("Already initialized");const t=e.actions,n=e.feedbacks;if(this.#Y=e.config,this.#H=e.label,e.isFirstInit){const t={},n=this.getConfigFields();for(const e of n)"default"in e&&(t[e.id]=e.default);this.#Y=t,this.saveConfig(this.#Y),e.lastUpgradeIndex=this.#M.length-1}const{updatedActions:s,updatedFeedbacks:i,updatedConfig:r}=(0,a.runThroughUpgradeScripts)(t,n,e.lastUpgradeIndex,this.#M,this.#Y,!1);this.#Y=r??this.#Y;const o=this.#$.sendWithCb("upgradedItems",{updatedActions:s,updatedFeedbacks:i});try{await this.init(this.#Y,!!e.isFirstInit),this.#G=!0}catch(e){throw console.trace(`Init failed: ${e}`),e}finally{await o}return setImmediate((()=>{this._handleUpdateActions({actions:t},!0).catch((e=>{this.log("error",`Receive actions failed: ${e}`)})),this._handleUpdateFeedbacks({feedbacks:n},!0).catch((e=>{this.log("error",`Receive feedbacks failed: ${e}`)}))})),{hasHttpHandler:"function"==typeof this.handleHttpRequest,hasRecordActionsHandler:"function"==typeof this.handleStartStopRecordActions,newUpgradeIndex:this.#M.length-1,updatedConfig:this.#Y}}))}async _handleDestroy(){await this.#j.add((async()=>{if(!this.#G)throw new Error("Not initialized");await this.destroy(),this.#G=!1}))}async _handleConfigUpdateAndLabel(e){await this.#j.add((async()=>{if(!this.#G)throw new Error("Not initialized");this.#H=e.label,this.#Y=e.config,await this.configUpdated(this.#Y)}))}async _handleExecuteAction(e){return this.#F.handleExecuteAction(e)}async _handleUpdateFeedbacks(e,t){if(!t){const t=(0,a.runThroughUpgradeScripts)({},e.feedbacks,null,this.#M,this.#Y,!0);this.#$.sendWithCb("upgradedItems",{updatedActions:t.updatedActions,updatedFeedbacks:t.updatedFeedbacks}).catch((e=>{this.log("error",`Failed to save upgraded feedbacks: ${e}`)}))}this.#q.handleUpdateFeedbacks(e.feedbacks)}async _handleUpdateActions(e,t){if(!t){const t=(0,a.runThroughUpgradeScripts)(e.actions,{},null,this.#M,this.#Y,!0);this.#$.sendWithCb("upgradedItems",{updatedActions:t.updatedActions,updatedFeedbacks:t.updatedFeedbacks}).catch((e=>{this.log("error",`Failed to save upgraded actions: ${e}`)}))}this.#F.handleUpdateActions(e.actions)}async _handleGetConfigFields(e){return{fields:(0,o.serializeIsVisibleFn)(this.getConfigFields())}}async _handleHttpRequest(e){if(!this.handleHttpRequest)throw new Error("handleHttpRequest is not supported!");return{response:await this.handleHttpRequest(e.request)}}async _handleLearnAction(e){return this.#F.handleLearnAction(e)}async _handleLearnFeedback(e){return this.#q.handleLearnFeedback(e)}async _handleStartStopRecordActions(e){if(e.recording){if(this.#B)return}else if(!this.#B)return;if(!this.handleStartStopRecordActions)throw this.#B=!1,new Error("Recording actions is not supported by this module!");this.#B=e.recording,this.handleStartStopRecordActions(this.#B)}async _handleVariablesChanged(e){this.#q.handleVariablesChanged(e)}saveConfig(e){this.#Y=e,this.#$.sendWithNoCb("saveConfig",{config:e})}setActionDefinitions(e){this.#F.setActionDefinitions(e)}setFeedbackDefinitions(e){this.#q.setFeedbackDefinitions(e)}setPresetDefinitions(e){const t=[];for(const[n,s]of Object.entries(e))s&&t.push({...s,id:n});this.#$.sendWithNoCb("setPresetDefinitions",{presets:t})}setVariableDefinitions(e){const t=[];this.#L.clear();for(const n of e)t.push({id:n.variableId,name:n.name}),this.#L.set(n.variableId,n),this.#V.has(n.variableId)||this.#V.set(n.variableId,"");if(!this.#n.disableVariableValidation){const e=new Set(this.#L.keys());for(const t of this.#V.keys())e.has(t)||this.#V.delete(t)}this.#$.sendWithNoCb("setVariableDefinitions",{variables:t})}setVariableValues(e){const t=[];for(const[n,s]of Object.entries(e))this.#n.disableVariableValidation?(void 0===s?this.#V.delete(n):this.#V.set(n,s),t.push({id:n,value:s})):this.#L.has(n)?(this.#V.set(n,s??""),t.push({id:n,value:s??""})):t.push({id:n,value:void 0});this.#$.sendWithNoCb("setVariableValues",{newValues:t})}getVariableValue(e){return this.#V.get(e)}async parseVariablesInString(e){const t=this.#q.parseVariablesContext;return t&&this.log("debug",`parseVariablesInString called while in: ${t}. You should use the parseVariablesInString provided to the callback instead`),(await this.#$.sendWithCb("parseVariablesInString",{text:e,controlId:void 0,actionInstanceId:void 0,feedbackInstanceId:void 0})).text}checkFeedbacks(...e){this.#q.checkFeedbacks(e)}checkFeedbacksById(...e){this.#q.checkFeedbacksById(e)}_getAllActions(){return this.#F._getAllActions()}subscribeActions(...e){this.#F.subscribeActions(e)}unsubscribeActions(...e){this.#F.unsubscribeActions(e)}_getAllFeedbacks(){return this.#q._getAllFeedbacks()}subscribeFeedbacks(...e){this.#q.subscribeFeedbacks(e)}unsubscribeFeedbacks(...e){this.#q.unsubscribeFeedbacks(e)}recordAction(e,t){if(!this.#B)throw new Error("Not currently recording actions");this.#$.sendWithNoCb("recordAction",{uniquenessId:t??null,actionId:e.actionId,options:e.options})}setCustomVariableValue(e,t){this.#$.sendWithNoCb("setCustomVariable",{customVariableId:e,value:t})}oscSend(e,t,n,s){this.#$.sendWithNoCb("send-osc",(0,i.literal)({host:e,port:t,path:n,args:s}))}updateStatus(e,t){this.#$.sendWithNoCb("set-status",(0,i.literal)({status:e,message:t??null}))}log(e,t){this.#$.sendWithNoCb("log-message",(0,i.literal)({level:e,message:t}))}}},9051:(e,t)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0})},609:(e,t)=>{"use strict";var n,s;Object.defineProperty(t,"__esModule",{value:!0}),t.Regex=t.InstanceStatus=void 0,(s=t.InstanceStatus||(t.InstanceStatus={})).Ok="ok",s.Connecting="connecting",s.Disconnected="disconnected",s.ConnectionFailure="connection_failure",s.BadConfig="bad_config",s.UnknownError="unknown_error",s.UnknownWarning="unknown_warning",(n=t.Regex||(t.Regex={})).IP="/^(?:(?:25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)\\.){3}(?:25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)$/",n.HOSTNAME="/^(([a-zA-Z0-9]|[a-zA-Z0-9][a-zA-Z0-9-]*[a-zA-Z0-9])\\.)*([A-Za-z0-9]|[A-Za-z0-9][A-Za-z0-9-]*[A-Za-z0-9])$/",n.BOOLEAN="/^(true|false|0|1)$/i",n.PORT="/^([1-9]|[1-8][0-9]|9[0-9]|[1-8][0-9]{2}|9[0-8][0-9]|99[0-9]|[1-8][0-9]{3}|9[0-8][0-9]{2}|99[0-8][0-9]|999[0-9]|[1-5][0-9]{4}|6[0-4][0-9]{3}|65[0-4][0-9]{2}|655[0-2][0-9]|6553[0-4])$/",n.PERCENT="/^(100|[0-9]|[0-9][0-9])$/",n.FLOAT="/^([0-9]*\\.)?[0-9]+$/",n.SIGNED_FLOAT="/^[+-]?([0-9]*\\.)?[0-9]+$/",n.FLOAT_OR_INT="/^([0-9]+)(\\.[0-9]+)?$/",n.NUMBER="/^\\d+$/",n.SIGNED_NUMBER="/^[+-]?\\d+$/",n.SOMETHING="/^.+$/",n.TIMECODE="/^(0*[0-9]|1[0-9]|2[0-4]):(0*[0-9]|[1-5][0-9]|60):(0*[0-9]|[1-5][0-9]|60):(0*[0-9]|[12][0-9]|30)$/"},4334:(e,t)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0})},2490:(e,t)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0})},4911:(e,t,n)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0});const s=n(1460);s.__exportStar(n(8322),t),s.__exportStar(n(5203),t),s.__exportStar(n(9051),t),s.__exportStar(n(609),t),s.__exportStar(n(4334),t),s.__exportStar(n(2490),t),s.__exportStar(n(3646),t),s.__exportStar(n(3558),t),s.__exportStar(n(4788),t),s.__exportStar(n(521),t),s.__exportStar(n(6870),t)},3646:(e,t)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0})},3558:(e,t)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0})},4788:(e,t)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0})},521:(e,t)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CreateConvertToBooleanFeedbackUpgradeScript=t.EmptyUpgradeScript=void 0,t.EmptyUpgradeScript=()=>({updatedConfig:null,updatedActions:[],updatedFeedbacks:[]}),t.CreateConvertToBooleanFeedbackUpgradeScript=function(e){return(t,n)=>{const s=[];for(const t of n.feedbacks){let n=e[t.feedbackId];if(!0===n&&(n={bg:"bgcolor",bgcolor:"bgcolor",fg:"color",color:"color",png64:"png64",png:"png64"}),n){t.style||(t.style={});for(const[e,i]of Object.entries(n))void 0!==t.options[e]&&(t.style[i]=t.options[e],delete t.options[e],s.push(t))}}return{updatedConfig:null,updatedActions:[],updatedFeedbacks:s}}}},6870:(e,t)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0})},2068:(e,t)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.splitRgb=t.combineRgb=t.assertNever=t.literal=void 0,t.literal=function(e){return e},t.assertNever=function(e){},t.combineRgb=function(e,t,n){return(255&e)<<16|(255&t)<<8|255&n},t.splitRgb=function(e){return{r:(16711680&e)>>16,g:(65280&e)>>8,b:255&e}}},4618:(e,t,n)=>{"use strict";e.exports=r,e.exports.default=r;const s={$schema:"http://json-schema.org/draft-07/schema#",type:"object",title:"ModuleManifest",properties:{id:{type:"string",description:"Unique identifier for the module"},name:{type:"string",description:"Name of the module"},shortname:{type:"string"},description:{type:"string",description:"Description of the module "},version:{type:"string",description:"Current version of the module"},license:{type:"string",description:"SPDX identifier for license of the module"},repository:{type:"string",description:"URL to the source repository"},bugs:{type:"string",description:"URL to bug tracker"},maintainers:{type:"array",description:"List of active maintiners",uniqueItems:!0,items:{type:"object",title:"ModuleManifestMaintainer",properties:{name:{type:"string"},email:{type:"string"},github:{type:"string"}},required:["name"]}},legacyIds:{type:"array",description:"If the module had a different unique identifier previously, then specify it here",uniqueItems:!0,items:{type:"string"}},runtime:{type:"object",title:"ModuleManifestRuntime",description:"Information on how to execute the module",properties:{type:{type:"string",description:"Type of the module. Must be: node18"},api:{type:"string",description:"Which host-api does it use. In the future alternate options will be allowed",enum:["nodejs-ipc"]},apiVersion:{type:"string",description:"The version of the host-api used"},entrypoint:{type:"string",description:"Entrypoint to pass to the runtime. eg index.js"}},required:["type","api","apiVersion","entrypoint"]},manufacturer:{type:"string"},products:{type:"array",uniqueItems:!0,items:{type:"string"}},keywords:{type:"array",uniqueItems:!0,items:{type:"string"}}},required:["id","name","shortname","description","version","license","repository","bugs","maintainers","legacyIds","runtime","manufacturer","products","keywords"]},i=n(7056).Z;function r(e,{instancePath:t="",parentData:n,parentDataProperty:o,rootData:a=e}={}){if(!e||"object"!=typeof e||Array.isArray(e))return r.errors=[{instancePath:t,schemaPath:"#/type",keyword:"type",params:{type:"object"},message:"must be object"}],!1;{let n;if(void 0===e.id&&(n="id")||void 0===e.name&&(n="name")||void 0===e.shortname&&(n="shortname")||void 0===e.description&&(n="description")||void 0===e.version&&(n="version")||void 0===e.license&&(n="license")||void 0===e.repository&&(n="repository")||void 0===e.bugs&&(n="bugs")||void 0===e.maintainers&&(n="maintainers")||void 0===e.legacyIds&&(n="legacyIds")||void 0===e.runtime&&(n="runtime")||void 0===e.manufacturer&&(n="manufacturer")||void 0===e.products&&(n="products")||void 0===e.keywords&&(n="keywords"))return r.errors=[{instancePath:t,schemaPath:"#/required",keyword:"required",params:{missingProperty:n},message:"must have required property '"+n+"'"}],!1;if(void 0!==e.id){const n=0;if("string"!=typeof e.id)return r.errors=[{instancePath:t+"/id",schemaPath:"#/properties/id/type",keyword:"type",params:{type:"string"},message:"must be string"}],!1;var c=0===n}else c=!0;if(c){if(void 0!==e.name){const n=0;if("string"!=typeof e.name)return r.errors=[{instancePath:t+"/name",schemaPath:"#/properties/name/type",keyword:"type",params:{type:"string"},message:"must be string"}],!1;c=0===n}else c=!0;if(c){if(void 0!==e.shortname){const n=0;if("string"!=typeof e.shortname)return r.errors=[{instancePath:t+"/shortname",schemaPath:"#/properties/shortname/type",keyword:"type",params:{type:"string"},message:"must be string"}],!1;c=0===n}else c=!0;if(c){if(void 0!==e.description){const n=0;if("string"!=typeof e.description)return r.errors=[{instancePath:t+"/description",schemaPath:"#/properties/description/type",keyword:"type",params:{type:"string"},message:"must be string"}],!1;c=0===n}else c=!0;if(c){if(void 0!==e.version){const n=0;if("string"!=typeof e.version)return r.errors=[{instancePath:t+"/version",schemaPath:"#/properties/version/type",keyword:"type",params:{type:"string"},message:"must be string"}],!1;c=0===n}else c=!0;if(c){if(void 0!==e.license){const n=0;if("string"!=typeof e.license)return r.errors=[{instancePath:t+"/license",schemaPath:"#/properties/license/type",keyword:"type",params:{type:"string"},message:"must be string"}],!1;c=0===n}else c=!0;if(c){if(void 0!==e.repository){const n=0;if("string"!=typeof e.repository)return r.errors=[{instancePath:t+"/repository",schemaPath:"#/properties/repository/type",keyword:"type",params:{type:"string"},message:"must be string"}],!1;c=0===n}else c=!0;if(c){if(void 0!==e.bugs){const n=0;if("string"!=typeof e.bugs)return r.errors=[{instancePath:t+"/bugs",schemaPath:"#/properties/bugs/type",keyword:"type",params:{type:"string"},message:"must be string"}],!1;c=0===n}else c=!0;if(c){if(void 0!==e.maintainers){let n=e.maintainers;const s=0;if(0===s){if(!Array.isArray(n))return r.errors=[{instancePath:t+"/maintainers",schemaPath:"#/properties/maintainers/type",keyword:"type",params:{type:"array"},message:"must be array"}],!1;{var u=!0;const e=n.length;for(let s=0;s<e;s++){let e=n[s];const i=0;if(0===i){if(!e||"object"!=typeof e||Array.isArray(e))return r.errors=[{instancePath:t+"/maintainers/"+s,schemaPath:"#/properties/maintainers/items/type",keyword:"type",params:{type:"object"},message:"must be object"}],!1;{let n;if(void 0===e.name&&(n="name"))return r.errors=[{instancePath:t+"/maintainers/"+s,schemaPath:"#/properties/maintainers/items/required",keyword:"required",params:{missingProperty:n},message:"must have required property '"+n+"'"}],!1;if(void 0!==e.name){const n=0;if("string"!=typeof e.name)return r.errors=[{instancePath:t+"/maintainers/"+s+"/name",schemaPath:"#/properties/maintainers/items/properties/name/type",keyword:"type",params:{type:"string"},message:"must be string"}],!1;var l=0===n}else l=!0;if(l){if(void 0!==e.email){const n=0;if("string"!=typeof e.email)return r.errors=[{instancePath:t+"/maintainers/"+s+"/email",schemaPath:"#/properties/maintainers/items/properties/email/type",keyword:"type",params:{type:"string"},message:"must be string"}],!1;l=0===n}else l=!0;if(l)if(void 0!==e.github){const n=0;if("string"!=typeof e.github)return r.errors=[{instancePath:t+"/maintainers/"+s+"/github",schemaPath:"#/properties/maintainers/items/properties/github/type",keyword:"type",params:{type:"string"},message:"must be string"}],!1;l=0===n}else l=!0}}}if(!(u=0===i))break}if(u){let e,s=n.length;if(s>1)for(;s--;)for(e=s;e--;)if(i(n[s],n[e]))return r.errors=[{instancePath:t+"/maintainers",schemaPath:"#/properties/maintainers/uniqueItems",keyword:"uniqueItems",params:{i:s,j:e},message:"must NOT have duplicate items (items ## "+e+" and "+s+" are identical)"}],!1}}}c=0===s}else c=!0;if(c){if(void 0!==e.legacyIds){let n=e.legacyIds;const s=0;if(0===s){if(!Array.isArray(n))return r.errors=[{instancePath:t+"/legacyIds",schemaPath:"#/properties/legacyIds/type",keyword:"type",params:{type:"array"},message:"must be array"}],!1;{var d=!0;const e=n.length;for(let s=0;s<e;s++){const e=0;if("string"!=typeof n[s])return r.errors=[{instancePath:t+"/legacyIds/"+s,schemaPath:"#/properties/legacyIds/items/type",keyword:"type",params:{type:"string"},message:"must be string"}],!1;if(!(d=0===e))break}if(d){let e,s=n.length;if(s>1){const i={};for(;s--;){let o=n[s];if("string"==typeof o){if("number"==typeof i[o])return e=i[o],r.errors=[{instancePath:t+"/legacyIds",schemaPath:"#/properties/legacyIds/uniqueItems",keyword:"uniqueItems",params:{i:s,j:e},message:"must NOT have duplicate items (items ## "+e+" and "+s+" are identical)"}],!1;i[o]=s}}}}}}c=0===s}else c=!0;if(c){if(void 0!==e.runtime){let n=e.runtime;const i=0;if(0===i){if(!n||"object"!=typeof n||Array.isArray(n))return r.errors=[{instancePath:t+"/runtime",schemaPath:"#/properties/runtime/type",keyword:"type",params:{type:"object"},message:"must be object"}],!1;{let e;if(void 0===n.type&&(e="type")||void 0===n.api&&(e="api")||void 0===n.apiVersion&&(e="apiVersion")||void 0===n.entrypoint&&(e="entrypoint"))return r.errors=[{instancePath:t+"/runtime",schemaPath:"#/properties/runtime/required",keyword:"required",params:{missingProperty:e},message:"must have required property '"+e+"'"}],!1;if(void 0!==n.type){const e=0;if("string"!=typeof n.type)return r.errors=[{instancePath:t+"/runtime/type",schemaPath:"#/properties/runtime/properties/type/type",keyword:"type",params:{type:"string"},message:"must be string"}],!1;var p=0===e}else p=!0;if(p){if(void 0!==n.api){let e=n.api;const i=0;if("string"!=typeof e)return r.errors=[{instancePath:t+"/runtime/api",schemaPath:"#/properties/runtime/properties/api/type",keyword:"type",params:{type:"string"},message:"must be string"}],!1;if("nodejs-ipc"!==e)return r.errors=[{instancePath:t+"/runtime/api",schemaPath:"#/properties/runtime/properties/api/enum",keyword:"enum",params:{allowedValues:s.properties.runtime.properties.api.enum},message:"must be equal to one of the allowed values"}],!1;p=0===i}else p=!0;if(p){if(void 0!==n.apiVersion){const e=0;if("string"!=typeof n.apiVersion)return r.errors=[{instancePath:t+"/runtime/apiVersion",schemaPath:"#/properties/runtime/properties/apiVersion/type",keyword:"type",params:{type:"string"},message:"must be string"}],!1;p=0===e}else p=!0;if(p)if(void 0!==n.entrypoint){const e=0;if("string"!=typeof n.entrypoint)return r.errors=[{instancePath:t+"/runtime/entrypoint",schemaPath:"#/properties/runtime/properties/entrypoint/type",keyword:"type",params:{type:"string"},message:"must be string"}],!1;p=0===e}else p=!0}}}}c=0===i}else c=!0;if(c){if(void 0!==e.manufacturer){const n=0;if("string"!=typeof e.manufacturer)return r.errors=[{instancePath:t+"/manufacturer",schemaPath:"#/properties/manufacturer/type",keyword:"type",params:{type:"string"},message:"must be string"}],!1;c=0===n}else c=!0;if(c){if(void 0!==e.products){let n=e.products;const s=0;if(0===s){if(!Array.isArray(n))return r.errors=[{instancePath:t+"/products",schemaPath:"#/properties/products/type",keyword:"type",params:{type:"array"},message:"must be array"}],!1;{var h=!0;const e=n.length;for(let s=0;s<e;s++){const e=0;if("string"!=typeof n[s])return r.errors=[{instancePath:t+"/products/"+s,schemaPath:"#/properties/products/items/type",keyword:"type",params:{type:"string"},message:"must be string"}],!1;if(!(h=0===e))break}if(h){let e,s=n.length;if(s>1){const i={};for(;s--;){let o=n[s];if("string"==typeof o){if("number"==typeof i[o])return e=i[o],r.errors=[{instancePath:t+"/products",schemaPath:"#/properties/products/uniqueItems",keyword:"uniqueItems",params:{i:s,j:e},message:"must NOT have duplicate items (items ## "+e+" and "+s+" are identical)"}],!1;i[o]=s}}}}}}c=0===s}else c=!0;if(c)if(void 0!==e.keywords){let n=e.keywords;const s=0;if(0===s){if(!Array.isArray(n))return r.errors=[{instancePath:t+"/keywords",schemaPath:"#/properties/keywords/type",keyword:"type",params:{type:"array"},message:"must be array"}],!1;{var f=!0;const e=n.length;for(let s=0;s<e;s++){const e=0;if("string"!=typeof n[s])return r.errors=[{instancePath:t+"/keywords/"+s,schemaPath:"#/properties/keywords/items/type",keyword:"type",params:{type:"string"},message:"must be string"}],!1;if(!(f=0===e))break}if(f){let e,s=n.length;if(s>1){const i={};for(;s--;){let o=n[s];if("string"==typeof o){if("number"==typeof i[o])return e=i[o],r.errors=[{instancePath:t+"/keywords",schemaPath:"#/properties/keywords/uniqueItems",keyword:"uniqueItems",params:{i:s,j:e},message:"must NOT have duplicate items (items ## "+e+" and "+s+" are identical)"}],!1;i[o]=s}}}}}}c=0===s}else c=!0}}}}}}}}}}}}}return r.errors=null,!0}},4300:(e,t,n)=>{let s,i,r=n(6113),{urlAlphabet:o}=n(3792),a=e=>{!s||s.length<e?(s=Buffer.allocUnsafe(128*e),r.randomFillSync(s),i=0):i+e>s.length&&(r.randomFillSync(s),i=0),i+=e},c=e=>(a(e-=0),s.subarray(i-e,i)),u=(e,t,n)=>{let s=(2<<31-Math.clz32(e.length-1|1))-1,i=Math.ceil(1.6*s*t/e.length);return(r=t)=>{let o="";for(;;){let t=n(i),a=i;for(;a--;)if(o+=e[t[a]&s]||"",o.length===r)return o}}};e.exports={nanoid:(e=21)=>{a(e-=0);let t="";for(let n=i-e;n<i;n++)t+=o[63&s[n]];return t},customAlphabet:(e,t=21)=>u(e,t,c),customRandom:u,urlAlphabet:o,random:c}},3792:e=>{e.exports={urlAlphabet:"useandom-26T198340PX75pxJACKVERYMINDBUSHWOLF_GQZbfghjklqvwyzrict"}}},t={};function n(s){var i=t[s];if(void 0!==i)return i.exports;var r=t[s]={id:s,loaded:!1,exports:{}};return e[s].call(r.exports,r,r.exports,n),r.loaded=!0,r.exports}n.c=t,n.n=e=>{var t=e&&e.__esModule?()=>e.default:()=>e;return n.d(t,{a:t}),t},n.d=(e,t)=>{for(var s in t)n.o(t,s)&&!n.o(e,s)&&Object.defineProperty(e,s,{enumerable:!0,get:t[s]})},n.hmd=e=>((e=Object.create(e)).children||(e.children=[]),Object.defineProperty(e,"exports",{enumerable:!0,set:()=>{throw new Error("ES Modules may not assign module.exports or exports.*, Use ESM export syntax, instead: "+e.id)}}),e),n.o=(e,t)=>Object.prototype.hasOwnProperty.call(e,t),n.r=e=>{"undefined"!=typeof Symbol&&Symbol.toStringTag&&Object.defineProperty(e,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(e,"__esModule",{value:!0})},n(n.s=6010)})();